//PropertyDlg.cpp, Copyright (c) 2001, 2002, 2003, 2004 R.Lackner
//Property dialogs for graphic objects
//
//    This file is part of RLPlot.
//
//    RLPlot is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    RLPlot is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with RLPlot; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
#include "rlplot.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "TheDialog.h"

extern tag_Units Units[];
extern char TmpTxt[];
extern TextDEF DlgText;
extern Default defs;
extern int dlgtxtheight;
extern Axis **CurrAxes;
extern UndoObj Undo;
extern int AxisTempl3D;

int ODtickstyle;

//prototypes: WinSpec.cpp
void *CreateDlgWnd(char *title, int x, int y, int width, int height, tag_DlgObj *d, DWORD flags);

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Symbol properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Symbol::PropertyDlg()
{
	TabSHEET tab1 = {0, 45, 10, "Size & Color"};
	TabSHEET tab2 = {110, 130, 10, "Edit"};
	TabSHEET tab3 = {68, 110, 10, "Text Prop."};
	TabSHEET tab4 = {45, 68, 10, "Text"};
	Symbol *PrevSym = 0L;
	char text1[40], text2[100];
	DlgInfo SymDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to SYMBOL", 145, 10, 60, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 145, 25, 60, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 145, 40, 60, 12},
		{4, 500, 5, CHECKED | ISPARENT, GROUP, NULL, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 130, 70},
		{6, 7, 300, ISPARENT, SHEET, &tab2, 5, 10, 130, 70},
		{7, 8, 200, TOUCHEXIT | ISPARENT, SHEET, &tab3, 5, 10, 130, 70},
		{8, 401, 250, TOUCHEXIT | ISPARENT, SHEET, &tab4, 5, 10, 130, 70},
		{100, 101, 0, 0x0L, RTEXT, (void*)"size", 5, 25, 45, 8},
		{101, 102, 0, TOUCHEXIT, INCDECVAL1, &size, 55, 25, 32, 10},
		{102, 103, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 89, 25, 20, 8},
		{103, 104, 0, 0x0L, RTEXT, (void*)"line width", 5, 37, 45, 8},
		{104, 105, 0, TOUCHEXIT, INCDECVAL1, &SymLine.width, 55, 37, 32, 10},
		{105, 106, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 89, 37, 20, 8},
		{106, 107, 0, 0x0L, RTEXT, (void*)"line color", 5, 49, 45, 8},
		{107, 108, 0, TOUCHEXIT | OWNDIALOG, COLBUTTON, (void *)SymLine.color, 55, 49, 25, 10},
		{108, 109, 0, 0x0L, RTEXT, (void*)"fill color" , 5, 61, 45, 8},
		{109, 0, 0, TOUCHEXIT | OWNDIALOG, COLBUTTON, (void *)SymFill.color, 55, 61, 25, 10},
		{200, 204, 201, CHECKED | ISPARENT, GROUPBOX, (void*)" font ", 12, 28, 50, 45},
		{201, 202, 0, TOUCHEXIT, RADIO1, (void*)"Helvetica", 15, 35, 45, 8},
		{202, 203, 0, TOUCHEXIT, RADIO1, (void*)"Times", 15, 45, 45, 8},
		{203, 0, 0, TOUCHEXIT, RADIO1, (void*)"Courier", 15, 55, 45, 8},
		{204, 0, 205, CHECKED | ISPARENT, GROUPBOX, (void*)" style ", 72, 28, 57, 45},
		{205, 206, 0, TOUCHEXIT, CHECKBOX, (void*)"bold", 75, 35, 25, 8},
		{206, 207, 0, TOUCHEXIT, CHECKBOX, (void*)"italic", 75, 45, 25, 8},
		{207, 0, 0, TOUCHEXIT, CHECKBOX, (void*)"underlined", 75, 55, 25, 8},
		{250, 251, 0, TOUCHEXIT | CHECKED, RADIO1, (void*)"fixed text:", 10, 30, 45, 8},
		{251, 252, 0, 0x0L, EDTEXT, text1, 60, 30, 45, 10},
		{252, 253, 0, TOUCHEXIT, RADIO1, (void*)"from spreadsheet range:", 10, 45, 60, 8},
		{253, 0, 0, 0x0L, EDTEXT, text2, 20, 55, 100, 10},
		{300, 301, 0, 0x0L, RTEXT, (void*)"x-value", 5, 30, 45, 8},
		{301, 302, 0, 0x0L, EDVAL1, &fPos.fx, 55, 30, 45, 10},
		{302, 303, 0, 0x0L, RTEXT, (void*)"y-value", 5, 50, 45, 8},
		{303, 0, 0, 0x0L, EDVAL1, &fPos.fy, 55, 50, 45, 10},
		{401, 402, 0, TOUCHEXIT, SYMRADIO, (void*)0, 15, 85, 10, 10},
		{402, 403, 0, TOUCHEXIT, SYMRADIO, (void*)1, 25, 85, 10, 10}, 
		{403, 404, 0, TOUCHEXIT, SYMRADIO, (void*)2, 35, 85, 10, 10}, 
		{404, 405, 0, TOUCHEXIT, SYMRADIO, (void*)3, 45, 85, 10, 10}, 
		{405, 406, 0, TOUCHEXIT, SYMRADIO, (void*)4, 55, 85, 10, 10}, 
		{406, 407, 0, TOUCHEXIT, SYMRADIO, (void*)5, 65, 85, 10, 10}, 
		{407, 408, 0, TOUCHEXIT, SYMRADIO, (void*)6, 75, 85, 10, 10}, 
		{408, 409, 0, TOUCHEXIT, SYMRADIO, (void*)7, 85, 85, 10, 10}, 
		{409, 410, 0, TOUCHEXIT, SYMRADIO, (void*)8, 95, 85, 10, 10}, 
		{410, 411, 0, TOUCHEXIT, SYMRADIO, (void*)9, 105, 85, 10, 10}, 
		{411, 412, 0, TOUCHEXIT, SYMRADIO, (void*)10, 115, 85, 10, 10}, 
		{412, 413, 0, TOUCHEXIT, SYMRADIO, (void*)11, 15, 95, 10, 10}, 
		{413, 414, 0, TOUCHEXIT, SYMRADIO, (void*)12, 25, 95, 10, 10}, 
		{414, 415, 0, TOUCHEXIT, SYMRADIO, (void*)13, 35, 95, 10, 10}, 
		{415, 416, 0, TOUCHEXIT, SYMRADIO, (void*)14, 45, 95, 10, 10}, 
		{416, 0, 0, TOUCHEXIT, SYMRADIO, (void*)SYM_TEXT, 55, 95, 40, 10}, 
		{500, 0, 0, LASTOBJ | TOUCHEXIT, SYMBUTT, (void*)&PrevSym, 155, 65, 40, 40}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmpType, width, height;
	DWORD tmpCol, undo_flags = 0L;
	double tmpVal, o_size, n_size, o_lwidth, n_lwidth;
	TextDEF textdef;
	lfPOINT o_pos, n_pos;

	if(!parent) return false;
	if(!Command(CMD_GETTEXT, (void*)text1, 0L)) sprintf(text1, "text");
	if(data && data->GetSize(&width, &height)) sprintf(text2, "b1:b%d", height);
	else sprintf(text2, "(not available)");
	if((PrevSym = new Symbol(0L, data, 0.0f, 0.0f, type))){
		PrevSym->SetColor(COL_SYM_LINE, SymLine.color);
		PrevSym->SetColor(COL_SYM_FILL, SymFill.color);
		PrevSym->SetSize(SIZE_SYMBOL, size);
		PrevSym->SetSize(SIZE_SYM_LINE, SymLine.width);
		PrevSym->Command(CMD_SETTEXT, (void*)text1, 0L);
		PrevSym->Command(CMD_GETTEXTDEF, &textdef, 0L);
		PrevSym->Command(CMD_SET_DATAOBJ, (void*)data, 0L);
		if(Command(CMD_GETTEXTDEF, &textdef, 0L))
			PrevSym->Command(CMD_SETTEXTDEF, &textdef, 0L);
		PrevSym->idx = idx;
		}
	if(PrevSym && (Dlg = new DlgRoot(SymDlg))) {
		Dlg->TextFont(201, FONT_HELVETICA);
		Dlg->TextFont(202, FONT_TIMES);
		Dlg->TextFont(203, FONT_COURIER);
		Dlg->TextStyle(205, TXS_BOLD);
		Dlg->TextStyle(206, TXS_ITALIC);
		Dlg->TextStyle(207, TXS_UNDERLINE);
		if(type == SYM_TEXT) Dlg->SetCheck(416, 0L, true);
		else Dlg->SetCheck(401+type, 0L, true);
		switch(textdef.Font) {
		case FONT_TIMES:	Dlg->SetCheck(202, 0L, true);	break;
		case FONT_COURIER:	Dlg->SetCheck(203, 0L, true);	break;
		default:			Dlg->SetCheck(201, 0L, true);	break;
			}
		if(textdef.Style & TXS_BOLD) Dlg->SetCheck(205, 0L, true);
		if(textdef.Style & TXS_ITALIC) Dlg->SetCheck(206, 0L, true);
		if(textdef.Style & TXS_UNDERLINE) Dlg->SetCheck(207, 0L, true);
		}
	else return false;
	if(parent->name) sprintf(TmpTxt, "Symbol of %s", parent->name);
	else strcpy(TmpTxt, "Symbol properties");
	if(!(hDlg = CreateDlgWnd(TmpTxt, 50, 50, 430, 260, Dlg, 0x0L)))return false;
	tmpCol = 0x00c0c0c0L;	o_size = size;	o_lwidth = SymLine.width;
	Dlg->GetValue(101, &o_size);		Dlg->GetValue(104, &o_lwidth);
	n_size = o_size;					n_lwidth = o_lwidth;
	o_pos.fx = fPos.fx;					o_pos.fy = fPos.fy;
	if(Dlg->GetValue(301, &tmpVal)) o_pos.fx = tmpVal;	n_pos.fx = o_pos.fx;
	if(Dlg->GetValue(303, &tmpVal)) o_pos.fy = tmpVal;	n_pos.fy = o_pos.fy;
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 2:
		case 1:
			if(PrevSym->type == SYM_TEXT && Dlg->GetCheck(250)){
				Dlg->GetText(251, text1);
				if(PrevSym->Command(CMD_GETTEXT, (void *)text2, 0L) && strcmp(text1, text2)) {
					PrevSym->Command(CMD_SETTEXT, (void *)text1, 0L);
					Dlg->DoPlot(NULL);
					res = -1;
					}
				}
			else if(PrevSym->type == SYM_TEXT && Dlg->GetCheck(252)) {
				if(Dlg->GetCheck(252) && Dlg->GetText(253, text2))	
					PrevSym->Command(CMD_RANGETEXT, &text2, 0L);
				}
			Dlg->GetValue(101, &n_size);		Dlg->GetValue(104, &n_lwidth);
			break;
		case 7:											//the text sheets
		case 8:
			Dlg->SetCheck(416, 0L, true);
			if(PrevSym->type != SYM_TEXT) {
				PrevSym->type = SYM_TEXT;
				Dlg->DoPlot(NULL);
				}
			res = -1;
			break;
		case 201:	case 202:	case 203:				//fonts and styles
		case 205:	case 206:	case 207:
			if(PrevSym->Command(CMD_GETTEXTDEF, &textdef, 0L)) {
				if(Dlg->GetCheck(202)) textdef.Font = FONT_TIMES;
				else if(Dlg->GetCheck(203)) textdef.Font = FONT_COURIER;
				else textdef.Font = FONT_HELVETICA;
				textdef.Style = TXS_NORMAL;
				if(Dlg->GetCheck(205)) textdef.Style |= TXS_BOLD;
				if(Dlg->GetCheck(206)) textdef.Style |= TXS_ITALIC;
				if(Dlg->GetCheck(207)) textdef.Style |= TXS_UNDERLINE;
				PrevSym->Command(CMD_SETTEXTDEF, &textdef, 0L);
				Dlg->DoPlot(NULL);
				}
			res = -1;
			break;
		case 252:										//use spreadsheet text
			if(!data) Dlg->SetCheck(250, 0L, true);
		case 250:										//use fixed text
			if(Dlg->GetCheck(250) && Dlg->GetText(251,text1))PrevSym->Command(CMD_SETTEXT, text1, 0L);
			else if(Dlg->GetCheck(252) && Dlg->GetText(253, text2))	
				PrevSym->Command(CMD_RANGETEXT, text2, 0L);
			Dlg->DoPlot(NULL);
			res = -1;
			break;
		case 401:	case 402:	case 403:	case 404:	//symbol selection
		case 405:	case 406:	case 407:	case 408:
		case 409:	case 410:	case 411:	case 412:
		case 413:	case 414:	case 415:
			tmpType = res - 401;
		case 416:										//text symbol
			if(res == 416) tmpType = SYM_TEXT;
			PrevSym->type = tmpType;
		case 107:										//line color button
			if(res == 107 && Dlg->GetColor(107, &tmpCol))
				PrevSym->SetColor(COL_SYM_LINE, tmpCol);
		case 109:										//fill color button
			if(res == 109 && Dlg->GetColor(109, &tmpCol)) 
				PrevSym->SetColor(COL_SYM_FILL, tmpCol);
		case 101:										//symbol size changed
		case 104:										//line width changed
		case 500:										//preview button
			if(Dlg->GetValue(101, &tmpVal))	PrevSym->SetSize(SIZE_SYMBOL, tmpVal);
			if(Dlg->GetValue(104, &tmpVal))	PrevSym->SetSize(SIZE_SYM_LINE, tmpVal);
			if(PrevSym->type == SYM_TEXT) {
				if(Dlg->GetCheck(250) && Dlg->GetText(251,text1))PrevSym->Command(CMD_SETTEXT, text1, 0L);
				else if(Dlg->GetCheck(252) && Dlg->GetText(253, text2))	
					PrevSym->Command(CMD_RANGETEXT, text2, 0L);
				}
			Dlg->DoPlot(NULL);
			res = -1;
			break;
			}
		}while (res < 0);
	switch (res) {
	case 1:								//accept values for symbol
		undo_flags = CheckNewFloat(&size, o_size, n_size, parent, undo_flags);
		undo_flags = CheckNewFloat(&SymLine.width, o_lwidth, n_lwidth, parent, undo_flags);
		if(Dlg->GetValue(301, &tmpVal)) n_pos.fx = tmpVal;
		if(Dlg->GetValue(303, &tmpVal)) n_pos.fy = tmpVal;
		undo_flags = CheckNewLFPoint(&fPos, &o_pos, &n_pos, parent, undo_flags);
		if(Dlg->GetColor(107, &tmpCol)) undo_flags = 
			CheckNewDword(&SymLine.color, SymLine.color, tmpCol, parent, undo_flags);
		if(Dlg->GetColor(109, &tmpCol)) undo_flags = 
			CheckNewDword(&SymFill.color, SymFill.color, tmpCol, parent, undo_flags);
		undo_flags = CheckNewInt(&type, type, PrevSym->type, parent, undo_flags);
		if(type == SYM_TEXT && PrevSym->Command(CMD_GETTEXTDEF, &textdef, 0L)){
			if(SymTxt && cmpTextDEF(SymTxt, &textdef)){
				Undo.TextDef(parent, SymTxt, undo_flags);	undo_flags |= UNDO_CONTINUE;
				}
			if(PrevSym->Command(CMD_GETTEXT, text1, 0L)) Command(CMD_SETTEXT, text1, 0L);
			Command(CMD_SETTEXTDEF, &textdef, 0L);
			}
		break;
	case 2:								//accept values for all symbols of plot
		parent->Command(CMD_SAVE_SYMBOLS, 0L, 0L);
		parent->SetSize(SIZE_SYMBOL, n_size);
		parent->SetSize(SIZE_SYM_LINE, n_lwidth);
		if(Dlg->GetColor(107, &tmpCol))	parent->SetColor(COL_SYM_LINE, tmpCol);
		if(Dlg->GetColor(109, &tmpCol))	parent->SetColor(COL_SYM_FILL, tmpCol);
		parent->Command(CMD_SYM_TYPE, (void*)(& PrevSym->type), 0L);
		if(PrevSym->type == SYM_TEXT) {
			if(Dlg->GetCheck(250) && PrevSym->Command(CMD_GETTEXT, text1, 0L))
				parent->Command(CMD_SYMTEXT_UNDO, text1, 0L);
			else if(Dlg->GetCheck(252) && Dlg->GetText(253, text2))	
				parent->Command(CMD_SYM_RANGETEXT, text2, 0L);
			if(PrevSym->Command(CMD_GETTEXTDEF, &textdef, 0L))
				parent->Command(CMD_SYMTEXTDEF, &textdef, 0L);
			}
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	delete PrevSym;
	return true;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Bubble properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Bubble::PropertyDlg()
{
	TabSHEET tab1 = {0, 50, 10, "Shape & Color"};
	TabSHEET tab2 = {50, 90, 10, "Scaling"};
	TabSHEET tab3 = {90, 120, 10, "Edit"};
	DlgInfo BubDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to BUBBLE", 130, 10, 60, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 130, 25, 60, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 130, 40, 60, 12},
		{4, 0, 5, CHECKED | ISPARENT, GROUP, NULL, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 100},
		{6, 7, 200, ISPARENT, SHEET, &tab2, 5, 10, 120, 100},
		{7, 0, 300, ISPARENT, SHEET, &tab3, 5, 10, 120, 100},
		{100, 109, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 18, 57, 90, 50},
		{109, 110, 0, 0x0L, SYMRADIO, (void *)SYM_CIRCLE, 30, 30, 20, 20},
		{110, 111, 0, 0x0L, SYMRADIO, (void *)SYM_RECT, 50, 30, 20, 20},
		{111, 112, 0, 0x0L, SYMRADIO, (void *)SYM_TRIAU, 70, 30, 20, 20},
		{112, 0, 0, 0x0L, SYMRADIO, (void *)SYM_TRIAD, 90, 30, 20, 20},
		{200, 201, 0, 0x0L, LTEXT, (void*)"Sizes are given as", 10, 30, 110, 8},
		{201, 202, 210, ISPARENT | CHECKED, GROUP, NULL, 0, 0, 0, 0},
		{202, 203, 0, 0x0L, LTEXT, (void*)"Proportionality (relative to circle)", 10, 64, 110, 8},
		{203, 0, 220, ISPARENT | CHECKED, GROUP, NULL, 0, 0, 0, 0},
		{210, 211, 0, 0x0L, RADIO1, (void *) Units[defs.cUnits].display, 40, 38, 45, 8},
		{211, 212, 0, 0x0L, RADIO1, (void*)"scaling with X axis", 40, 46, 45, 8},
		{212, 0, 0, 0x0L, RADIO1, (void*)"scaling with Y axis", 40, 54, 45, 8},
		{220, 221, 0, 0x0L, RADIO1, (void*)"diameter", 40, 72, 45, 8},
		{221, 222, 0, 0x0L, RADIO1, (void*)"circumference", 40, 80, 45, 8},
		{222, 0, 0, 0x0L, RADIO1, (void*)"area", 40, 88, 45, 8},
		{300, 301, 0, 0x0L, RTEXT, (void*)"x-value", 10, 40, 45, 8},
		{301, 302, 0, 0x0L, EDVAL1, &fPos.fx, 60, 40, 35, 10},
		{302, 303, 0, 0x0L, RTEXT, (void*)"y-value", 10, 60, 45, 8},
		{303, 304, 0, 0x0L, EDVAL1, &fPos.fy, 60, 60, 35, 10},
		{304, 305, 0, 0x0L, RTEXT, (void*)"size", 10, 80, 45, 8},
		{305, 0, 0, LASTOBJ, EDVAL1, &fs, 60, 80, 35, 10}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmpType;
	lfPOINT o_pos, n_pos;
	LineDEF newLine, newFillLine;
	FillDEF newFill;
	DWORD undo_flags = 0L;
	double o_size, n_size;
	bool bRet = false;

	if(!parent) return false;
	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)&BubbleLine, 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)&BubbleFill, 0);
	Dlg = new DlgRoot(BubDlg);
	switch(type & 0x00f) {
	case BUBBLE_SQUARE:		Dlg->SetCheck(110, 0L, true);		break;
	case BUBBLE_UPTRIA:		Dlg->SetCheck(111, 0L, true);		break;
	case BUBBLE_DOWNTRIA:	Dlg->SetCheck(112, 0L, true);		break;
	default:				Dlg->SetCheck(109, 0L, true);		break;
		}
	switch(type & 0x0f0) {
	case BUBBLE_XAXIS:		Dlg->SetCheck(211, 0L, true);		break;
	case BUBBLE_YAXIS:		Dlg->SetCheck(212, 0L, true);		break;
	default:				Dlg->SetCheck(210, 0L, true);		break;
		}
	switch(type & 0xf00) {
	case BUBBLE_CIRCUM:		Dlg->SetCheck(221, 0L, true);		break;
	case BUBBLE_AREA:		Dlg->SetCheck(222, 0L, true);		break;
	default:				Dlg->SetCheck(220, 0L, true);		break;
		}
	if(!Dlg->GetValue(301, &o_pos.fx))	o_pos.fx = fPos.fx;
	if(!Dlg->GetValue(303, &o_pos.fy))	o_pos.fy = fPos.fy;
	if(!Dlg->GetValue(305, &o_size))	o_size = fs;
	n_pos.fx = o_pos.fx;	n_pos.fy = o_pos.fy;	n_size = o_size;
	if(parent->name) sprintf(TmpTxt, "Bubble of %s", parent->name);
	else strcpy(TmpTxt, "Bubble properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 390, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 1:			//accept for current bubble only
		case 2:			//accept for plot
			OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
			OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&newFill, 0);
			memcpy(&newFillLine, &BubbleFillLine, sizeof(LineDEF));
			if(newFill.hatch) memcpy(&newFillLine, newFill.hatch, sizeof(LineDEF));
			if(Dlg->GetCheck(110)) tmpType = BUBBLE_SQUARE;
			else if(Dlg->GetCheck(111)) tmpType = BUBBLE_UPTRIA;
			else if(Dlg->GetCheck(112)) tmpType = BUBBLE_DOWNTRIA;
			else tmpType = BUBBLE_CIRCLE;
			if(Dlg->GetCheck(211)) tmpType |= BUBBLE_XAXIS;
			else if(Dlg->GetCheck(212)) tmpType |= BUBBLE_YAXIS;
			if(Dlg->GetCheck(221)) tmpType |= BUBBLE_CIRCUM;
			else if(Dlg->GetCheck(222)) tmpType |= BUBBLE_AREA;
			break;
			}
		}while (res < 0);
	switch (res) {
	case 1:				//new setting for current bubble only
		Dlg->GetValue(301, &n_pos.fx);		Dlg->GetValue(303, &n_pos.fy);
		undo_flags = CheckNewLFPoint(&fPos, &o_pos, &n_pos, parent, undo_flags);
		undo_flags = CheckNewInt(&type, type, tmpType, parent, undo_flags);
		Dlg->GetValue(305, &n_size);
		undo_flags = CheckNewFloat(&fs, o_size, n_size, parent, undo_flags);
		if(cmpLineDEF(&BubbleLine, &newLine)) {
			Undo.Line(parent, &BubbleLine, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&BubbleLine, &newLine, sizeof(LineDEF));
			}
		if(newFill.type && cmpLineDEF(&BubbleFillLine, &newFillLine)) {
			Undo.Line(parent, &BubbleFillLine, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&BubbleFillLine, &newFillLine, sizeof(LineDEF));
			}
		if(cmpFillDEF(&BubbleFill, &newFill)) {
			Undo.Fill(parent, &BubbleFill, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&BubbleFill, &newFill, sizeof(FillDEF));
			}
		BubbleFill.hatch = &BubbleFillLine;
		if(undo_flags & UNDO_CONTINUE) bRet = true;
		break;
	case 2:				//accept settings for plot
		parent->Command(CMD_SAVE_SYMBOLS, 0L, 0L);
		parent->Command(CMD_BUBBLE_TYPE, (void*)(& tmpType), 0L);
		parent->Command(CMD_BUBBLE_ATTRIB, (void*)(& tmpType), 0L);
		parent->Command(CMD_BUBBLE_FILL, (void*)&newFill, 0L);
		parent->Command(CMD_BUBBLE_LINE, (void*)&newLine, 0L);
		bRet = true;
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Bar properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Bar::PropertyDlg()
{
	TabSHEET tab1 = {0, 50, 10, "Size & Color"};
	TabSHEET tab2 = {50, 90, 10, "Baseline"};
	TabSHEET tab3 = {90, 120, 10, "Edit"};
	char sTxt1[20], sTxt2[20];
	DlgInfo BarDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to BAR", 130, 10, 55, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 130, 25, 55, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 130, 40, 55, 12},
		{4, 0, 5, CHECKED | ISPARENT, GROUP, NULL, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 120},
		{6, 7, 200, ISPARENT, SHEET, &tab2, 5, 10, 120, 120},
		{7, 0, 300, ISPARENT, SHEET, &tab3, 5, 10, 120, 120},
		{100, 109, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 18, 30, 90, 50},
		{109, 110, 0, 0x0L, LTEXT, (void*)"bar width:", 10, 80, 45, 8},
		{110, 111, 0, 0x0L, RADIO1, (void*)" fixed", 20, 92, 25, 8},
		{111, 112, 0, 0x0L, EDTEXT, &sTxt1[1], 60, 92, 25, 10},
		{112, 113, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 87, 92, 20, 8},
		{113, 114, 0, 0x0L, RADIO1, (void*)" relative", 20, 104, 25, 8},
		{114, 115, 0, 0x0L, EDTEXT, &sTxt2[1], 60, 104, 25, 10},
		{115, 0, 0, 0x0L, LTEXT, (void*)"%", 87, 104, 10, 8},
		{200, 201, 0, TOUCHEXIT, RADIO2, (void*)"vertical bars", 20, 30, 45, 8},
		{201, 205, 202, CHECKED | ISPARENT, GROUP, NULL, 0, 0, 0, 0},
		{202, 203, 0, TOUCHEXIT, RADIO1, (void*)"bottom baseline", 30, 40, 35, 8},
		{203, 204, 0, TOUCHEXIT, RADIO1, (void*)"top", 30, 48, 35, 8},
		{204, 0, 0, TOUCHEXIT, RADIO1, (void*)"user y =", 30, 56, 35, 8},
		{205, 206, 0, 0x0L, EDVAL1, &BarBase.fy, 65, 56, 35, 10},
		{206, 207, 0, TOUCHEXIT, RADIO2, (void*)"horizontal bars", 20, 70, 45, 8},
		{207, 211, 208, CHECKED | ISPARENT, GROUP, NULL, 0, 0, 0, 0},
		{208, 209, 0, TOUCHEXIT, RADIO1, (void*)"left baseline", 30, 80, 35, 8},
		{209, 210, 0, TOUCHEXIT, RADIO1, (void*)"right", 30, 88, 35, 8},
		{210, 0, 0, TOUCHEXIT, RADIO1, (void*)"user x =", 30, 96, 35, 8},
		{211, 212, 0, 0x0L, EDVAL1, &BarBase.fx, 65, 96, 35, 10},
		{212, 0, 0, 0x0L, CHECKBOX, (void*)"bars centered across baseline", 20, 113, 50, 8},
		{300, 301, 0, 0x0L, RTEXT, (void*)"x-value", 10, 50, 45, 8},
		{301, 302, 0, 0x0L, EDVAL1, &fPos.fx, 60, 50, 40, 10},
		{302, 303, 0, 0x0L, RTEXT, (void*)"y-value", 10, 75, 45, 8},
		{303, 0, 0, LASTOBJ, EDVAL1, &fPos.fy, 60, 75, 40, 10}};
	DlgRoot *Dlg;
	void *hDlg;
	double n_size;
	int res, tmpType = type;
	bool bRet = false;
	LineDEF newLine, newFillLine;
	FillDEF newFill;
	DWORD undo_flags = 0L;
	lfPOINT o_bl, n_bl, o_pos, n_pos;

	if(!parent) return false;
	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)&BarLine, 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)&BarFill, 0);
	if(type & BAR_RELWIDTH) {
		WriteNatFloatToBuff(sTxt2, size);
		WriteNatFloatToBuff(sTxt1, defs.GetSize(SIZE_BAR));
		}
	else {
		WriteNatFloatToBuff(sTxt1, size);
		strcpy(sTxt2, " 50");
		}
	Dlg = new DlgRoot(BarDlg);
	switch (type & 0xff) {
	case BAR_VERTB:		case BAR_VERTT:		case BAR_VERTU:
		Dlg->SetCheck(200, 0L, true);
		Dlg->SetCheck(208, 0L, true);
		switch(type & 0xff) {
		case BAR_VERTT:	Dlg->SetCheck(203, 0L, true);	break;
		case BAR_VERTU:	Dlg->SetCheck(204, 0L, true);	break;
		default:		Dlg->SetCheck(202, 0L, true);	break;
			}
		break;
	case BAR_HORL:		case BAR_HORR:		case BAR_HORU:
		Dlg->SetCheck(206, 0L, true);
		Dlg->SetCheck(202, 0L, true);
		switch(type & 0xff) {
		case BAR_HORR:	Dlg->SetCheck(209, 0L, true);	break;
		case BAR_HORU:	Dlg->SetCheck(210, 0L, true);	break;
		default:		Dlg->SetCheck(208, 0L, true);	break;
			}
		break;
		}
	if(type & BAR_RELWIDTH) Dlg->SetCheck(113, 0L, true);
	else Dlg->SetCheck(110, 0L, true);
	if(type & BAR_CENTERED) Dlg->SetCheck(212, 0L, true);
	if(parent && parent->name) sprintf(TmpTxt, "Bar of %s", parent->name);
	else strcpy(TmpTxt, "Bar properties");
	if(!Dlg->GetValue(211, &o_bl.fx))	o_bl.fx = BarBase.fx;
	if(!Dlg->GetValue(205, &o_bl.fy))	o_bl.fy = BarBase.fy;
	if(!Dlg->GetValue(301, &o_pos.fx))	o_pos.fx = fPos.fx;
	if(!Dlg->GetValue(303, &o_pos.fy))	o_pos.fy = fPos.fy;
	n_bl.fx = o_bl.fx;			n_bl.fy = o_bl.fy;
	n_pos.fx = o_pos.fx;		n_pos.fy = o_pos.fy;
	n_size = size;
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 390, 296, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 202:	case 203:	case 204:
			Dlg->SetCheck(200, NULL, true);
			tmpType = res == 202 ? BAR_VERTB : res == 203 ? BAR_VERTT : BAR_VERTU;
			res = -1;				//continue on radiobutton
			break;
		case 208:	case 209:	case 210:
			Dlg->SetCheck(206, NULL, true);
			tmpType = res == 208 ? BAR_HORL : res == 209 ? BAR_HORR : BAR_HORU;
			res = -1;				//continue on radiobutton
			break;
		case 200:					//group of vertical bars
			if(Dlg->GetCheck(203)) tmpType = BAR_VERTT;
			else if(Dlg->GetCheck(204)) tmpType = BAR_VERTU;
			else tmpType = BAR_VERTB;
			res = -1;
			break;
		case 206:					//group of horizontal bars
			if(Dlg->GetCheck(209)) tmpType = BAR_HORR;
			else if(Dlg->GetCheck(210)) tmpType = BAR_HORU;
			else tmpType = BAR_HORL;
			res = -1;
			break;
		case 1:
		case 2:
			OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
			OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&newFill, 0);
			memcpy(&newFillLine, &HatchLine, sizeof(LineDEF));
			if(newFill.hatch) memcpy(&newFillLine, newFill.hatch, sizeof(LineDEF));
			if(Dlg->GetCheck(113)) {
				tmpType |= BAR_RELWIDTH;			Dlg->GetValue(114, &n_size);
				}
			else {
				tmpType &= ~BAR_RELWIDTH;			Dlg->GetValue(111, &n_size);
				}
			if(Dlg->GetCheck(212))tmpType |= BAR_CENTERED; 
			else tmpType &= ~BAR_CENTERED;
			Dlg->GetValue(211, &n_bl.fx);			Dlg->GetValue(205, &n_bl.fy);
			Dlg->GetValue(301, &n_pos.fx);			Dlg->GetValue(303, &n_pos.fy);
			break;
			}
		}while (res < 0);
	switch (res) {
	case 1:				//new setting for current bar only
		undo_flags = CheckNewInt(&type, type, tmpType, parent, undo_flags);
		undo_flags = CheckNewLFPoint(&BarBase, &o_bl, &n_bl, parent, undo_flags);
		undo_flags = CheckNewLFPoint(&fPos, &o_pos, &n_pos, parent, undo_flags);
		if(undo_flags & UNDO_CONTINUE) parent->Command(CMD_MRK_DIRTY, 0L, 0L);
		undo_flags = CheckNewFloat(&size, size, n_size, parent, undo_flags);
		if(cmpLineDEF(&BarLine, &newLine)) {
			Undo.Line(parent, &BarLine, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&BarLine, &newLine, sizeof(LineDEF));
			}
		if(newFill.type && cmpLineDEF(&HatchLine, &newFillLine)) {
			Undo.Line(parent, &HatchLine, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&HatchLine, &newFillLine, sizeof(LineDEF));
			}
		if(cmpFillDEF(&BarFill, &newFill)) {
			Undo.Fill(parent, &BarFill, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&BarFill, &newFill, sizeof(FillDEF));
			}
		BarFill.hatch = &HatchLine;
		if(undo_flags & UNDO_CONTINUE) bRet = true;
		break;
	case 2:				//new settings to all bars of plot
		parent->Command(CMD_SAVE_BARS, 0L, 0L);
		if(parent->Id == GO_PLOTSCATT && parent->parent 
			&& parent->parent->Id == GO_STACKBAR){ 
			parent->parent->SetSize(SIZE_BAR, n_size);
			parent->parent->Command(CMD_BAR_TYPE, (void *)(& tmpType), 0L);
			}
		else {
			parent->SetSize(SIZE_BAR, n_size);
			parent->Command(CMD_BAR_TYPE, (void *)(& tmpType), 0L);
			}
		parent->SetColor(COL_BAR_LINE, newLine.color);
		parent->SetSize(SIZE_BAR_LINE, newLine.width);
		parent->SetSize(SIZE_YBASE, n_bl.fy);
		parent->SetSize(SIZE_XBASE, n_bl.fx);
		parent->Command(CMD_MRK_DIRTY, 0L, 0L);
		parent->Command(CMD_BAR_TYPE, (void *)(& tmpType), 0L);
		parent->Command(CMD_BAR_FILL, (void *)&newFill, 0L);
		bRet = true;
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Data line properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
DataLine::PropertyDlg()
{
	TabSHEET tab1 = {0, 40, 10, "Line"};
	TabSHEET tab2 = {40, 80, 10, "Style"};
	DlgInfo LineDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 150, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 139, 120},
		{5, 0, 200, ISPARENT, SHEET, &tab2, 5, 10, 139, 120},
		{100, 0, 0, NOSELECT, ODBUTTON, (void*)OD_linedef, 10, 38, 130, 100},
		{200, 201, 0, 0x0L, LTEXT, (void*)"select style:", 10, 38, 130, 100},
		{201, 202, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_LineStyleTempl), 12, 50, 25, 25},
		{202, 203, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_LineStyleTempl), 37, 50, 25, 25},
		{203, 204, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_LineStyleTempl), 62, 50, 25, 25},
		{204, 205, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_LineStyleTempl), 87, 50, 25, 25},
		{205, 206, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_LineStyleTempl), 112, 50, 25, 25},
		{206, 207, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_LineStyleTempl), 37, 75, 25, 25},
		{207, 208, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_LineStyleTempl), 62, 75, 25, 25},
		{208, 209, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_LineStyleTempl), 87, 75, 25, 25},
		{209, 0, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_LineStyleTempl), 112, 75, 25, 25},
		{800, 0, 0, LASTOBJ, NONE, 0L, 0, 0, 0, 0}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmpType = type;
	DWORD undo_flags = 0L;
	LineDEF newLine;
	bool bRet = false;

	if(!parent) return false;
	if(parent->Id == GO_FUNCTION) return parent->PropertyDlg();
	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&LineDef, 0);
	if(!(Dlg = new DlgRoot(LineDlg)))return false;
	Dlg->SetCheck(201 + (type & 0x7), 0L, true);
	if(parent && parent->name) sprintf(TmpTxt, "Line of %s", parent->name);
	else strcpy(TmpTxt, "Line properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 410, 300, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 201:	case 202:	case 203:	case 204:	case 205:
		case 206:	case 207:	case 208:	case 209:
			tmpType &= ~0x0f;
			tmpType |= (res-201);
			res = -1;
			break;
			}
		}while (res < 0);
	if(res == 1){						//OK pressed
		OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
		if(cmpLineDEF(&LineDef, &newLine)) {
			Undo.Line(parent, &LineDef, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&LineDef, &newLine, sizeof(LineDEF));
			}
		undo_flags = CheckNewInt(&type, type, tmpType, parent, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Data polygon properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
DataPolygon::PropertyDlg()
{
	TabSHEET tab1 = {0, 40, 10, "Polygon"};
	DlgInfo LineDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 102, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 102, 25, 45, 12},
		{3, 0, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 90, 75},
		{100, 0, 0, LASTOBJ | NOSELECT, ODBUTTON, (void*)OD_filldef, 8, 30, 90, 50}};
	DlgRoot *Dlg;
	void *hDlg;
	LineDEF newLine, newFillLine;
	FillDEF newFill;
	DWORD undo_flags = 0L;
	int res;
	bool bRet = false;

	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)&LineDef, 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)&pgFill, 0);
	Dlg = new DlgRoot(LineDlg);
	if(parent && parent->name) sprintf(TmpTxt, "Polygon of %s", parent->name);
	else strcpy(TmpTxt, "Polygon properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 310, 204, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		}while (res < 0);
	if(res == 1){						//OK pressed
		OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
		OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&newFill, 0);
		memcpy(&newFillLine, &pgFillLine, sizeof(LineDEF));
		if(newFill.hatch) memcpy(&newFillLine, newFill.hatch, sizeof(LineDEF));
		if(cmpLineDEF(&LineDef, &newLine)) {
			Undo.Line(parent, &LineDef, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&LineDef, &newLine, sizeof(LineDEF));
			}
		if(newFill.type && cmpLineDEF(&pgFillLine, &newFillLine)) {
			Undo.Line(parent, &pgFillLine, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&pgFillLine, &newFillLine, sizeof(LineDEF));
			}
		if(cmpFillDEF(&pgFill, &newFill)) {
			Undo.Fill(parent, &pgFill, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&pgFill, &newFill, sizeof(FillDEF));
			}
		pgFill.hatch = &pgFillLine;
		if(undo_flags & UNDO_CONTINUE) bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Regression line properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
RegLine::PropertyDlg()
{
	TabSHEET tab1 = {0, 30, 10, "Line"};
	TabSHEET tab2 = {30, 60, 10, "Model"};
	TabSHEET tab3 = {60, 95, 10, "Clipping"};
	char text1[40], text2[40], text3[40], text4[40], text5[40];
	DlgInfo LineDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 155, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 155, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 144, 130},
		{5, 6, 200, ISPARENT, SHEET, &tab2, 5, 10, 144, 130},
		{6, 0, 300, ISPARENT, SHEET, &tab3, 5, 10, 144, 130},
		{100, 0, 0, NOSELECT, ODBUTTON, (void*)OD_linedef, 12, 38, 130, 100},
		{200, 201, 0, TOUCHEXIT, RADIO1, (void*)"y dependent on x", 15, 25, 130, 8},
		{201, 202, 0, 0x0L, LTEXT, (void*)text1, 25, 33, 120, 8},
		{202, 203, 0, TOUCHEXIT, RADIO1, (void*)"x dependent on y", 15, 45, 130, 8},
		{203, 204, 0, 0x0L, LTEXT, (void*)text2, 25, 53, 120, 8},
		{204, 205, 0, TOUCHEXIT, RADIO1, (void*)"mixed model", 15, 65, 130, 8},
		{205, 206, 0, 0x0L, LTEXT, (void*)text3, 25, 73, 120, 8},
		{206, 207, 0, TOUCHEXIT, RADIO1, (void*)"zero crossing (x = 0, y = 0)", 15, 85, 130, 8},
		{207, 208, 0, 0x0L, LTEXT, (void*)text4, 25, 93, 120, 8},
		{208, 209, 0, TOUCHEXIT, RADIO1, (void*)"set manually", 15, 105, 130, 8},
		{209, 210, 0, 0x0L, LTEXT, (void*)text5, 25, 113, 60, 8},
		{210, 211, 0, 0x0L, RTEXT, (void*)"a =", 92, 113, 10, 8},
		{211, 212, 0, 0x0L, EDVAL1, &l5.fx, 104, 113, 40, 10},
		{212, 213, 0, 0x0L, RTEXT, (void*)"b =", 92, 125, 10, 8},
		{213, 0, 0, 0x0L, EDVAL1, &l5.fy, 104, 125, 40, 10},
		{300, 301, 0, 0x0L, LTEXT, (void*)"Line length is limited by", 15, 30, 100, 8},
		{301, 302, 0, TOUCHEXIT, RADIO1, (void*)"data minima and maxima", 15, 45, 100, 8},
		{302, 303, 0, TOUCHEXIT, RADIO1, (void*)"frame rectangle", 15, 60, 100, 8},
		{303, 304, 0, TOUCHEXIT, RADIO1, (void*)"user defined values", 15, 75, 100, 8},
		{304, 305, 0, 0x0L, RTEXT, (void*)"x", 10, 89, 15, 8},
		{305, 306, 0, 0x0L, EDVAL1, &uclip.Xmin, 27, 89, 40, 10},
		{306, 307, 0, 0x0L, LTEXT, (void*)"-", 70, 89, 5, 8},
		{307, 308, 0, 0x0L, EDVAL1, &uclip.Xmax, 76, 89, 40, 10},
		{308, 309, 0, 0x0L, LTEXT, (void*)"[data]", 119, 89, 15, 8},
		{309, 310, 0, 0x0L, RTEXT, (void*)"y", 10, 101, 15, 8},
		{310, 311, 0, 0x0L, EDVAL1, &uclip.Ymin, 27, 101, 40, 10},
		{311, 312, 0, 0x0L, LTEXT, (void*)"-", 70, 101, 5, 8},
		{312, 313, 0, 0x0L, EDVAL1, &uclip.Ymax, 76, 101, 40, 10},
		{313, 0, 0, LASTOBJ, LTEXT, (void*)"[data]", 119, 101, 15, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmpType;
	bool bRet = false;
	LineDEF newLine;
	DWORD undo_flags = 0L;
	lfPOINT o_l5, n_l5;
	fRECT o_clip, n_clip;
	char *tx, *ty;

	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&LineDef, 0);
	switch(type &0x700) {
	case 0x100:		tx = "log(x)";	break;
	case 0x200:		tx = "(1/x)";	break;
	case 0x300:		tx = "sqrt(x)"; break;
	default:		tx = "x";		break;
		}
	switch(type &0x7000) {
	case 0x1000:	ty = "log(y)";	break;
	case 0x2000:	ty = "(1/y)";	break;
	case 0x3000:	ty = "sqrt(y)"; break;
	default:		ty = "y";		break;
		}
	sprintf(text1, "%s = %.3lf + %.3lf * %s   (n = %ld)", ty, l1.fx, l1.fy, tx, nPoints);
	sprintf(text2, "%s = %.3lf + %.3lf * %s", ty, l2.fx, l2.fy, tx);
	sprintf(text3, "%s = %.3lf + %.3lf * %s", ty, l3.fx, l3.fy, tx);
	sprintf(text4, "%s = %.3lf + %.3lf * %s", ty, l4.fx, l4.fy, tx);
	sprintf(text5, "%s = a + b * %s", ty, tx);
	if(!(Dlg = new DlgRoot(LineDlg))) return false;
	Dlg->Activate(211, false);	Dlg->Activate(213, false);
	switch(type & 0x07) {
	case 1:		Dlg->SetCheck(202, 0L, true);	break;
	case 2:		Dlg->SetCheck(204, 0L, true);	break;
	case 3:		Dlg->SetCheck(206, 0L, true);	break;
	case 4:		
		Dlg->SetCheck(208, 0L, true);
		Dlg->Activate(211, true);	Dlg->Activate(213, true);
		break;
	default:	Dlg->SetCheck(200, 0L, true);	break;
		}
	switch(type & 0x70) {
	case 0x10:	Dlg->SetCheck(302, 0L, true);	break;
	case 0x20:	Dlg->SetCheck(303, 0L, true);	break;
	default:	Dlg->SetCheck(301, 0L, true);	break;
		}
	if(0x20 == (type & 0x70)) {
		Dlg->Activate(305, true);	Dlg->Activate(307, true);
		Dlg->Activate(310, true);	Dlg->Activate(312, true);
		}
	else {
		Dlg->Activate(305, false);	Dlg->Activate(307, false);
		Dlg->Activate(310, false);	Dlg->Activate(312, false);
		}
	if(!Dlg->GetValue(211, &o_l5.fx))	o_l5.fx = l5.fx;
	if(!Dlg->GetValue(213, &o_l5.fy))	o_l5.fy = l5.fy;
	n_l5.fx = o_l5.fx;			n_l5.fy = o_l5.fy;
	if(!Dlg->GetValue(305, &o_clip.Xmin)) o_clip.Xmin = uclip.Xmin;
	if(!Dlg->GetValue(307, &o_clip.Xmax)) o_clip.Xmax = uclip.Xmax;
	if(!Dlg->GetValue(310, &o_clip.Ymin)) o_clip.Ymin = uclip.Ymin;
	if(!Dlg->GetValue(312, &o_clip.Ymax)) o_clip.Ymax = uclip.Ymax;
	memcpy(&n_clip, &o_clip, sizeof(fRECT));
	if(parent && parent->name) {
		sprintf(TmpTxt, "Regression line of %s", parent->name);
		}
	else strcpy(TmpTxt, "Regression line properties");
	hDlg = CreateDlgWnd(cp ? TmpTxt : 
		(char*)"Linear regression analysis step 2/2", 50, 50, 420, 320, Dlg, 0x0L);
	if(!cp) Dlg->SetCheck(5, 0L, true);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 200:	case 202:	case 204:	case 206:
			Dlg->Activate(211, false);	Dlg->Activate(213, false);
			res = -1;
			break;
		case 208:
			Dlg->Activate(211, true);	Dlg->Activate(213, true);
			res = -1;
			break;
		case 301:	case 302:
			Dlg->Activate(305, false);	Dlg->Activate(307, false);
			Dlg->Activate(310, false);	Dlg->Activate(312, false);
			res = -1;
			break;
		case 303:
			Dlg->Activate(305, true);	Dlg->Activate(307, true);
			Dlg->Activate(310, true);	Dlg->Activate(312, true);
			res = -1;
			break;
			}
		}while (res < 0);
	if(res == 1){						//OK pressed
		OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
		if(cmpLineDEF(&LineDef, &newLine)) {
			Undo.Line(parent, &LineDef, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&LineDef, &newLine, sizeof(LineDEF));
			}
		tmpType = type & (~0x77);
		if(Dlg->GetCheck(202)) tmpType |= 1;
		else if(Dlg->GetCheck(204)) tmpType |= 2;
		else if(Dlg->GetCheck(206)) tmpType |= 3;
		else if(Dlg->GetCheck(208)) tmpType |= 4;
		if(Dlg->GetCheck(302)) tmpType |= 0x10;
		else if(Dlg->GetCheck(303)) tmpType |= 0x20;
		undo_flags = CheckNewInt(&type, type, tmpType, parent, undo_flags);
		Dlg->GetValue(211, &n_l5.fx);			Dlg->GetValue(213, &n_l5.fy);
		undo_flags = CheckNewLFPoint(&l5, &o_l5, &n_l5, parent, undo_flags);
		Dlg->GetValue(305, &n_clip.Xmin);		Dlg->GetValue(307, &n_clip.Xmax);
		Dlg->GetValue(310, &n_clip.Ymin);		Dlg->GetValue(312, &n_clip.Ymax);
		undo_flags = CheckNewFloat(&uclip.Xmin, o_clip.Xmin, n_clip.Xmin, parent, undo_flags);
		undo_flags = CheckNewFloat(&uclip.Xmax, o_clip.Xmax, n_clip.Xmax, parent, undo_flags);
		undo_flags = CheckNewFloat(&uclip.Ymin, o_clip.Ymin, n_clip.Ymin, parent, undo_flags);
		undo_flags = CheckNewFloat(&uclip.Ymax, o_clip.Ymax, n_clip.Ymax, parent, undo_flags);
		if(!cp || (undo_flags & UNDO_CONTINUE)) bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// SDellipse properties
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
SDellipse::PropertyDlg()
{
	TabSHEET tab1 = {0, 40, 10, "Line"};
	TabSHEET tab2 = {40, 80, 10, "Details"};
	DlgInfo ellDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 150, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 139, 120},
		{5, 0, 200, ISPARENT, SHEET, &tab2, 5, 10, 139, 120},
		{100, 0, 0, NOSELECT, ODBUTTON, (void*)OD_linedef, 10, 38, 130, 100},
		{200, 201, 0, 0x0L, CHECKBOX, (void*)" show regression line", 20, 30, 80, 9},
		{201, 0, 250, CHECKED, GROUPBOX, (void*)"  ellipse  ", 10, 55, 129, 70},
		{250, 251, 0, 0x0L, LTEXT, (void*)"center (means of data)", 25, 60, 60, 8},
		{251, 252, 0, 0x0L, RTEXT, (void*)"x =", 20, 70, 60, 8},
		{252, 253, 0, 0x0L, LTEXT, 0L, 82, 70, 30, 8},
		{253, 254, 0, 0x0L, RTEXT, (void*)"y =", 20, 78, 60, 8},
		{254, 255, 0, 0x0L, LTEXT, 0L, 82, 78, 30, 8},
		{255, 256, 0, 0x0L, LTEXT, (void*)"standard deviation (SD)", 25, 90, 60, 8},
		{256, 257, 0, 0x0L, RTEXT, (void*)"major axis =", 20, 100, 60, 8},
		{257, 258, 0, 0x0L, LTEXT, 0L, 82, 100, 30, 8},
		{258, 259, 0, 0x0L, RTEXT, (void*)"minor axis =", 20, 108, 60, 8},
		{259, 0, 0, LASTOBJ, LTEXT, 0L, 82, 108, 30, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmpType;
	LineDEF newLine;
	bool bRet = false;
	DWORD undo_flags = 0L;

	if(!parent) return false;
	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&LineDef, 0);
	if(!(Dlg = new DlgRoot(ellDlg))) return false;
	if(!(type & 0x10000)) Dlg->SetCheck(200, 0L, true);
	WriteNatFloatToBuff(TmpTxt, mx);		Dlg->SetText(252, TmpTxt+1);
	WriteNatFloatToBuff(TmpTxt, my);		Dlg->SetText(254, TmpTxt+1);
	strcpy(TmpTxt, "+/-");
	WriteNatFloatToBuff(TmpTxt+3, sd1);		Dlg->SetText(259, TmpTxt);
	WriteNatFloatToBuff(TmpTxt+3, sd2);		Dlg->SetText(257, TmpTxt);
	tmpType = type;
	if(parent && parent->name) sprintf(TmpTxt, "SD ellipse of %s", parent->name);
	else strcpy(TmpTxt, "SD ellipse properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 410, 300, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		}while (res < 0);
	if(res == 1){						//OK pressed
		OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
		if(cmpLineDEF(&LineDef, &newLine)) {
			Undo.Line(parent, &LineDef, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&LineDef, &newLine, sizeof(LineDEF));
			}
		if(Dlg->GetCheck(200)) tmpType &= ~0x10000;
		else tmpType |= 0x10000;
		undo_flags = CheckNewInt(&type, type, tmpType, parent, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bRet = true;
		}
	CloseDlgWnd(hDlg);		delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Normal error bars properties
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
ErrorBar::PropertyDlg()
{
	TabSHEET tab1 = {0, 38, 10, "Error Bar"};
	TabSHEET tab2 = {38, 65, 10, "Type"};
	TabSHEET tab3 = {65, 90, 10, "Edit"};
	DlgInfo ErrDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to ERROR", 100, 10, 57, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 100, 25, 57, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 100, 40, 57, 12},
		{4, 0, 5, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 90, 100},
		{6, 7, 200, ISPARENT, SHEET, &tab2, 5, 10, 90, 100},
		{7, 0, 300, ISPARENT, SHEET, &tab3, 5, 10, 90, 100},
		{100, 101, 0, 0x0L, RTEXT, (void*)"cap width", 15, 40, 28, 8},
		{101, 102, 0, 0x0L, EDVAL1, &SizeBar, 46, 40, 25, 10},
		{102, 103, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 40, 20, 8},
		{103, 104, 0, 0x0L, RTEXT, (void*)"line width", 15, 55, 28, 8},
		{104, 105, 0, 0x0L, EDVAL1, &ErrLine.width, 46, 55, 25, 10},
		{105, 106, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 55, 20, 8},
		{106, 107, 0, 0x0L, RTEXT, (void*)"line color", 15, 70, 28, 8},
		{107, 0, 0, OWNDIALOG, COLBUTTON, (void *)ErrLine.color, 46, 70, 25, 10},
		{200, 0, 500, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{300, 301, 0, 0x0L, RTEXT, (void*)"x-value", 15, 40, 28, 8},
		{301, 302, 0, 0x0L, EDVAL1, &fPos.fx, 46, 40, 35, 10},
		{302, 303, 0, 0x0L, RTEXT, (void*)"y-value", 15, 55, 28, 8},
		{303, 304, 0, 0x0L, EDVAL1, &fPos.fy, 46, 55, 35, 10},
		{304, 305, 0, 0x0L, RTEXT, (void*)"error", 15, 70, 28, 8},
		{305, 0, 0, 0x0L, EDVAL1, &ferr, 46, 70, 35, 10},
		{500, 501, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 12, 40, 25, 25},
		{501, 502, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 37, 40, 25, 25},
		{502, 503, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 62, 40, 25, 25},
		{503, 504, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 12, 65, 25, 25},
		{504, 505, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 37, 65, 25, 25},
		{505, 0, 0, LASTOBJ | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 62, 65, 25, 25}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmpType = type;
	double n_sb, o_sb, n_lw, o_lw, n_err, o_err;
	lfPOINT n_pos, o_pos;
	DWORD n_col, undo_flags = 0L;
	bool bRet = false;

	if(!parent) return false;
	if(!(Dlg = new DlgRoot(ErrDlg)))return false;
	Dlg->SetCheck(500 + (type & 0x7), 0L, true);
	if(!(Dlg->GetValue(101, &o_sb))) o_sb = SizeBar;
	if(!(Dlg->GetValue(104, &o_lw))) o_lw = ErrLine.width;
	if(!(Dlg->GetValue(305, &o_err))) o_err = ferr;
	if(!(Dlg->GetValue(301, &o_pos.fx))) o_pos.fx = fPos.fx;
	if(!(Dlg->GetValue(303, &o_pos.fy))) o_pos.fy = fPos.fy;
	n_sb = o_sb;	n_lw = o_lw;	n_err = o_err; n_pos.fx = o_pos.fx;	n_pos.fy = o_pos.fy;
	if(parent && parent->name) sprintf(TmpTxt, "Error bar of %s", parent->name);
	else strcpy(TmpTxt, "Error properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 328, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 500:	case 501:	case 502:
		case 503:	case 504:	case 505:
			tmpType = res-500;
			res = -1;
			break;
		case 1:								//accept for this object
		case 2:								//   or all objects of plot
			Dlg->GetValue(101, &n_sb);		Dlg->GetValue(104, &n_lw);
			Dlg->GetColor(107, &n_col);		Dlg->GetValue(305, &n_err);
			Dlg->GetValue(301, &n_pos.fx);	Dlg->GetValue(303, &n_pos.fy);
			break;
			}
		}while (res <0);
	switch (res) {
	case 1:				//new setting for current error bar only
		undo_flags = CheckNewFloat(&SizeBar, o_sb, n_sb, parent, undo_flags);
		undo_flags = CheckNewFloat(&ErrLine.width, o_lw, n_lw, parent, undo_flags);
		undo_flags = CheckNewDword(&ErrLine.color, ErrLine.color, n_col, parent, undo_flags);
		undo_flags = CheckNewInt(&type, type, tmpType, parent, undo_flags);
		undo_flags = CheckNewFloat(&ferr, o_err, n_err, parent, undo_flags);
		undo_flags = CheckNewLFPoint(&fPos, &o_pos, &n_pos, parent, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bRet = true;
		break;
	case 2:				//new settings to all error bars of plot
		parent->Command(CMD_SAVE_ERRS, 0L, 0L);
		parent->SetSize(SIZE_ERRBAR, n_sb);
		parent->SetSize(SIZE_ERRBAR_LINE, n_lw);
		parent->SetColor(COL_ERROR_LINE, n_col);
		if(type != tmpType) parent->Command(CMD_MRK_DIRTY, 0L, 0L);
		bRet = parent->Command(CMD_ERR_TYPE, (void*)(& tmpType), 0L);
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Arrow properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Arrow::PropertyDlg()
{
	TabSHEET tab1 = {0, 29, 10, "Arrow"};
	TabSHEET tab2 = {29, 59, 10, "Type"};
	TabSHEET tab3 = {59, 90, 10, "Edit"};
	DlgInfo ArrowDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, type & ARROW_UNITS ? 
			(void*)"OK" : (void*)"Apply to ARROW", 100, 10, 57, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 100, 25, 57, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 100, 
			type & ARROW_UNITS ? 25 : 40, 57, 12},
		{4, 50, 5, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 90, 100},
		{6, 7, 200, ISPARENT, SHEET, &tab2, 5, 10, 90, 100},
		{7, 0, 300, ISPARENT, SHEET, &tab3, 5, 10, 90, 100},
		{50, 0, 600, ISPARENT | CHECKED | HIDDEN, GROUP, 0L, 0, 0, 0, 0},
		{100, 101, 0, 0x0L, RTEXT, (void*)"cap width", 15, 40, 28, 8},
		{101, 102, 0, 0x0L, EDVAL1, &cw, 46, 40, 25, 10},
		{102, 103, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 40, 20, 8},
		{103, 104, 0, 0x0L, RTEXT, (void*)"length", 15, 52, 28, 8},
		{104, 105, 0, 0x0L, EDVAL1, &cl, 46, 52, 25, 10},
		{105, 106, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 52, 20, 8},
		{106, 107, 0, 0x0L, RTEXT, (void*)"line width", 15, 70, 28, 8},
		{107, 108, 0, 0x0L, EDVAL1, &LineDef.width, 46, 70, 25, 10},
		{108, 109, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 70, 20, 8},
		{109, 110, 0, 0x0L, RTEXT, (void*)"color", 15, 82, 28, 8},
		{110, 0, 0, OWNDIALOG, COLBUTTON, (void *)LineDef.color, 46, 82, 25, 10},
		{200, 201, 0, TOUCHEXIT, RADIO1, (void*)"line only", 15, 40, 60, 8},
		{201, 202, 0, TOUCHEXIT, RADIO1, (void*)"arrow with lines", 15, 55, 60, 8},
		{202, 0, 0, TOUCHEXIT, RADIO1, (void*)"filled arrow", 15, 70, 60, 8},
		{300, 301, 0, 0x0L, RTEXT, (void*)"x-value", 10, 30, 28, 8},
		{301, 302, 0, 0x0L, EDVAL1, &pos2.fx, 46, 30, 35, 10},
		{302, 303, 0, 0x0L, RTEXT, (void*)"y-value", 10, 42, 28, 8},
		{303, 304, 0, 0x0L, EDVAL1, &pos2.fy, 46, 42, 35, 10},
		{304, 305, 0, 0x0L, RTEXT, (void*)"origin x", 10, 60, 28, 8},
		{305, 306, 0, 0x0L, EDVAL1, &pos1.fx, 46, 60, 35, 10},
		{306, 307, 0, 0x0L, RTEXT, (void*)" y", 10, 72, 28, 8},
		{307, 308, 0, 0x0L, EDVAL1, &pos1.fy, 46, 72, 35, 10},
		{308, 309, 0, 0x0L, CHECKBOX, (void*)"set common origin to", 16, 85, 70, 8},
		{309, 0, 0, 0x0L, LTEXT, (void*)"all arrows of plot", 25, 93, 65, 8},
		{600, 601, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 108, 67, 15, 15},
		{601, 602, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 134, 67, 15, 15},
		{602, 603, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 134, 82, 15, 15},
		{603, 0, 0, LASTOBJ | TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 108, 82, 15, 15}};
	DlgRoot *Dlg;
	void *hDlg;
	lfPOINT o_pos1, o_pos2, n_pos1, n_pos2;
	double o_cw, o_cl, n_cw, n_cl, o_lw, n_lw;
	int res, tmptype = type, undo_level = *Undo.pcb;
	bool bRet = false;
	DWORD o_col, n_col, undo_flags = 0L;

	if(!parent) return false;
	if(!(Dlg = new DlgRoot(ArrowDlg))) return false;
	Dlg->GetValue(301, &o_pos2.fx);		Dlg->GetValue(303, &o_pos2.fy);
	Dlg->GetValue(305, &o_pos1.fx);		Dlg->GetValue(307, &o_pos1.fy);
	Dlg->GetValue(101, &o_cw);			Dlg->GetValue(104, &o_cl);
	Dlg->GetValue(107, &o_lw);			Dlg->GetColor(110, &o_col);
	if(parent->Id ==  GO_GRAPH || parent->Id == GO_PAGE) Dlg->ShowItem(50, true);
	switch(type & 0xff) {
	case ARROW_LINE:		Dlg->SetCheck(201, 0L, true);		break;
	case ARROW_TRIANGLE:	Dlg->SetCheck(202, 0L, true);		break;
	default:				Dlg->SetCheck(200, 0L, true);		break;
		}
	if(tmptype & ARROW_UNITS){
		Dlg->ShowItem(2, false);
		Dlg->ShowItem(308, false);		Dlg->ShowItem(309, false);
		}
	if(parent && parent->name) sprintf(TmpTxt, "Arrow of %s", parent->name);
	else strcpy(TmpTxt, "Arrow properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 328, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = ExecDrawOrderButt(parent, this, Dlg->GetResult());
		switch (res) {
		case 200:	tmptype = ARROW_NOCAP;		res = -1;	break;
		case 201:	tmptype = ARROW_LINE;		res = -1;	break;
		case 202:	tmptype = ARROW_TRIANGLE;	res = -1;	break;
		case 1:		case 2:
			Dlg->GetValue(301, &n_pos2.fx);		Dlg->GetValue(303, &n_pos2.fy);
			Dlg->GetValue(305, &n_pos1.fx);		Dlg->GetValue(307, &n_pos1.fy);
			Dlg->GetValue(101, &n_cw);			Dlg->GetValue(104, &n_cl);
			Dlg->GetValue(107, &n_lw);			Dlg->GetColor(110, &n_col);
			break;
			}
		}while (res <0);
	switch (res) {
	case 1:				//new setting for current arrow
		if(n_pos1.fx != o_pos1.fx || n_pos1.fy != o_pos1.fy ||
			n_pos2.fx != o_pos2.fx || n_pos2.fy != o_pos2.fy){
			Command(CMD_SAVEPOS, 0L, 0L);				undo_flags |= UNDO_CONTINUE;
			memcpy(&pos1, &n_pos1, sizeof(lfPOINT));	memcpy(&pos2, &n_pos2, sizeof(lfPOINT));
			if(!(type & ARROW_UNITS)) parent->Command(CMD_MRK_DIRTY, 0L, 0L);
			}
		if((type & 0xff) != (tmptype & 0xff)){
			Undo.ValInt(this, &type, undo_flags);
			type &= ~0xff;	type |= (tmptype & 0xff);	undo_flags |= UNDO_CONTINUE;
			}
		undo_flags = CheckNewFloat(&cw, o_cw, n_cw, this, undo_flags);
		undo_flags = CheckNewFloat(&cl, o_cl, n_cl, this, undo_flags);
		undo_flags = CheckNewFloat(&LineDef.width, o_lw, n_lw, this, undo_flags);
		undo_flags = CheckNewDword(&LineDef.color, o_col, n_col, this, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bModified = true;
		bRet = true;
		break;
	case 2:				//new settings to all arrows of plot
		if(parent->Id >= GO_PLOT && parent->Id < GO_GRAPH) {
			parent->Command(CMD_SAVE_ARROWS, 0L, 0L);
			if(Dlg->GetCheck(308)) parent->Command(CMD_ARROW_ORG, &n_pos1, 0L);
			parent->SetSize(SIZE_ARROW_LINE, n_lw);
			parent->SetSize(SIZE_ARROW_CAPWIDTH, n_cw);
			parent->SetSize(SIZE_ARROW_CAPLENGTH, n_cl);
			parent->SetColor(COL_ARROW, n_col);
			parent->Command(CMD_ARROW_TYPE, &tmptype, 0L);
			bRet = true;
			}
		break;
	case 3:								//Cancel
		if(*Undo.pcb > undo_level) {	//restore plot order
			while(*Undo.pcb > undo_level)	Undo.Restore(false, 0L);
			bRet = true;
			}
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Box properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Box::PropertyDlg()
{
	TabSHEET tab1 = {0, 50, 10, "Size & Color"};
	TabSHEET tab2 = {50, 90, 10, "Edit"};
	char sTxt1[20], sTxt2[20];
	DlgInfo BoxDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to BOX", 130, 10, 55, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 130, 25, 55, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 130, 40, 55, 12},
		{4, 0, 5, CHECKED | ISPARENT, GROUP, 0L, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 115},
		{6, 0, 300, ISPARENT, SHEET, &tab2, 5, 10, 120, 115},
		{100, 105, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 8, 30, 90, 50},
		{105, 0, 109, CHECKED | ISPARENT, GROUP, 0L, 0, 0, 0, 0},
		{109, 110, 0, 0x0L, LTEXT, (void*)"bar width:", 10, 80, 45, 8},
		{110, 111, 0, 0x0L, RADIO1, (void*)" fixed", 20, 92, 25, 8},
		{111, 112, 0, 0x0L, EDTEXT, &sTxt1[1], 60, 92, 25, 10},
		{112, 113, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 87, 92, 20, 8},
		{113, 114, 0, 0x0L, RADIO1, (void*)" relative", 20, 104, 25, 8},
		{114, 115, 0, 0x0L, EDTEXT, &sTxt2[1], 60, 104, 25, 10},
		{115, 0, 0, 0x0L, LTEXT, (void*)"%", 87, 104, 10, 8},
		{300, 301, 0, 0x0L, RTEXT, (void*)"point 1 x", 15, 40, 28, 8},
		{301, 302, 0, 0x0L, EDVAL1, &pos1.fx, 46, 40, 35, 10},
		{302, 303, 0, 0x0L, RTEXT, (void*)"y", 15, 52, 28, 8},
		{303, 304, 0, 0x0L, EDVAL1, &pos1.fy, 46, 52, 35, 10},
		{304, 305, 0, 0x0L, RTEXT, (void*)"point 2 x", 15, 70, 28, 8},
		{305, 306, 0, 0x0L, EDVAL1, &pos2.fx, 46, 70, 35, 10},
		{306, 307, 0, 0x0L, RTEXT, (void*)"y", 15, 82, 28, 8},
		{307, 308, 0, 0x0L, EDVAL1, &pos2.fy, 46, 82, 35, 10},
		{308, 309, 0, HIDDEN, RTEXT, (void*)"box width", 15, 100, 28, 8},
		{309, 0, 0, HIDDEN | LASTOBJ, EDVAL1, &size, 46, 100, 35, 10},
		};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmpType = type;
	FillDEF newFill;
	LineDEF newLine, newHatchLine;
	DWORD undo_flags = 0L;
	lfPOINT n_pos;
	double tmpVal, o_size, n_size;
	bool bRet = false;
	GraphObj *ppar = parent;

	if(!parent) return false;
	memcpy(&newHatchLine, &Hatchline, sizeof(LineDEF));
	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)&Outline, 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)&Fill, 0);
	if(type & BAR_RELWIDTH) {
		WriteNatFloatToBuff(sTxt2, size);
		WriteNatFloatToBuff(sTxt1, defs.GetSize(SIZE_BAR));
		}
	else {
		WriteNatFloatToBuff(sTxt1, size);
		strcpy(sTxt2, " 50");
		}
	Dlg = new DlgRoot(BoxDlg);
	if(type & BAR_WIDTHDATA) {
		Dlg->ShowItem(105, false);
		Dlg->ShowItem(308, true);		Dlg->ShowItem(309, true);
		}
	if(type & BAR_RELWIDTH) Dlg->SetCheck(113, 0L, true);
	else Dlg->SetCheck(110, 0L, true);
	if(parent && parent->name) sprintf(TmpTxt, "Box of %s", parent->name);
	else strcpy(TmpTxt, "Box properties");
	Dlg->GetValue(309, &o_size);
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 390, 290, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 1:								//accept for this object
		case 2:								//   or all objects of plot
			OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
			OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&newFill, 0);
			if(newFill.hatch) memcpy(&newHatchLine, newFill.hatch, sizeof(LineDEF));
			newFill.hatch = &newHatchLine;
			if(type & BAR_WIDTHDATA) Dlg->GetValue(309, &size);
			else {
				if(Dlg->GetCheck(113)) {
					tmpType |= BAR_RELWIDTH;
					Dlg->GetValue(114, &n_size);
					}
				else {
					tmpType &= ~BAR_RELWIDTH;
					Dlg->GetValue(111, &n_size);
					}
				}
			break;
			}
		}while (res < 0);
	switch (res) {
	case 1:				//new setting for current box
		if(cmpLineDEF(&Outline, &newLine)) {
			Undo.Line(parent, &Outline, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&Outline, &newLine, sizeof(LineDEF));
			}
		if(newFill.type && cmpLineDEF(&Hatchline, &newHatchLine)) {
			Undo.Line(parent, &Hatchline, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&Hatchline, &newHatchLine, sizeof(LineDEF));
			}
		if(cmpFillDEF(&Fill, &newFill)) {
			Undo.Fill(parent, &Fill, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&Fill, &newFill, sizeof(FillDEF));
			}
		Fill.hatch = &Hatchline;
		if(Dlg->GetValue(301, &tmpVal)) n_pos.fx = tmpVal;
		else n_pos.fx = pos1.fx;
		if(Dlg->GetValue(303, &tmpVal)) n_pos.fy = tmpVal;
		else n_pos.fy = pos1.fy;
		undo_flags = CheckNewLFPoint(&pos1, &pos1, &n_pos, parent, undo_flags);
		if(Dlg->GetValue(305, &tmpVal)) n_pos.fx = tmpVal;
		else n_pos.fx = pos2.fx;
		if(Dlg->GetValue(307, &tmpVal)) n_pos.fy = tmpVal;
		else n_pos.fy = pos2.fy;
		undo_flags = CheckNewLFPoint(&pos2, &pos2, &n_pos, parent, undo_flags);
		undo_flags = CheckNewFloat(&size, o_size, n_size, parent, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bRet = true;
		break;
	case 2:				//new settings to all boxes of plot
		if(type != tmpType || Outline.width != newLine.width || o_size != n_size) {
			Undo.ValInt(this, &type, 0L);			//dummy: all following have UNDO_CONTINUE
			undo_flags |= UNDO_CONTINUE;
			if(parent->parent && parent->parent->Id == GO_STACKBAR) ppar = parent->parent;
			}
		else if(newLine.color != Outline.color || cmpFillDEF(&Fill, &newFill)) {
			Undo.ValInt(this, &type, 0L);			//dummy: all following have UNDO_CONTINUE
			}
		ppar->Command(CMD_SAVE_BARS_CONT, 0L, 0L);
		ppar->Command(CMD_BOX_TYPE, (void*)(& tmpType), 0L);
		ppar->SetSize(SIZE_BOX_LINE, newLine.width);
		ppar->SetSize(SIZE_BOX, n_size);
		parent->SetColor(COL_BOX_LINE, newLine.color);
		parent->Command(CMD_BOX_FILL, &newFill, 0L);
		bRet = true;
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Whisker properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Whisker::PropertyDlg()
{
	TabSHEET tab1 = {0, 38, 10, "Whisker"};
	TabSHEET tab2 = {65, 90, 10, "Edit"};
	TabSHEET tab3 = {38, 65, 10, "Style"};
	DlgInfo ErrDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to WHISKER", 100, 10, 64, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 100, 25, 64, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 100, 40, 64, 12},
		{4, 0, 5, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 90, 100},
		{6, 7, 500, ISPARENT, SHEET, &tab3, 5, 10, 90, 100},
		{7, 0, 300, ISPARENT, SHEET, &tab2, 5, 10, 90, 100},
		{100, 101, 0, 0x0L, RTEXT, (void*)"cap width", 15, 40, 28, 8},
		{101, 102, 0, 0x0L, EDVAL1, &size, 46, 40, 25, 10},
		{102, 103, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 40, 20, 8},
		{103, 104, 0, 0x0L, RTEXT, (void*)"line width", 15, 55, 28, 8},
		{104, 105, 0, 0x0L, EDVAL1, &LineDef.width, 46, 55, 25, 10},
		{105, 106, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 55, 20, 8},
		{106, 107, 0, 0x0L, RTEXT, (void*)"line color", 15, 70, 28, 8},
		{107, 0, 0, OWNDIALOG, COLBUTTON, (void *)LineDef.color, 46, 70, 25, 10},
		{300, 301, 0, 0x0L, RTEXT, (void*)"point 1 x", 15, 40, 28, 8},
		{301, 302, 0, 0x0L, EDVAL1, &pos1.fx, 46, 40, 35, 10},
		{302, 303, 0, 0x0L, RTEXT, (void*)"y", 15, 52, 28, 8},
		{303, 304, 0, 0x0L, EDVAL1, &pos1.fy, 46, 52, 35, 10},
		{304, 305, 0, 0x0L, RTEXT, (void*)"point 2 x", 15, 70, 28, 8},
		{305, 306, 0, 0x0L, EDVAL1, &pos2.fx, 46, 70, 35, 10},
		{306, 307, 0, 0x0L, RTEXT, (void*)"y", 15, 82, 28, 8},
		{307, 0, 0, 0x0L, EDVAL1, &pos2.fy, 46, 82, 35, 10},
		{500, 501, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_WhiskerTempl),32,40,18,18},
		{501, 502, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_WhiskerTempl), 14, 40, 18, 18},
		{502, 503, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_WhiskerTempl), 50, 40, 18, 18},
		{503, 504, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_WhiskerTempl), 68, 40, 18, 18},
		{504, 0, 0, LASTOBJ, LTEXT, (void*)"select style:", 14, 30, 30, 9}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmp_type;
	DWORD undo_flags = 0L, n_col = LineDef.color;
	lfPOINT n_pos;
	double tmpVal, o_size, n_size, o_lw, n_lw;
	bool bRet = false;

	if(!parent) return false;
	tmp_type = type;
	Dlg = new DlgRoot(ErrDlg);
	Dlg->SetCheck(500 + (tmp_type & 0x03), 0L, true);
	Dlg->GetValue(101, &o_size);		Dlg->GetValue(104, &o_lw);
	if(parent && parent->name) sprintf(TmpTxt, "Whisker of %s", parent->name);
	else strcpy(TmpTxt, "Whisker properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 339, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 500:	case 501:	case 502:	case 503:
			tmp_type &= ~0x0f;	tmp_type |= (res-500);	res = -1;
			break;
		case 1:								//accept for this object
		case 2:								//   or all objects of plot
			Dlg->GetValue(101, &n_size);		Dlg->GetValue(104, &n_lw);
			Dlg->GetColor(107, &n_col);
			break;
			}
		}while (res <0);
	switch (res) {
	case 1:				//new setting for current whisker
		if(Dlg->GetValue(301, &tmpVal)) n_pos.fx = tmpVal;
		else n_pos.fx = pos1.fx;
		if(Dlg->GetValue(303, &tmpVal)) n_pos.fy = tmpVal;
		else n_pos.fy = pos1.fy;
		undo_flags = CheckNewLFPoint(&pos1, &pos1, &n_pos, parent, undo_flags);
		if(Dlg->GetValue(305, &tmpVal)) n_pos.fx = tmpVal;
		else n_pos.fx = pos2.fx;
		if(Dlg->GetValue(307, &tmpVal)) n_pos.fy = tmpVal;
		else n_pos.fy = pos2.fy;
		undo_flags = CheckNewLFPoint(&pos2, &pos2, &n_pos, parent, undo_flags);
		undo_flags = CheckNewFloat(&size, o_size, n_size, parent, undo_flags);
		undo_flags = CheckNewInt(&type, type, tmp_type, parent, undo_flags);
		undo_flags = CheckNewFloat(&LineDef.width, o_lw, n_lw, parent, undo_flags);
		undo_flags = CheckNewDword(&LineDef.color, LineDef.color, n_col, parent, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bRet = true;
		break;
	case 2:				//new settings to all whiskers of plot
		if(o_size == n_size && type == tmp_type && o_lw == n_lw 
			&& n_col == LineDef.color) break;
		parent->Command(CMD_SAVE_ERRS, 0L, 0L);
		parent->SetSize(SIZE_WHISKER, n_size);
		parent->SetSize(SIZE_WHISKER_LINE, n_lw);
		parent->SetColor(COL_WHISKER, n_col);
		parent->Command(CMD_WHISKER_STYLE, &tmp_type, 0L);
		bRet = true;
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Drop line properties
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
DropLine::PropertyDlg()
{
	TabSHEET tab1 = {0, 21, 10, "Line"};
	TabSHEET tab2 = {21, 42, 10, "Edit"};
	DlgInfo LineDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to LINE", 150, 10, 50, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 150, 25, 50, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 40, 50, 12},
		{4, 300, 10, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{10, 11, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 139, 120},
		{11, 0, 200, ISPARENT, SHEET, &tab2, 5, 10, 139, 120},
		{100, 0, 0, NOSELECT, ODBUTTON, (void*)OD_linedef, 10, 38, 130, 100},
		{200, 201, 0, 0x0L, RTEXT, (void*)"x-value", 35, 40, 28, 8},
		{201, 202, 0, 0x0L, EDVAL1, &fPos.fx, 76, 40, 35, 10},
		{202, 203, 0, 0x0L, RTEXT, (void*)"y-value", 35, 52, 28, 8},
		{203, 204, 0, 0x0L, EDVAL1, &fPos.fy, 76, 52, 35, 10},
		{204, 0, 250, CHECKED | ISPARENT, GROUPBOX, (void*)" Shape ", 10, 70, 129, 50},
		{250, 251, 0, 0x0L, RTEXT, (void*)"line to:", 15, 80, 28, 8},
		{251, 252, 0, 0x0L, CHECKBOX, (void*)"left", 46, 80, 35, 8},
		{252, 253, 0, 0x0L, CHECKBOX, (void*)"right", 46, 90, 35, 8},
		{253, 254, 0, 0x0L, CHECKBOX, (void*)"y-axis", 46, 100, 35, 8},
		{254, 255, 0, 0x0L, CHECKBOX, (void*)"top", 86, 80, 35, 8},
		{255, 256, 0, 0x0L, CHECKBOX, (void*)"bottom", 86, 90, 35, 8},
		{256, 0, 0, LASTOBJ, CHECKBOX, (void*)"x-axis", 86, 100, 35, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmptype;
	bool bRet = false;
	LineDEF newLine;
	DWORD undo_flags = 0L;
	lfPOINT o_pos, n_pos;

	if(!parent) return false;
	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&LineDef, 0);
	Dlg = new DlgRoot(LineDlg);
	Dlg->SetCheck(251, 0L, type & DL_LEFT ? true : false);
	Dlg->SetCheck(252, 0L, type & DL_RIGHT ? true : false);
	Dlg->SetCheck(253, 0L, type & DL_YAXIS ? true : false);
	Dlg->SetCheck(254, 0L, type & DL_TOP ? true : false);
	Dlg->SetCheck(255, 0L, type & DL_BOTTOM ? true : false);
	Dlg->SetCheck(256, 0L, type & DL_XAXIS ? true : false);
	Dlg->GetValue(201, &o_pos.fx);		Dlg->GetValue(203, &o_pos.fy);
	if(parent->name) sprintf(TmpTxt, "Dropline of %s", parent->name);
	else strcpy(TmpTxt, "Dropline properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 415, 300, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 1:							//this line
		case 2:							//all lines of plot
			tmptype = 0;
			if(Dlg->GetCheck(251)) tmptype |= DL_LEFT;
			if(Dlg->GetCheck(252)) tmptype |= DL_RIGHT;
			if(Dlg->GetCheck(253)) tmptype |= DL_YAXIS;
			if(Dlg->GetCheck(254)) tmptype |= DL_TOP;
			if(Dlg->GetCheck(255)) tmptype |= DL_BOTTOM;
			if(Dlg->GetCheck(256)) tmptype |= DL_XAXIS;
			OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
			break;
			}
		}while (res < 0);
	if(res == 1){						//Apply to line
		if(cmpLineDEF(&LineDef, &newLine)) {
			Undo.Line(this, &LineDef, undo_flags);
			memcpy(&LineDef, &newLine, sizeof(LineDEF));
			undo_flags |= UNDO_CONTINUE;
			}
		Dlg->GetValue(201, &n_pos.fx);		Dlg->GetValue(203, &n_pos.fy);
		undo_flags = CheckNewLFPoint(&fPos, &o_pos, &n_pos, this, undo_flags);
		undo_flags = CheckNewInt(&type, type, tmptype, this, undo_flags);
		if (undo_flags & UNDO_CONTINUE) bModified = true;
		bRet = true;
		}
	else if(res == 2) {					//Apply to plot
		if(cmpLineDEF(&LineDef, &newLine) || type != tmptype) {
			parent->Command(CMD_SAVE_DROPLINES, 0L, 0L);
			if(cmpLineDEF(&LineDef, &newLine)) parent->Command(CMD_DL_LINE, (void*)&newLine, 0L);
			if(type != tmptype) parent->Command(CMD_DL_TYPE, (void*)(&tmptype), 0L);
			bRet = true;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Drop line properties: DropLine 3D
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
DropLine3D::PropertyDlg()
{
	TabSHEET tab1 = {0, 21, 10, "Line"};
	TabSHEET tab2 = {21, 42, 10, "Edit"};
	DlgInfo LineDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to LINE", 150, 10, 50, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 150, 25, 50, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 40, 50, 12},
		{4, 300, 10, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{10, 11, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 139, 120},
		{11, 0, 200, ISPARENT, SHEET, &tab2, 5, 10, 139, 120},
		{100, 0, 0, NOSELECT, ODBUTTON, (void*)OD_linedef, 10, 38, 130, 100},
		{200, 201, 0, 0x0L, RTEXT, (void*)"x-value", 35, 30, 28, 8},
		{201, 202, 0, 0x0L, EDVAL1, &fPos.fx, 76, 30, 35, 10},
		{202, 203, 0, 0x0L, RTEXT, (void*)"y-value", 35, 42, 28, 8},
		{203, 204, 0, 0x0L, EDVAL1, &fPos.fy, 76, 42, 35, 10},
		{204, 205, 0, 0x0L, RTEXT, (void*)"z-value", 35, 54, 28, 8},
		{205, 240, 0, 0x0L, EDVAL1, &fPos.fz, 76, 54, 35, 10},
		{240, 0, 250, CHECKED | ISPARENT, GROUPBOX, (void*)" Shape ", 10, 70, 129, 50},
		{250, 251, 0, 0x0L, RTEXT, (void*)"line to:", 15, 80, 28, 8},
		{251, 252, 0, 0x0L, CHECKBOX, (void*)"bottom", 46, 80, 35, 8},
		{252, 253, 0, 0x0L, CHECKBOX, (void*)"top", 86, 80, 35, 8},
		{253, 254, 0, 0x0L, CHECKBOX, (void*)"back", 46, 90, 35, 8},
		{254, 255, 0, 0x0L, CHECKBOX, (void*)"front", 86, 90, 35, 8},
		{255, 256, 0, 0x0L, CHECKBOX, (void*)"left", 46, 100, 35, 8},
		{256, 0, 0, LASTOBJ, CHECKBOX, (void*)"right", 86, 100, 35, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmptype, i;
	bool bRet = false;
	LineDEF newLine;
	DWORD undo_flags = 0L;
	fPOINT3D o_pos, n_pos;

	if(!parent) return false;
	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&Line, 0);
	Dlg = new DlgRoot(LineDlg);
	for(i = 0; i < 6; i++) {
		Dlg->SetCheck(251+i, 0L, (type & (1<<i)) ? true : false);
		}
	Dlg->GetValue(201, &o_pos.fx);		Dlg->GetValue(203, &o_pos.fy);
	Dlg->GetValue(205, &o_pos.fz);
	if(parent->name) sprintf(TmpTxt, "Dropline of %s", parent->name);
	else strcpy(TmpTxt, "Dropline properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 415, 300, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 1:							//this line
		case 2:							//all lines of plot
			OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
			for(i = tmptype = 0; i < 6; i++) {
				tmptype |= Dlg->GetCheck(251+i) ? 1<<i : 0;
				}
			break;
			}
		}while (res < 0);
	if(res == 1){						//Apply to line
		if(cmpLineDEF(&Line, &newLine)) {
			Undo.Line(this, &Line, undo_flags);
			memcpy(&Line, &newLine, sizeof(LineDEF));
			undo_flags |= UNDO_CONTINUE;
			}
		Dlg->GetValue(201, &n_pos.fx);		Dlg->GetValue(203, &n_pos.fy);
		Dlg->GetValue(205, &n_pos.fz);
		if(n_pos.fx != o_pos.fx || n_pos.fy != o_pos.fy || n_pos.fz != o_pos.fz) {
			Undo.ValLFP3D(this, &fPos, undo_flags);
			memcpy(&fPos, &n_pos, sizeof(fPOINT3D));
			undo_flags |= UNDO_CONTINUE;
			}
		undo_flags = CheckNewInt(&type, type, tmptype, this, undo_flags);
		if (undo_flags & UNDO_CONTINUE) bModified = true;
		bRet = true;
		}
	else if(res == 2) {					//Apply to plot
		if(cmpLineDEF(&Line, &newLine) || type != tmptype) {
			parent->Command(CMD_SAVE_DROPLINES, 0L, 0L);
			if(cmpLineDEF(&Line, &newLine)) parent->Command(CMD_DL_LINE, (void*)&newLine, 0L);
			if(type != tmptype) parent->Command(CMD_DL_TYPE, (void*)(&tmptype), 0L);
			bRet = true;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// sphere (ball) properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Sphere::PropertyDlg()
{
	TabSHEET tab1 = {0, 22, 10, "Ball"};
	TabSHEET tab2 = {22, 45, 10, "Edit"};
	FillDEF newFill;
	char *type_text[] = {Units[defs.cUnits].display, "[x-data]", "[y-data]", "[z-data]"};
	DlgInfo BallDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to BALL", 110, 10, 50, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 110, 25, 50, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 110, 40, 50, 12},
		{4, 0, 10, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{10, 11, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 100, 80},
		{11, 0, 200, ISPARENT, SHEET, &tab2, 5, 10, 100, 80},
		{100, 101, 0, 0x0L, RTEXT, (void*)"ball size", 15, 35, 28, 8},
		{101, 102, 0, 0x0L, EDVAL1, &size, 46, 35, 25, 10},
		{102, 103, 0, 0x0L, LTEXT, (void*)type_text[type], 73, 35, 15, 8},
		{103, 104, 0, 0x0L, RTEXT, (void*)"line width", 15, 47, 28, 8},
		{104, 105, 0, 0x0L, EDVAL1, &Line.width, 46, 47, 25, 10},
		{105, 106, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 73, 47, 15, 8},
		{106, 107, 0, 0x0L, RTEXT, (void*)"line color", 15, 59, 28, 8},
		{107, 108, 0, OWNDIALOG, COLBUTTON, (void *)Line.color, 46, 59, 25, 10},
		{108, 109, 0, 0x0L, RTEXT, (void*)"fill color", 15, 71, 28, 8},
		{109, 0, 0, OWNDIALOG, SHADE3D, &newFill, 46, 71, 25, 10},
		{200, 201, 0, 0x0L, RTEXT, (void*)"x-value", 15, 35, 28, 8},
		{201, 202, 0, 0x0L, EDVAL1, &fPos.fx, 46, 35, 35, 10},
		{202, 203, 0, 0x0L, RTEXT, (void*)"y-value", 15, 47, 28, 8},
		{203, 204, 0, 0x0L, EDVAL1, &fPos.fy, 46, 47, 35, 10},
		{204, 205, 0, 0x0L, RTEXT, (void*)"z-value", 15, 59, 28, 8},
		{205, 0, 0, LASTOBJ, EDVAL1, &fPos.fz, 46, 59, 35, 10}};
	DlgRoot *Dlg;
	void *hDlg;
	int res;
	bool bRet = false, bContinue = false;
	fPOINT3D n_pos, o_pos;
	DWORD new_lcolor = Line.color, undo_flags = 0L;
	double o_size, n_size, o_lsize, n_lsize;

	if(!parent) return false;
	memcpy(&newFill, &Fill, sizeof(FillDEF));
	Dlg = new DlgRoot(BallDlg);
	Dlg->GetValue(201, &o_pos.fx);			Dlg->GetValue(203, &o_pos.fy);
	Dlg->GetValue(205, &o_pos.fz);			Dlg->GetValue(101, &o_size);
	Dlg->GetValue(104, &o_lsize);
	if(parent->name) sprintf(TmpTxt, "Ball of %s", parent->name);
	else strcpy(TmpTxt, "Ball properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 335, 216, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:
			if(bContinue) res = -1;
			bContinue = false;
			break;
		case 1:		case 2:
			Dlg->GetColor(107, &new_lcolor);	Dlg->GetValue(101, &n_size);
			Dlg->GetValue(104, &n_lsize);
			break;
		case 109:
			Dlg->DoPlot(0L);
			bContinue = true;
			break;
			}
		}while (res < 0);
	if(res == 1){
		Dlg->GetValue(201, &n_pos.fx);		Dlg->GetValue(203, &n_pos.fy);
		Dlg->GetValue(205, &n_pos.fz);
		if(n_pos.fx != o_pos.fx || n_pos.fy != o_pos.fy || n_pos.fz != o_pos.fz) {
			Undo.ValLFP3D(this, &fPos, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&fPos, &n_pos, sizeof(fPOINT3D));	parent->Command(CMD_MRK_DIRTY, 0L, 0L);
			}
		undo_flags = CheckNewFloat(&size, o_size, n_size, this, undo_flags);
		undo_flags = CheckNewFloat(&Line.width, o_lsize, n_lsize, this, undo_flags);
		undo_flags = CheckNewDword(&Line.color, Line.color, new_lcolor, this, undo_flags);
		undo_flags = CheckNewDword(&Fill.color, Fill.color, newFill.color, this, undo_flags);
		undo_flags = CheckNewDword(&Fill.color2, Fill.color2, newFill.color2, this, undo_flags);
		undo_flags = CheckNewInt(&Fill.type, Fill.type, newFill.type, this, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bRet = bModified = true;
		}
	else if(res == 2) {
		if(cmpFillDEF(&Fill, &newFill) || n_size != o_size || n_lsize != o_lsize ||
			new_lcolor != Line.color) {
			parent->Command(CMD_SAVE_SYMBOLS, 0L, 0L);
			if(cmpFillDEF(&Fill, &newFill)) parent->Command(CMD_SYM_FILL, &newFill, 0L);
			if(n_size != o_size) parent->SetSize(SIZE_SYMBOL, n_size);
			if(n_lsize != o_lsize) parent->SetSize(SIZE_SYM_LINE, n_lsize);
			if(new_lcolor != Line.color) parent->SetColor(COL_SYM_LINE, new_lcolor);
			bRet = true;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// properties of 3D plane
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Plane3D::PropertyDlg()
{
	TabSHEET tab1 = {0, 27, 10, "Plane"};
	double rb_width = 0.0, rb_z = 0.0;
	FillDEF newFill;
	DlgInfo PlaneDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to PLANE", 115, 10, 55, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 115, 25, 55, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 115, 40, 55, 12},
		{4, 0, 10, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{10, 0, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 105, 85},
		{100, 101, 0, 0x0L, RTEXT, (void*)"line width", 15, 30, 36, 8},
		{101, 102, 0, 0x0L, EDVAL1, &Line.width, 53, 30, 25, 10},
		{102, 103, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 80, 30, 15, 8},
		{103, 104, 0, 0x0L, RTEXT, (void*)"line color", 15, 42, 36, 8},
		{104, 105, 0, OWNDIALOG, COLBUTTON, (void *)Line.color, 53, 42, 25, 10},
		{105, 106, 0, 0x0L, RTEXT, (void*)"fill color", 15, 54, 36, 8},
		{106, 200, 0, OWNDIALOG, SHADE3D, &newFill, 53, 54, 25, 10},
		{200, 0, 201, CHECKED, GROUP, NULL, 0, 0, 0, 0},
		{201, 202, 0, 0x0L, RTEXT, (void*)"ribbon width", 15, 66, 36, 8},
		{202, 203, 0, 0x0L, INCDECVAL1, &rb_width, 53, 66, 25, 10},
		{203, 204, 0, 0x0L, LTEXT, (void*)"%", 80, 66, 5, 8},
		{204, 205, 0, 0x0L, RTEXT, (void*)"ribbon pos.", 15, 78, 36, 8},
		{205, 206, 0, 0x0L, EDVAL1, &rb_z, 53, 78, 25, 10},
		{206, 0, 0, 0x0L, LTEXT, (void*)"[z-data]", 80, 78, 40, 8},
		{800, 0, 0, LASTOBJ, 0L, 0, 0, 0, 0}};
	DlgRoot *Dlg;
	void *hDlg;
	int res;
	bool bRet = false;
	DWORD new_lcolor = Line.color, undo_flags = 0L;
	double o_lsize, n_lsize, o_rbw, n_rbw, o_rbz, n_rbz;

	if(!parent) return false;
	memcpy(&newFill, &Fill, sizeof(FillDEF));
	if(parent->Id == GO_RIBBON && parent->type == 1) {
		rb_width = parent->GetSize(SIZE_CELLWIDTH) *100.0;
		rb_z = parent->GetSize(SIZE_ZPOS);
		}
	Dlg = new DlgRoot(PlaneDlg);
	Dlg->GetValue(101, &o_lsize);		Dlg->GetValue(202, &o_rbw);
	Dlg->GetValue(205, &o_rbz);
	if(parent->name) sprintf(TmpTxt, "Plane of %s", parent->name);
	else strcpy(TmpTxt, "Plane properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 355, 226, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 1:		case 2:
			Dlg->GetColor(104, &new_lcolor);	Dlg->GetValue(101, &n_lsize);		Dlg->GetValue(202, &n_rbw);
			Dlg->GetValue(205, &n_rbz);
			break;
			}
		}while (res < 0);
	if(res == 1){
		undo_flags = CheckNewFloat(&Line.width, o_lsize, n_lsize, this, undo_flags);
		undo_flags = CheckNewDword(&Line.color, Line.color, new_lcolor, this, undo_flags);
		undo_flags = CheckNewDword(&Fill.color, Fill.color, newFill.color, this, undo_flags);
		undo_flags = CheckNewDword(&Fill.color2, Fill.color2, newFill.color2, this, undo_flags);
		undo_flags = CheckNewInt(&Fill.type, Fill.type, newFill.type, this, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bRet = true;
		}
	else if(res == 2) {
		if(cmpFillDEF(&Fill, &newFill) || n_lsize != o_lsize || new_lcolor != Line.color ||
			o_rbw != n_rbw || o_rbz != n_rbz) {
			parent->Command(CMD_SAVE_SYMBOLS, 0L, 0L);
			if(cmpFillDEF(&Fill, &newFill)) parent->Command(CMD_SYM_FILL, &newFill, 0L);
			if(n_lsize != o_lsize) parent->SetSize(SIZE_SYM_LINE, n_lsize);
			if(new_lcolor != Line.color) parent->SetColor(COL_POLYLINE, new_lcolor);
			if(parent->Id == GO_RIBBON && parent->type == 1) {
				if(o_rbw != n_rbw) parent->SetSize(SIZE_CELLWIDTH, n_rbw/100.0);
				if(o_rbz != n_rbz) parent->SetSize(SIZE_ZPOS, n_rbz);
				}
			bRet = true;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// properties of 3D column
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Brick::PropertyDlg()
{
	TabSHEET tab1 = {0, 50, 10, "Size & Color"};
//	TabSHEET tab2 = {50, 90, 10, "Baseline"};
	TabSHEET tab3 = {50, 80, 10, "Edit"};
	FillDEF newFill;
	DlgInfo ColumnDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to COLUMN", 130, 10, 65, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 130, 25, 65, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 130, 40, 65, 12},
		{4, 0, 5, CHECKED | ISPARENT, GROUP, NULL, 138, 40, 55, 12},
		{5, 7, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 120},
//		{6, 7, 0, ISPARENT, SHEET, &tab2, 5, 10, 120, 120},
		{7, 0, 300, ISPARENT, SHEET, &tab3, 5, 10, 120, 120},
		{100, 101, 0, 0x0L, RTEXT, (void*)"outline width", 18, 30, 40, 8},
		{101, 102, 0, 0x0L, EDVAL1, &Line.width, 60, 30, 25, 10},
		{102, 103, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 87, 30, 20, 8},
		{103, 104, 0, 0x0L, RTEXT, (void*)"outline color", 18, 42, 40, 8},
		{104, 105, 0, OWNDIALOG, COLBUTTON, (void *)Line.color, 60, 42, 25, 10},
		{105, 106, 0, 0x0L, RTEXT,(void*)"fill color" , 18, 54, 40, 8},
		{106, 107, 0, OWNDIALOG, SHADE3D, &newFill, 60, 54, 25, 10},
		{107, 108, 0, 0x0L, RTEXT, (void*)"column width", 18, 74, 40, 8},
		{108, 109, 0, 0x0L, EDVAL1, &width, 60, 74, 25, 10},
		{109, 110, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 87, 74, 20, 8},
		{110, 111, 0, 0x0L, RTEXT, (void*)"column depth", 18, 86, 40, 8},
		{111, 112, 0, 0x0L, EDVAL1, &depth, 60, 86, 25, 10},
		{112, 0, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 87, 86, 20, 8},
		{300, 301, 0, 0x0L, RTEXT, (void*)"x-value", 10, 30, 35, 8},
		{301, 302, 0, 0x0L, EDVAL1, &fPos.fx, 50, 30, 30, 10},
		{302, 303, 0, 0x0L, RTEXT, (void*)"base (y)", 10, 75, 35, 8},
		{303, 304, 0, 0x0L, EDVAL1, &fPos.fy, 50, 75, 30, 10},
		{304, 305, 0, 0x0L, RTEXT, (void*)"z-value", 10, 42, 35, 8},
		{305, 306, 0, 0x0L, EDVAL1, &fPos.fz, 50, 42, 30, 10},
		{306, 307, 0, 0x0L, RTEXT, (void*)"height", 10, 87, 35, 8},
		{307, 0, 0, LASTOBJ, EDVAL1, &height, 50, 87, 30, 10}};
	DlgRoot *Dlg;
	void *hDlg;
	int res;
	bool bRet = false;
	DWORD col1 = Line.color, undo_flags = 0L;
	double o_lw = Line.width, n_lw, o_height = height, n_height, o_width = width, n_width;
	double o_depth = depth, n_depth;
	fPOINT3D o_pos, n_pos;

	if(!parent) return false;
	memcpy(&newFill, &Fill, sizeof(FillDEF));
	Dlg = new DlgRoot(ColumnDlg);
	Dlg->GetValue(101, &o_lw);		Dlg->GetValue(301, &o_pos.fx);
	Dlg->GetValue(303, &o_pos.fy);	Dlg->GetValue(305, &o_pos.fz);
	Dlg->GetValue(307, &o_height);	Dlg->GetValue(108, &o_width);
	Dlg->GetValue(111, &o_depth);
	memcpy(&n_pos, &o_pos, sizeof(fPOINT3D));
	if(parent->name) sprintf(TmpTxt, "Column of %s", parent->name);
	else strcpy(TmpTxt, "Column properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 405, 296, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 1:
		case 2:
			Dlg->GetColor(104, &col1);
			Dlg->GetValue(101, &n_lw);		Dlg->GetValue(301, &n_pos.fx);
			Dlg->GetValue(303, &n_pos.fy);	Dlg->GetValue(305, &n_pos.fz);
			Dlg->GetValue(307, &n_height);	Dlg->GetValue(108, &n_width);
			Dlg->GetValue(111, &n_depth);
			break;
			}
		}while (res < 0);
	switch (res) {
	case 1:				//new setting for current column only
		undo_flags = CheckNewFloat(&Line.width, o_lw, n_lw, this, undo_flags);
		undo_flags = CheckNewDword(&Line.color, Line.color, col1, this, undo_flags);
		undo_flags = CheckNewDword(&Fill.color, Fill.color, newFill.color, this, undo_flags);
		undo_flags = CheckNewDword(&Fill.color2, Fill.color2, newFill.color2, this, undo_flags);
		undo_flags = CheckNewInt(&Fill.type, Fill.type, newFill.type, this, undo_flags);
		if(o_pos.fx != n_pos.fx || o_pos.fy != n_pos.fy || o_pos.fz != n_pos.fz) {
			Undo.ValLFP3D(this, &fPos, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&fPos, &n_pos, sizeof(fPOINT3D));	parent->Command(CMD_MRK_DIRTY, 0L, 0L);
			}
		undo_flags = CheckNewFloat(&height, o_height, n_height, this, undo_flags);
		if(o_height != n_height) parent->Command(CMD_MRK_DIRTY, 0L, 0L);
		undo_flags = CheckNewFloat(&width, o_width, n_width, this, undo_flags);
		undo_flags = CheckNewFloat(&depth, o_depth, n_depth, this, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bModified = bRet = true;
		break;
	case 2:
		if(cmpFillDEF(&Fill, &newFill) || o_lw != n_lw || Line.color != col1 ||
			o_pos.fy != n_pos.fy || n_width != o_width || o_depth != n_depth) {
			parent->Command(CMD_SAVE_BARS, 0L, 0L);
			if(o_pos.fy != n_pos.fy){
				parent->Command(CMD_MRK_DIRTY, 0L, 0L);
				parent->SetSize(SIZE_BAR_BASE, n_pos.fy);
				}
			if(n_lw != o_lw) parent->SetSize(SIZE_BAR_LINE, n_lw);
			if(n_width != o_width) parent->SetSize(SIZE_BAR, n_width);
			if(o_depth != n_depth) parent->SetSize(SIZE_BAR_DEPTH, n_depth);
			if(Line.color != col1) parent->SetColor(COL_BAR_LINE, col1);
			if(cmpFillDEF(&Fill, &newFill)) parent->Command(CMD_BAR_FILL, &newFill, 0L);
			bRet = true;
			}
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Properties of arrow in 3D space
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Arrow3D::PropertyDlg()
{
	TabSHEET tab1 = {0, 29, 10, "Arrow"};
	TabSHEET tab2 = {29, 59, 10, "Type"};
	TabSHEET tab3 = {59, 90, 10, "Edit"};
	DlgInfo ArrowDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to ARROW", 100, 10, 57, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 100, 25, 57, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 100, 40, 57, 12},
		{4, 0, 5, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 90, 100},
		{6, 7, 200, ISPARENT, SHEET, &tab2, 5, 10, 90, 100},
		{7, 0, 300, ISPARENT, SHEET, &tab3, 5, 10, 90, 100},
		{100, 101, 0, 0x0L, RTEXT, (void*)"cap width", 15, 40, 28, 8},
		{101, 102, 0, 0x0L, EDVAL1, &cw, 46, 40, 25, 10},
		{102, 103, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 40, 20, 8},
		{103, 104, 0, 0x0L, RTEXT, (void*)"length", 15, 52, 28, 8},
		{104, 105, 0, 0x0L, EDVAL1, &cl, 46, 52, 25, 10},
		{105, 106, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 52, 20, 8},
		{106, 107, 0, 0x0L, RTEXT, (void*)"line width", 15, 70, 28, 8},
		{107, 108, 0, 0x0L, EDVAL1, &Line.width, 46, 70, 25, 10},
		{108, 109, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 73, 70, 20, 8},
		{109, 110, 0, 0x0L, RTEXT, (void*)"color", 15, 82, 28, 8},
		{110, 0, 0, OWNDIALOG, COLBUTTON, (void *)Line.color, 46, 82, 25, 10},
		{200, 201, 0, TOUCHEXIT, RADIO1, (void*)"line only", 15, 40, 60, 8},
		{201, 202, 0, TOUCHEXIT, RADIO1, (void*)"arrow with lines", 15, 55, 60, 8},
		{202, 0, 0, TOUCHEXIT, RADIO1, (void*)"filled arrow", 15, 70, 60, 8},
		{300, 301, 0, 0x0L, RTEXT, (void*)"x-value", 10, 25, 28, 8},
		{301, 302, 0, 0x0L, EDVAL1, &fPos2.fx, 46, 25, 35, 10},
		{302, 303, 0, 0x0L, RTEXT, (void*)"y-value", 10, 36, 28, 8},
		{303, 304, 0, 0x0L, EDVAL1, &fPos2.fy, 46, 36, 35, 10},
		{304, 305, 0, 0x0L, RTEXT, (void*)"z-value", 10, 47, 28, 8},
		{305, 306, 0, 0x0L, EDVAL1, &fPos2.fz, 46, 47, 35, 10},
		{306, 307, 0, 0x0L, RTEXT, (void*)"origin x", 10, 60, 28, 8},
		{307, 308, 0, 0x0L, EDVAL1, &fPos1.fx, 46, 60, 35, 10},
		{308, 309, 0, 0x0L, RTEXT, (void*)" y", 10, 71, 28, 8},
		{309, 310, 0, 0x0L, EDVAL1, &fPos1.fy, 46, 71, 35, 10},
		{310, 311, 0, 0x0L, RTEXT, (void*)" z", 10, 82, 28, 8},
		{311, 312, 0, 0x0L, EDVAL1, &fPos1.fz, 46, 82, 35, 10},
		{312, 0, 0, LASTOBJ, CHECKBOX, (void*)"set common origin", 16, 95, 70, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	fPOINT3D o_pos1, o_pos2, n_pos1, n_pos2;
	double o_cw, o_cl, n_cw, n_cl, o_lw, n_lw;
	int res, tmptype = type, undo_level = *Undo.pcb;
	bool bRet = false;
	DWORD o_col, n_col, undo_flags = 0L;

	if(!parent) return false;
	if(!(Dlg = new DlgRoot(ArrowDlg))) return false;
	Dlg->GetValue(301, &o_pos2.fx);		Dlg->GetValue(303, &o_pos2.fy);
	Dlg->GetValue(305, &o_pos2.fz);		Dlg->GetValue(307, &o_pos1.fx);
	Dlg->GetValue(309, &o_pos1.fy);		Dlg->GetValue(311, &o_pos1.fz);
	Dlg->GetValue(101, &o_cw);			Dlg->GetValue(104, &o_cl);
	Dlg->GetValue(107, &o_lw);			Dlg->GetColor(110, &o_col);
	switch(type & 0xff) {
	case ARROW_LINE:		Dlg->SetCheck(201, 0L, true);		break;
	case ARROW_TRIANGLE:	Dlg->SetCheck(202, 0L, true);		break;
	default:				Dlg->SetCheck(200, 0L, true);		break;
		}
	if(parent->name) sprintf(TmpTxt, "Arrow of %s", parent->name);
	else strcpy(TmpTxt, "Arrow properties");
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 328, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 200:	tmptype = ARROW_NOCAP;		res = -1;	break;
		case 201:	tmptype = ARROW_LINE;		res = -1;	break;
		case 202:	tmptype = ARROW_TRIANGLE;	res = -1;	break;
		case 1:		case 2:
			Dlg->GetValue(301, &n_pos2.fx);		Dlg->GetValue(303, &n_pos2.fy);
			Dlg->GetValue(305, &n_pos2.fz);		Dlg->GetValue(307, &n_pos1.fx);
			Dlg->GetValue(309, &n_pos1.fy);		Dlg->GetValue(311, &n_pos1.fz);
			Dlg->GetValue(101, &n_cw);			Dlg->GetValue(104, &n_cl);
			Dlg->GetValue(107, &n_lw);			Dlg->GetColor(110, &n_col);
			break;
			}
		}while (res <0);
	switch (res) {
	case 1:				//new setting for current arrow
		if(n_pos1.fx != o_pos1.fx || n_pos1.fy != o_pos1.fy ||
			n_pos1.fz != o_pos1.fz){
			Undo.ValLFP3D(this, &fPos1, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&fPos1, &n_pos1, sizeof(fPOINT3D));
			parent->Command(CMD_MRK_DIRTY, 0L, 0L);
			}
		if(n_pos2.fx != o_pos2.fx || n_pos2.fy != o_pos2.fy ||
			n_pos2.fz != o_pos2.fz){
			Undo.ValLFP3D(this, &fPos2, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&fPos2, &n_pos2, sizeof(fPOINT3D));
			parent->Command(CMD_MRK_DIRTY, 0L, 0L);
			}
		if((type & 0xff) != (tmptype & 0xff)){
			Undo.ValInt(this, &type, undo_flags);
			type &= ~0xff;	type |= (tmptype & 0xff);	undo_flags |= UNDO_CONTINUE;
			}
		undo_flags = CheckNewFloat(&cw, o_cw, n_cw, this, undo_flags);
		undo_flags = CheckNewFloat(&cl, o_cl, n_cl, this, undo_flags);
		undo_flags = CheckNewFloat(&Line.width, o_lw, n_lw, this, undo_flags);
		undo_flags = CheckNewDword(&Line.color, o_col, n_col, this, undo_flags);
		if(undo_flags & UNDO_CONTINUE) bModified = true;
		bRet = true;
		break;
	case 2:				//new settings to all arrows of plot
		if(parent->Id >= GO_PLOT && parent->Id < GO_GRAPH && (Dlg->GetCheck(312) || n_lw != o_lw
			|| n_cw != o_cw || n_cl != o_cl || o_col != n_col || type != tmptype)) {
			parent->Command(CMD_SAVE_ARROWS, 0L, 0L);
			if(Dlg->GetCheck(312)) parent->Command(CMD_ARROW_ORG3D, &n_pos1, 0L);
			if(n_lw != o_lw) parent->SetSize(SIZE_ARROW_LINE, n_lw);
			if(n_cw != o_cw) parent->SetSize(SIZE_ARROW_CAPWIDTH, n_cw);
			if(n_cl != o_cl) parent->SetSize(SIZE_ARROW_CAPLENGTH, n_cl);
			if(o_col != n_col) parent->SetColor(COL_ARROW, n_col);
			if(type != tmptype) parent->Command(CMD_ARROW_TYPE, &tmptype, 0L);
			bRet = true;
			}
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// properties of 3D data line
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Line3D::PropertyDlg()
{
	TabSHEET tab1 = {0, 40, 10, "Line"};
	DlgInfo LineDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 150, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 0, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 139, 130},
		{100, 0, 0, LASTOBJ | NOSELECT, ODBUTTON, (void*)OD_linedef, 10, 30, 130, 90}};
	DlgRoot *Dlg;
	void *hDlg;
	int res;
	bool bRet = false;
	LineDEF newLine;

	if(!parent) return false;
	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&Line, 0);
	if(!(Dlg = new DlgRoot(LineDlg)))return false;
	hDlg = CreateDlgWnd("line properties", 50, 50, 410, 314, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
	}while (res < 0);
	switch(res) {
	case 1:							//OK pressed
		OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
		if(cmpLineDEF(&Line, &newLine)) {
			Undo.Line(this, &Line, 0L);
			memcpy(&Line, &newLine, sizeof(LineDEF));
			bModified = true;
			}
		bRet = true;
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// label (text) properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Label::PropertyDlg()
{
	TabSHEET tab1 = {0, 27, 10, "Label"};
	TabSHEET tab2 = {27, 75, 10, "Font & Style"};
	TabSHEET tab3 = {75, 110, 10, "Position"};
	DlgInfo LabelDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 150, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 25, 45, 12},
		{3, 50, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 139, 100},
		{5, 6, 200, ISPARENT, SHEET, &tab2, 5, 10, 139, 100},
		{6, 0, 300, ISPARENT, SHEET, &tab3, 5, 10, 139, 100},
		{50, 0, 600, ISPARENT | CHECKED | HIDDEN, GROUP, 0L, 0, 0, 0, 0},
		{100, 101, 0, 0x0L, RTEXT, (void*)"size", 10, 33, 45, 8},
		{101, 102, 0, 0x0L, EDVAL1, &TextDef.fSize, 60, 33, 25, 10},
		{102, 103, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 87, 33, 20, 8},
		{103, 104, 0, 0x0L, RTEXT, (void*)"color", 10, 45, 45, 8},
		{104, 105, 0, OWNDIALOG, COLBUTTON, (void *)TextDef.ColTxt, 60, 45, 25, 10},
		{105, 106, 0, 0x0L, LTEXT, (void*)"text:", 10, 75, 25, 8},
		{106, 107, 0, 0x0L, EDTEXT, (void*)TextDef.text, 10, 85, 129, 10},
		{107, 108, 0, 0x0L, RTEXT, (void*)"rotation", 10, 57, 45, 8},
		{108, 109, 0, 0x0L, EDVAL1, &TextDef.RotBL, 60, 57, 25, 10},
		{109, 0, 0, 0x0L, LTEXT, (void *)"deg.", 87, 57, 20, 8},
		{200, 204, 201, CHECKED | ISPARENT, GROUPBOX, (void*)" font ", 17, 28, 50, 45},
		{201, 202, 0, TOUCHEXIT, RADIO1, (void*)"Helvetica", 20, 35, 45, 8},
		{202, 203, 0, TOUCHEXIT, RADIO1, (void*)"Times", 20, 45, 45, 8},
		{203, 0, 0, TOUCHEXIT, RADIO1, (void*)"Courier", 20, 55, 45, 8},
		{204, 0, 205, CHECKED | ISPARENT, GROUPBOX, (void*)" style ", 77, 28, 57, 45},
		{205, 206, 0, TOUCHEXIT, CHECKBOX, (void*)"bold", 80, 35, 25, 8},
		{206, 207, 0, TOUCHEXIT, CHECKBOX, (void*)"italic", 80, 45, 25, 8},
		{207, 0, 0, TOUCHEXIT, CHECKBOX, (void*)"underlined", 80, 55, 25, 8},
		{300, 301, 0, 0x0L, LTEXT, (void*)"text anchor at", 10, 25, 30, 8},
		{301, 302, 0, 0x0L, RTEXT, (void*)"x", 5, 37, 15, 8},
		{302, 303, 0, 0x0L, EDVAL1, &fPos.fx, 22, 37, 35, 10},
		{303, 304, 0, 0x0L, LTEXT, (void*)"??", 59, 37, 10, 8},
		{304, 305, 0, 0x0L, RTEXT, (void*)"y", 75, 37, 10, 8},
		{305, 306, 0, 0x0L, EDVAL1, &fPos.fy, 87, 37, 35, 10},
		{306, 307, 0, 0x0L, LTEXT, (void*)"??", 124, 37, 10, 8},
		{307, 308, 0, 0x0L, LTEXT, (void*)"distance from anchor point", 10, 52, 50, 8},
		{308, 309, 0, 0x0L, RTEXT, (void*)"dx", 5, 64, 15, 8},
		{309, 310, 0, 0x0L, EDVAL1, &fDist.fx, 22, 64, 35, 10},
		{310, 311, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 59, 64, 10, 8},
		{311, 312, 0, 0x0L, RTEXT, (void*)"dy", 75, 64, 10, 8},
		{312, 313, 0, 0x0L, EDVAL1, &fDist.fy, 87, 64, 35, 10},
		{313, 314, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 124, 64, 10, 8},
		{314, 315, 0, 0x0L, LTEXT, (void*)"hot spot (alignment):", 10, 85, 60, 8},
		{315, 0, 0, 0x0L, TXTHSP, (void*)&TextDef.Align, 77, 78, 45, 25},
		{600, 601, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 165, 45, 15, 15},
		{601, 602, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 165, 60, 15, 15},
		{602, 603, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 165, 75, 15, 15},
		{603, 0, 0, LASTOBJ | TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 165, 90, 15, 15}};
	DlgRoot *Dlg;
	void *hDlg;
	int res;
	bool RetVal = false;
	DWORD undo_flags = 0x0;
	lfPOINT o_pos, o_dist, n_pos, n_dist;
	TextDEF OldTxtDef, NewTxtDef;
	Axis *pa;

	if(parent && (Dlg = new DlgRoot(LabelDlg))) {
		Dlg->TextFont(201, FONT_HELVETICA);
		Dlg->TextFont(202, FONT_TIMES);
		Dlg->TextFont(203, FONT_COURIER);
		Dlg->TextStyle(205, TXS_BOLD);
		Dlg->TextStyle(206, TXS_ITALIC);
		Dlg->TextStyle(207, TXS_UNDERLINE);
		switch(TextDef.Font) {
		case FONT_TIMES:	Dlg->SetCheck(202, 0L, true);	break;
		case FONT_COURIER:	Dlg->SetCheck(203, 0L, true);	break;
		default:			Dlg->SetCheck(201, 0L, true);	break;
			}
		if(TextDef.Style & TXS_BOLD) Dlg->SetCheck(205, 0L, true);
		if(TextDef.Style & TXS_ITALIC) Dlg->SetCheck(206, 0L, true);
		if(TextDef.Style & TXS_UNDERLINE) Dlg->SetCheck(207, 0L, true);
		}
	else return false;
	if(parent->Id ==  GO_GRAPH || parent->Id == GO_PAGE) Dlg->ShowItem(50, true);
	switch(flags & 0x03) {
	case LB_X_DATA:
		Dlg->SetText(303, "[data]");
		break;
	case LB_X_PARENT:
		Dlg->SetText(303, " ");
		TmpTxt[0] = 0;
		if(parent->Id == GO_MLABEL) {
			if(parent->parent->Id == GO_AXIS) strcpy(TmpTxt, "(axis)");
			else if(parent->parent->Id == GO_TICK) strcpy(TmpTxt, "(tick)");
			}
		else {
			if(parent->Id == GO_AXIS) strcpy(TmpTxt, "(axis)");
			else if(parent->Id == GO_TICK) strcpy(TmpTxt, "(tick)");
			}
		if(TmpTxt[0]) {
			Dlg->SetText(302, TmpTxt);			Dlg->Activate(302, false);
			}
		break;
	default:
		Dlg->SetText(303, Units[defs.cUnits].display);
		break;
		}
	switch(flags & 0x30) {
	case LB_Y_DATA:
		Dlg->SetText(306, "[data]");
		break;
	case LB_Y_PARENT:
		Dlg->SetText(306, " ");					TmpTxt[0] = 0;
		if(parent->Id == GO_MLABEL) {
			if(parent->parent->Id == GO_AXIS) strcpy(TmpTxt, "(axis)");
			if(parent->parent->Id == GO_TICK) strcpy(TmpTxt, "(tick)");
			}
		else {
			if(parent->Id == GO_AXIS) strcpy(TmpTxt, "(axis)");
			if(parent->Id == GO_TICK) strcpy(TmpTxt, "(tick)");
			}
		if(TmpTxt[0]) {
			Dlg->SetText(305, TmpTxt);			Dlg->Activate(305, false);
			}
		break;
	default:
		Dlg->SetText(306, Units[defs.cUnits].display);
		break;
		}
	memcpy(&OldTxtDef, &TextDef, sizeof(TextDEF));	OldTxtDef.text = 0L;
	Dlg->GetValue(101, &OldTxtDef.fSize);			Dlg->GetValue(108, &OldTxtDef.RotBL);
	memcpy(&NewTxtDef, &OldTxtDef, sizeof(TextDEF));
	o_pos.fx = fPos.fx;	o_pos.fy = fPos.fy;	o_dist.fx = fDist.fx;	o_dist.fy = fDist.fy;
	Dlg->GetValue(302, &o_pos.fx);					Dlg->GetValue(305, &o_pos.fy);
	Dlg->GetValue(309, &o_dist.fx);					Dlg->GetValue(312, &o_dist.fy);
	n_pos.fx = o_pos.fx;	n_pos.fy = o_pos.fy;	n_dist.fx = o_dist.fx;	n_dist.fy = o_dist.fy;
	hDlg = CreateDlgWnd("Label properties", 50, 50, 410, 250, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = ExecDrawOrderButt(parent, this, Dlg->GetResult());
		switch (res) {
		case 1:
			Dlg->GetValue(101, &NewTxtDef.fSize);	Dlg->GetColor(104, &NewTxtDef.ColTxt);
			Dlg->GetValue(108, &NewTxtDef.RotBL);
			if(Dlg->GetCheck(202)) NewTxtDef.Font = FONT_TIMES;
			else if(Dlg->GetCheck(203)) NewTxtDef.Font = FONT_COURIER;
			else NewTxtDef.Font = FONT_HELVETICA;
			NewTxtDef.Style = TXS_NORMAL;
			if(Dlg->GetCheck(205)) NewTxtDef.Style |= TXS_BOLD;
			if(Dlg->GetCheck(206)) NewTxtDef.Style |= TXS_ITALIC;
			if(Dlg->GetCheck(207)) NewTxtDef.Style |= TXS_UNDERLINE;
			Dlg->GetInt(315, &NewTxtDef.Align);
			Dlg->GetValue(302, &n_pos.fx);			Dlg->GetValue(305, &n_pos.fy);
			Dlg->GetValue(309, &n_dist.fx);			Dlg->GetValue(312, &n_dist.fy);
			break;
		case 201:	case 202:	case 203:				//fonts and styles
		case 205:	case 206:	case 207:
			res = -1;
			break;
			}
		}while (res < 0);
	if(res == 1) {
		if(parent->Id == GO_TICK && parent->parent && parent->parent->Id == GO_AXIS)
			pa = (Axis*)parent->parent;
		else if(parent->Id == GO_MLABEL && parent->parent->Id == GO_TICK 
			&& parent->parent->parent && parent->parent->parent->Id == GO_AXIS)
			pa = (Axis*)parent->parent->parent;
		else pa = 0L;
		if(pa && (cmpTextDEF(&OldTxtDef, &NewTxtDef) || o_dist.fx != n_dist.fx ||
			o_dist.fy != n_dist.fy)){
			pa->Command(CMD_SAVE_TICKS, 0L, 0L);			undo_flags |= UNDO_CONTINUE;
			}
		TmpTxt[0] = 0;		Dlg->GetText(106, TmpTxt);
		if(strcmp(TextDef.text, TmpTxt)) {
			Undo.String(this, &TextDef.text, undo_flags);	undo_flags |= UNDO_CONTINUE;
			if(TextDef.text) free(TextDef.text);			TextDef.text = strdup(TmpTxt);
			}
		if(cmpTextDEF(&OldTxtDef, &NewTxtDef)){
			if(NewTxtDef.ColTxt != TextDef.ColTxt) bBGvalid = false;
			if (pa) pa->Command(CMD_TLB_TXTDEF, &NewTxtDef, 0L);
			else if(parent->Id == GO_MLABEL) {
				if(parent->Command(CMD_SETTEXTDEF, &NewTxtDef, 0L))RetVal = true;
				}
			else {
				Undo.TextDef(this, &TextDef, undo_flags);
				NewTxtDef.text = TextDef.text;	memcpy(&TextDef, &NewTxtDef, sizeof(TextDEF));	
				undo_flags |= UNDO_CONTINUE;
				}
			}
		if(n_pos.fx != o_pos.fx || n_pos.fy != o_pos.fy) {
			if(parent->Id == GO_MLABEL) {
				if(parent->SetSize(SIZE_XPOS, n_pos.fx) || 
					parent->SetSize(SIZE_YPOS, n_pos.fy)) RetVal = true;
				}
			else {
				Undo.SaveLFP(this, &fPos, undo_flags);		undo_flags |= UNDO_CONTINUE;
				fPos.fx = n_pos.fx;		fPos.fy = n_pos.fy;
				}
			}
		if(n_dist.fx != o_dist.fx || n_dist.fy != o_dist.fy) {
			if(pa) {
				pa->SetSize(SIZE_TLB_XDIST, n_dist.fx);		pa->SetSize(SIZE_TLB_YDIST, n_dist.fy);
				}
			else if(parent->Id == GO_MLABEL) {
				if(parent->SetSize(SIZE_LB_XDIST, n_dist.fx) ||
					parent->SetSize(SIZE_LB_YDIST, n_dist.fy)) RetVal = true;
				}
			else {
				Undo.SaveLFP(this, &fDist, undo_flags);		undo_flags |= UNDO_CONTINUE;
				fDist.fx = n_dist.fx;	fDist.fy = n_dist.fy;
				}
			}
		if(undo_flags & UNDO_CONTINUE) RetVal = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return RetVal;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// segment properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
segment::PropertyDlg()
{
	TabSHEET tab1 = {0, 50, 10, "Size & Color"};
	TabSHEET tab2 = {50, 90, 10, "Edit"};
	DlgInfo SegDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to SEGMENT", 130, 10, 65, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to PLOT", 130, 25, 65, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 130, 40, 65, 12},
		{4, 0, 5, CHECKED | ISPARENT, GROUP, NULL, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 115},
		{6, 0, 200, ISPARENT, SHEET, &tab2, 5, 10, 120, 115},
		{100, 109, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 25, 35, 90, 50},
		{109, 110, 0, 0x0L, RTEXT, (void*)"shift out (explode)", 10, 90, 55, 8},
		{110, 111, 0, 0x0L, EDVAL1, &shift, 67, 90, 25, 10},
		{111, 112, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 94, 90, 20, 8},
		{112, 0, 0, 0x0L, CHECKBOX, (void*)"enable mouse drag (moveable)", 12, 107, 100, 8},
		{200, 201, 0, 0x0L, RTEXT, (void*)"center x", 10, 30, 40, 8},
		{201, 202, 0, 0x0L, EDVAL1, &fCent.fx, 55, 30, 40, 10},
		{202, 203, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 98, 30, 20, 8},
		{203, 204, 0, 0x0L, RTEXT, (void*)"y", 10, 42, 40, 8},
		{204, 205, 0, 0x0L, EDVAL1, &fCent.fy, 55, 42, 40, 10},
		{205, 206, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 98, 42, 20, 8},
		{206, 207, 0, 0x0L, RTEXT, (void*)"start angle", 10, 57, 40, 8},
		{207, 208, 0, 0x0L, EDVAL1, &angle1, 55, 57, 40, 10},
		{208, 209, 0, 0x0L, LTEXT, (void*)"deg.", 98, 57, 20, 8},
		{209, 210, 0, 0x0L, RTEXT, (void*)"stop", 10, 69, 40, 8},
		{210, 211, 0, 0x0L, EDVAL1, &angle2, 55, 69, 40, 10},
		{211, 212, 0, 0x0L, LTEXT, (void*)"deg.", 98, 69, 20, 8},
		{212, 213, 0, 0x0L, RTEXT, (void*)"outer radius", 10, 84, 40, 8},
		{213, 214, 0, 0x0L, EDVAL1, &radius2, 55, 84, 40, 10},
		{214, 215, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 98, 84, 20, 8},
		{215, 216, 0, 0x0L, RTEXT, (void*)"inner", 10, 96, 40, 8},
		{216, 217, 0, 0x0L, EDVAL1, &radius1, 55, 96, 40, 10},
		{217, 0, 0, LASTOBJ, LTEXT, (void *) Units[defs.cUnits].display, 98, 96, 20, 8}};

	DlgRoot *Dlg;
	void *hDlg;
	int res, new_mov;
	double old_r1, old_r2, old_a1, old_a2, old_shift;
	double new_r1, new_r2, new_a1, new_a2, new_shift;
	lfPOINT old_cent, new_cent;
	bool bRet = false;
	LineDEF newLine, newFillLine;
	FillDEF newFill;
	DWORD undo_flags = 0L;

	if(!parent) return false;
	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)&segLine, 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)&segFill, 0);
	Dlg = new DlgRoot(SegDlg);
	Dlg->GetValue(216, &old_r1);		new_r1 = old_r1;
	Dlg->GetValue(213, &old_r2);		new_r2 = old_r2;
	Dlg->GetValue(201, &old_cent.fx);	new_cent.fx = old_cent.fx;
	Dlg->GetValue(204, &old_cent.fy);	new_cent.fy = old_cent.fy;
	Dlg->GetValue(207, &old_a1);		new_a1 = old_a1;
	Dlg->GetValue(210, &old_a2);		new_a2 = old_a2;
	Dlg->GetValue(110, &old_shift);		new_shift = old_shift;
	if(moveable) Dlg->SetCheck(112, 0L, true);
	hDlg = CreateDlgWnd("segment properties", 50, 50, 410, 290, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 1:
		case 2:
			OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
			OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&newFill, 0);
			memcpy(&newFillLine, &segFillLine, sizeof(LineDEF));
			if(newFill.hatch) memcpy(&newFillLine, newFill.hatch, sizeof(LineDEF));
			Dlg->GetValue(201, &new_cent.fx);			Dlg->GetValue(204, &new_cent.fy);
			Dlg->GetValue(207, &new_a1);				Dlg->GetValue(210, &new_a2);
			Dlg->GetValue(216, &new_r1);				Dlg->GetValue(213, &new_r2);
			Dlg->GetValue(110, &new_shift);
			new_mov = Dlg->GetCheck(112) ? 1 : 0;
			break;
			}
		}while (res < 0);
	switch (res) {
	case 1:				//new setting for current segment only
		undo_flags = CheckNewLFPoint(&fCent, &old_cent, &new_cent, parent, undo_flags);
		undo_flags = CheckNewFloat(&angle1, old_a1, new_a1, parent, undo_flags);
		undo_flags = CheckNewFloat(&angle2, old_a2, new_a2, parent, undo_flags);
		undo_flags = CheckNewFloat(&radius1, old_r1, new_r1, parent, undo_flags);
		undo_flags = CheckNewFloat(&radius2, old_r2, new_r2, parent, undo_flags);
		undo_flags = CheckNewFloat(&shift, old_shift, new_shift, parent, undo_flags);
		if(cmpLineDEF(&segLine, &newLine)) {
			Undo.Line(parent, &segLine, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&segLine, &newLine, sizeof(LineDEF));
			}
		if(newFill.type && cmpLineDEF(&segFillLine, &newFillLine)) {
			Undo.Line(parent, &segFillLine, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&segFillLine, &newFillLine, sizeof(LineDEF));
			}
		if(cmpFillDEF(&segFill, &newFill)) {
			Undo.Fill(parent, &segFill, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&segFill, &newFill, sizeof(FillDEF));
			}
		segFill.hatch = &segFillLine;
		undo_flags = CheckNewInt(&moveable, moveable, new_mov, parent, undo_flags);
		bRet = bModified = ((undo_flags & UNDO_CONTINUE) == UNDO_CONTINUE);
		break;
	case 2:				//new settings to all segments of chart
		if(new_cent.fx != old_cent.fx || new_cent.fy != old_cent.fy || new_r1 != old_r1 || 
			new_r2 != old_r2 || new_shift != old_shift || cmpLineDEF(&segLine, &newLine) ||
			(newFill.type && cmpLineDEF(&segFillLine, &newFillLine)) || 
			cmpFillDEF(&segFill, &newFill) || new_mov != moveable) {
			parent->Command(CMD_SAVE_SYMBOLS, 0L, 0L);
			if(new_cent.fx != old_cent.fx || new_cent.fy != old_cent.fy) {
				parent->SetSize(SIZE_XPOS, new_cent.fx);	parent->SetSize(SIZE_YPOS, new_cent.fy);
				}
			if(new_r1 != old_r1 || new_r2 != old_r2) {
				parent->SetSize(SIZE_RADIUS1, new_r1);		parent->SetSize(SIZE_RADIUS2, new_r2);
				}
			if(new_shift != old_shift) parent->Command(CMD_SHIFT_OUT, (void*)&new_shift, 0L);
			if(cmpLineDEF(&segLine, &newLine))parent->Command(CMD_SEG_LINE, (void*)&newLine, 0L);
			if((newFill.type && cmpLineDEF(&segFillLine, &newFillLine)) || 
				cmpFillDEF(&segFill, &newFill)) parent->Command(CMD_SEG_FILL, (void*)&newFill, 0L);
			if(new_mov != moveable) parent->Command(CMD_SEG_MOVEABLE, (void *)&new_mov, 0L);
			bRet = true;
			}
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// polyline properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
polyline::PropertyDlg()
{
	TabSHEET tab1 = {0, 40, 10, "Line"};
	DlgInfo LineDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 150, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 50, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 139, 130},
		{50, 0, 600, ISPARENT | CHECKED | HIDDEN, GROUP, 0L, 0, 0, 0, 0},
		{100, 101, 0, NOSELECT, ODBUTTON, (void*)OD_linedef, 10, 30, 130, 90},
		{101, 0, 0, 0x0L, CHECKBOX, (void*)"use this style as default", 10, 125, 60, 9},
		{600, 601, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 165, 60, 15, 15},
		{601, 602, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 165, 75, 15, 15},
		{602, 603, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 165, 90, 15, 15},
		{603, 0, 0, LASTOBJ | TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 165, 105, 15, 15}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, undo_level = *Undo.pcb;
	bool bRet = false;
	LineDEF newLine;

	if(!parent) return false;
	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&pgLine, 0);
	if(!(Dlg = new DlgRoot(LineDlg)))return false;
	if(parent->Id ==  GO_GRAPH || parent->Id == GO_PAGE) Dlg->ShowItem(50, true);
	hDlg = CreateDlgWnd("line properties", 50, 50, 410, 314, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = ExecDrawOrderButt(parent, this, Dlg->GetResult());
	}while (res < 0);
	switch(res) {
	case 1:							//OK pressed
		OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
		if(cmpLineDEF(&pgLine, &newLine)) {
			Undo.Line(this, &pgLine, 0L);
			memcpy(&pgLine, &newLine, sizeof(LineDEF));
			bModified = true;
			}
		if(Dlg->GetCheck(101)) defs.plLineDEF(&pgLine);
		bRet = true;
		break;
	case 2:							//Cancel
		if(*Undo.pcb > undo_level) {	//restore plot order
			while(*Undo.pcb > undo_level)	Undo.Restore(false, 0L);
			bRet = true;
			}
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// polygon properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
polygon::PropertyDlg()
{
	TabSHEET tab1 = {0, 40, 10, "Polygon"};
	DlgInfo PolygDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 102, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 102, 25, 45, 12},
		{3, 50, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 90, 85},
		{50, 0, 600, ISPARENT | CHECKED | HIDDEN, GROUP, 0L, 0, 0, 0, 0},
		{100, 101, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 8, 30, 90, 50},
		{101, 0, 0, 0x0L, CHECKBOX, (void*)"use this style as default", 10, 82, 60, 9},
		{600, 601, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 107, 52, 15, 15},
		{601, 602, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 127, 52, 15, 15},
		{602, 603, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 127, 67, 15, 15},
		{603, 0, 0, LASTOBJ | TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 107, 67, 15, 15}};
	DlgRoot *Dlg;
	void *hDlg;
	LineDEF newLine, newFillLine;
	FillDEF newFill;
	DWORD undo_flags = 0L;
	int res, undo_level = *Undo.pcb;
	bool bRet = false;

	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)&pgLine, 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)&pgFill, 0);
	Dlg = new DlgRoot(PolygDlg);
	if(parent->Id ==  GO_GRAPH || parent->Id == GO_PAGE) Dlg->ShowItem(50, true);
	hDlg = CreateDlgWnd("polygon properties", 50, 50, 310, 224, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = ExecDrawOrderButt(parent, this, Dlg->GetResult());
		}while (res < 0);
	switch (res) {
	case 1:						//OK pressed
		OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
		OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&newFill, 0);
		memcpy(&newFillLine, &pgFillLine, sizeof(LineDEF));
		if(newFill.hatch) memcpy(&newFillLine, newFill.hatch, sizeof(LineDEF));
		if(cmpLineDEF(&pgLine, &newLine)) {
			Undo.Line(this, &pgLine, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&pgLine, &newLine, sizeof(LineDEF));
			}
		if(newFill.type && cmpLineDEF(&pgFillLine, &newFillLine)) {
			Undo.Line(this, &pgFillLine, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&pgFillLine, &newFillLine, sizeof(LineDEF));
			}
		if(cmpFillDEF(&pgFill, &newFill)) {
			Undo.Fill(this, &pgFill, undo_flags);		undo_flags |= UNDO_CONTINUE;
			memcpy(&pgFill, &newFill, sizeof(FillDEF));
			}
		pgFill.hatch = &pgFillLine;
		if(undo_flags & UNDO_CONTINUE) bModified = true;
		if(Dlg->GetCheck(101)){
			defs.pgLineDEF(&pgLine);			defs.pgFillDEF(&pgFill);
			}
		bRet = true;
		break;
	case 2:							//Cancel
		if(*Undo.pcb > undo_level) {	//restore plot order
			while(*Undo.pcb > undo_level)	Undo.Restore(false, 0L);
			bRet = true;
			}
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// rectangle, round rectangle and ellipse properties dialogs
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
rectangle::PropertyDlg()
{
	TabSHEET tab1 = {0, 40, 10, type == 1 ? (char*)"Ellipse" :(char*)"Rectangle"};
	TabSHEET tab2 = {40, 63, 10, "Edit"};
	DlgInfo RecDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 112, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 112, 25, 45, 12},
		{3, 0, 10, CHECKED | ISPARENT, GROUP, 0L, 0, 0, 0, 0},
		{10, 11, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 100, 97},
		{11, 50, 200, ISPARENT, SHEET, &tab2, 5, 10, 100, 97},
		{50, 0, 600, ISPARENT | CHECKED | HIDDEN, GROUP, 0L, 0, 0, 0, 0},
		{100, 101, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 8, 30, 90, 50},
		{101, 120, 110, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{110, 111, 0, 0x0L, RTEXT, (void*)"edge radius", 0, 79, 48, 8},
		{111, 112, 0, 0x0L, EDVAL1, &rad, 50, 79, 25, 10},
		{112, 0, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 77, 79, 10, 8},
		{120, 0, 0, 0x0L, CHECKBOX, (void*)"use this style as default", 10, 92, 60, 9},
		{200, 201, 0, 0x0L, RTEXT, (void*)"top left x", 5, 30, 40, 8},
		{201, 202, 0, 0x0L, EDVAL1, &fp1.fx, 47, 30, 38, 10},
		{202, 203, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 87, 30, 10, 8},
		{203, 204, 0, 0x0L, RTEXT, (void*)"y", 5, 42, 40, 8},
		{204, 205, 0, 0x0L, EDVAL1, &fp1.fy, 47, 42, 38, 10},
		{205, 206, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 87, 42, 10, 8},
		{206, 207, 0, 0x0L, RTEXT, (void*)"lower right x", 5, 55, 40, 8},
		{207, 208, 0, 0x0L, EDVAL1, &fp2.fx, 47, 55, 38, 10},
		{208, 209, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 87, 55, 10, 8},
		{209, 210, 0, 0x0L, RTEXT, (void*)"y", 5, 67, 40, 8},
		{210, 211, 0, 0x0L, EDVAL1, &fp2.fy, 47, 67, 38, 10},
		{211, 0, 0, 0x0L, LTEXT, (void*)Units[defs.cUnits].display, 87, 67, 10, 8},
		{600, 601, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 115, 64, 15, 15},
		{601, 602, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 139, 64, 15, 15},
		{602, 603, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 139, 79, 15, 15},
		{603, 0, 0, LASTOBJ | TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 115, 79, 15, 15}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, undo_level = *Undo.pcb;
	lfPOINT old_fp1, new_fp1, old_fp2, new_fp2;
	LineDEF old_Line, new_Line, old_FillLine, new_FillLine;
	FillDEF old_Fill, new_Fill;
	DWORD undo_flags = 0L;
	bool bRet = false;

	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)&Line, 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)&Fill, 0);
	if(!(Dlg = new DlgRoot(RecDlg)))return false;
	Dlg->GetValue(201, &old_fp1.fx);		Dlg->GetValue(204, &old_fp1.fy);
	Dlg->GetValue(207, &old_fp2.fx);		Dlg->GetValue(210, &old_fp2.fy);
	if(type != 2) Dlg->ShowItem(101, false);
	if(parent->Id ==  GO_GRAPH || parent->Id == GO_PAGE) Dlg->ShowItem(50, true);
	OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&old_Line, 0);
	OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&old_Fill, 0);
	if(old_Fill.hatch) memcpy(&old_FillLine, old_Fill.hatch, sizeof(LineDEF));
	old_Fill.hatch = &old_FillLine;
	hDlg = CreateDlgWnd(type == 1 ? (char*)"ellipse properties":
		type == 2 ? (char*)"rounded rectangle" : (char*)"rectangle properties", 
		50, 50, 330, 248, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = ExecDrawOrderButt(parent, this, Dlg->GetResult());
		}while (res < 0);
	switch (res) {
	case 1:						//OK pressed
		Dlg->GetValue(201, &new_fp1.fx);		Dlg->GetValue(204, &new_fp1.fy);
		Dlg->GetValue(207, &new_fp2.fx);		Dlg->GetValue(210, &new_fp2.fy);
		undo_flags = CheckNewLFPoint(&fp1, &old_fp1, &new_fp1, this, undo_flags);
		undo_flags = CheckNewLFPoint(&fp2, &old_fp2, &new_fp2, this, undo_flags);
		OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&new_Line, 0);
		OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&new_Fill, 0);
		if(new_Fill.hatch) memcpy(&new_FillLine, new_Fill.hatch, sizeof(LineDEF));
		new_Fill.hatch = &new_FillLine;
		if(cmpLineDEF(&old_Line, &new_Line)) {
			Undo.Line(this, &Line, undo_flags);
			undo_flags |= UNDO_CONTINUE;
			memcpy(&Line, &new_Line, sizeof(LineDEF));
			}
		if(new_Fill.type && cmpLineDEF(&old_FillLine, &new_FillLine)) {
			Undo.Line(this, &FillLine, undo_flags);
			undo_flags |= UNDO_CONTINUE;
			memcpy(&FillLine, &new_FillLine, sizeof(LineDEF));
			}
		if(cmpFillDEF(&Fill, &new_Fill)) {
			Undo.Fill(this, &Fill, undo_flags);
			undo_flags |= UNDO_CONTINUE;
			memcpy(&Fill, &new_Fill, sizeof(FillDEF));
			}
		Fill.hatch = &FillLine;
		if(type == 2) Dlg->GetValue(111, &rad);
		else rad = 0.0;
		if(Dlg->GetCheck(120)){
			defs.pgLineDEF(&Line);			defs.pgFillDEF(&Fill);
			if(type == 2)defs.rrectRad(rad);
			}
		if(undo_flags) bModified = true;
		bRet = true;
		break;
	case 2:							//Cancel
		if(*Undo.pcb > undo_level) {	//restore plot order
			while(*Undo.pcb > undo_level)	Undo.Restore(false, 0L);
			bRet = true;
			}
		break;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Create a bar chart: note this is a PlotScatt function
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
PlotScatt::CreateBarChart()
{
	TabSHEET tab1 = {0, 25, 10, "Data"};
	TabSHEET tab2 = {25, 55, 10, "Details"};
	double start = 1.0, step = 1.0, bw = 60.0;
	DlgInfo BarDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 130, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 130, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 110},
		{5, 10, 200, ISPARENT, SHEET, &tab2, 5, 10, 120, 110},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"spread sheet range for values", 10, 25, 60, 8},
		{101, 102, 0, 0x0L, EDTEXT, TmpTxt, 10, 38, 110, 10},
		{102, 0, 110, ISPARENT | CHECKED, GROUPBOX, (void*)" style ", 10, 55, 110, 61}, 
		{110, 0, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 25, 62, 90, 50},
		{200, 201, 0, 0x0L, RTEXT, (void*)"start value", 10, 35, 38, 8},
		{201, 202, 0, 0x0L, EDVAL1, (void*)&start, 58, 35, 35, 10},
		{202, 203, 0, 0x0L, RTEXT, (void*)"step value", 10, 50, 38, 8},
		{203, 204, 0, 0x0L, EDVAL1, (void*)&step, 58, 50, 35, 10},
		{204, 205, 0, 0x0L, RTEXT, (void*)"bar width", 10, 65, 38, 8},
		{205, 206, 0, 0x0L, EDVAL1, (void*)&bw, 58, 65, 35, 10},
		{206, 0, 0, LASTOBJ, LTEXT, (void*)"%", 95, 65, 8, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	bool bRet = false;
	int k, l, n, ic, res, width, height;
	double x, y;
	AccRange *rY = 0L;
	LineDEF Line;
	FillDEF Fill; 

	memcpy(&Line, defs.GetOutLine(), sizeof(LineDEF));
	memcpy(&Fill, defs.GetFill(), sizeof(FillDEF));
	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)&Line, 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)&Fill, 0);
	data->GetSize(&width, &height);
	sprintf(TmpTxt, "a1:a%d", height);
	if(!(Dlg = new DlgRoot(BarDlg)))return false;
	hDlg = CreateDlgWnd("Simple bar chart", 50, 50, 370, 280, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 0:
			if(Dlg->GetCheck(10)) res = -1;
			break;
		case 1:
			if(rY) delete rY;
			if(Dlg->GetText(101, TmpTxt)) rY = new AccRange(TmpTxt);
			yRange = strdup(TmpTxt);
			if(!(n = rY ? rY->CountItems() : 0)) {
				res = -1;
				ErrorBox("Data range not valid.");
				}
			break;
			}
	} while(res < 0);
	if(res == 1 && n && rY) {
		OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&Line, 0);
		OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&Fill, 0);
		Command(CMD_FLUSH, 0L, 0L);
		nPoints = n;
		Bars = (Bar**)calloc(nPoints, sizeof(Bar*));
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;		Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		rY->GetFirst(&k, &l);		rY->GetNext(&k, &l);
		Dlg->GetValue(201, &start);	Dlg->GetValue(203, &step);
		if(step < 0.001) step = 1.0;
		Dlg->GetValue(205, &bw);
		if(bw < 5) bw = 60;
		ic = 0;
		x = start;
		if(Bars) do {
			if(data->GetValue(l, k, &y)){
				Bars[ic] = new Bar(this, data, x, y, BAR_VERTB | BAR_RELWIDTH, -1, -1, k, l);
				CheckBounds(x, y);
				x += step;
				ic++;
				}
			}while(rY->GetNext(&k, &l));
		if(ic){
			bRet = true;
			Command(CMD_BAR_FILL, &Fill, 0L);
			SetColor(COL_BAR_LINE, Line.color);
			SetSize(SIZE_BAR_LINE, Line.width);
			SetSize(SIZE_BAR, bw);
			BarDist.fx = step;
			}
		}
	if(rY) delete rY;
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Scatter plot properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
PlotScatt::PropertyDlg()
{
	TabSHEET tab1 = {0, 22, 10, "Data"};
	TabSHEET tab2 = {22, 50, 10, "Layout"};
	TabSHEET tab3 = {50, 88, 10, "Error Bars"};
	TabSHEET tab4 = {88, 131, 10, "Data Labels"};
	char text1[100], text2[100], text3[100], text4[100];
	DlgInfo XYDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 140, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 140, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 131, 100},
		{5, 6, 200, TOUCHEXIT | ISPARENT, SHEET, &tab2, 5, 10, 131, 100},
		{6, 7, 300, ISPARENT, SHEET, &tab3, 5, 10, 131, 100},
		{7, 10, 400, ISPARENT, SHEET, &tab4, 5, 10, 131, 100},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for X Data", 10, 30, 60, 8},
		{101, 102, 0, 0x0L, EDTEXT, text1, 20, 40, 100, 10},
		{102, 103, 0, 0x0L, LTEXT, (void*)"range for Y Data", 10, 55, 60, 8},
		{103, 104, 0, 0x0L, EDTEXT, text2, 20, 65, 100, 10},
		{104, 105, 0, 0x0L, ICON, (void*)ICO_INFO, 10, 85, 10, 10},
		{105, 106, 0, 0x0L, LTEXT, (void*)"Valid ranges include e.g. \'a1:g13\'", 30, 85, 30, 6},
		{106, 107, 0, 0x0L, LTEXT, (void*)"or \'b4:j4\' if data are available.", 30, 91, 30, 6},
		{107, 0, 0, 0x0L, LTEXT, (void*)"Separate multiple ranges by \' ; \'.", 30, 97, 30, 6},
		{200, 201, 0, 0x0L, CHECKBOX, (void*)" symbols", 25, 30, 60, 8},
		{201, 202, 250, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{202, 203, 255, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{203, 204, 0, 0x0L, CHECKBOX, (void*)" arrows", 25, 80, 60, 8},
		{204, 0, 0, 0x0L, CHECKBOX, (void*)" drop lines", 25, 90, 60, 8},
		{250, 251, 0, ISRADIO, CHECKBOX, (void*)" line", 25, 40, 60, 8},
		{251, 0, 0, ISRADIO, CHECKBOX, (void*)" polygon", 25, 70, 60, 8},
		{255, 256, 0, ISRADIO, CHECKBOX, (void*)" vertical bars", 25, 50, 60, 8},
		{256, 0, 0, ISRADIO, CHECKBOX, (void*)" horizontal bars", 25, 60, 60, 8},
		{300, 301, 500, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{301, 302, 0, 0x0L, CHECKBOX, (void*)"draw error bars", 15, 28, 50, 8},
		{302, 303, 0, 0x0L, LTEXT, (void*)"style:", 35, 40, 20, 8},
		{303, 304, 0, 0x0L, LTEXT, (void*)"range for error data:", 15, 82, 60, 8},
		{304, 0, 0, 0x0L, EDTEXT, text3, 20, 93, 100, 10},
		{400, 401, 0, 0x0L, CHECKBOX, (void*)"add labels to data points", 15, 28, 50, 8},
		{401, 402, 0, 0x0L, LTEXT, (void*)"spread sheet range for labels:", 15, 40, 60, 8},
		{402, 0, 0, 0x0L, EDTEXT, text4, 20, 51, 100, 10},
		{500, 501, 0, TOUCHEXIT|CHECKED|ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl),60,40,20,20},
		{501, 502, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 80, 40, 20, 20},
		{502, 503, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 100, 40, 20, 20},
		{503, 504, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 60, 60, 20, 20},
		{504, 505, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 80, 60, 20, 20},
		{505, 0, 0, LASTOBJ | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_ErrBarTempl), 100, 60, 20, 20}};
	DlgRoot *Dlg;
	void *hDlg;
	int c, i, j, k, l, i1, j1, k1, l1, m, n, o, p, ic;
	int ErrType = 0, res, width, height, BarType;
	double x, y, e;
	lfPOINT fp1, fp2;
	bool bRet = false, bLayout = false, bContinue = false;
	TextDEF lbdef = {defs.Color(COL_TEXT), defs.Color(COL_BG), defs.GetSize(SIZE_TEXT), 0.0f, 0.0f, 0,
		TXA_HLEFT | TXA_VBOTTOM, TXM_TRANSPARENT, TXS_NORMAL, FONT_HELVETICA, TmpTxt};
	AccRange *rX, *rY, *rE, *rL;

	if(Id == GO_BARCHART) return CreateBarChart();
	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);		sprintf(text2, "b1:b%d", height);
	sprintf(text3, "c1:c%d", height);		sprintf(text4, "b1:b%d", height);
	rX = rY = rE = rL = 0L;
	if(!(Dlg = new DlgRoot(XYDlg)))return false;
#ifdef _WINDOWS
	for(i = 104; i <= 107; i++) Dlg->TextSize(i, 12);
#else
	for(i = 104; i <= 107; i++) Dlg->TextSize(i, 10);
#endif
	if(DefSel & 0x01)Dlg->SetCheck(200, 0L, true);
	if(DefSel & 0x02)Dlg->SetCheck(250, 0L, true);
	if(DefSel & 0x04)Dlg->SetCheck(255, 0L, true);
	if(DefSel & 0x08)Dlg->SetCheck(256, 0L, true);
	hDlg = CreateDlgWnd("XY Plot properties", 50, 50, 388, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:								// focus lost
			if(bContinue) res = -1;
			else if(Dlg->GetCheck(10)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 500:	case 501:	case 502:
		case 503:	case 504:	case 505:
			ErrType = res-500;
			Dlg->SetCheck(301, 0L, true);
			res = -1;
			break;
		case 5:								// the layout tab sheet
			bLayout = true;
			res = -1;
			break;
		case 1:								// OK
			if(rX) delete rX;	if(rY) delete rY; if(rE) delete rE;
			rX = rY = rE = 0L;						// check x-range
			if(Dlg->GetText(101, TmpTxt)) rX = new AccRange(TmpTxt);
			if(!(n = rX ? rX->CountItems() : 0)) {
				Dlg->SetCheck(4, 0L, true);
				res = -1;
				bContinue = true;
				ErrorBox("X-range not specified\nor not valid.");
				}
			else {							// check y-range
				if(Dlg->GetText(103, TmpTxt)) rY = new AccRange(TmpTxt);
				if(n != (rY ? rY->CountItems() : 0)) {
					Dlg->SetCheck(4, 0L, true);
					res = -1;
					bContinue = true;
					ErrorBox("Y-range missing\nor not valid.\n"
						"Size must match X-range.");
					}
				}
			//check for error bar
			if(res >0 && Dlg->GetCheck(301)) {
				if(Dlg->GetText(304, TmpTxt)) rE = new AccRange(TmpTxt);
				if(n != (rE ? rE->CountItems() : 0)) {
					Dlg->SetCheck(6, 0L, true);
					res = -1;
					bContinue = true;
					ErrorBox("Range for errors missing\nor not valid.\n"
						"Size must match X- and Y-range.");
					if(rE) delete (rE);
					rE = 0L;
					}
				}
			//check for data labels
			if(res >0 && Dlg->GetCheck(400)) {
				if(Dlg->GetText(402, TmpTxt)) rL = new AccRange(TmpTxt);
				if(n != (rL ? rL->CountItems() : 0)) {
					Dlg->SetCheck(7, 0L, true);
					res = -1;
					bContinue = true;
					ErrorBox("Range for labels missing\nor not valid.\n"
						"Size must match X- and Y-range.");
					if(rL) delete (rL);
					rL = 0L;
					}
				}
			//check if something left to do
			if(res > 0 && !rE && !rL && !Dlg->GetCheck(200) && !Dlg->GetCheck(250) && 
				!Dlg->GetCheck(251) && !Dlg->GetCheck(255) && !Dlg->GetCheck(256) && 
				!Dlg->GetCheck(203)) {
				Dlg->SetCheck(5, 0L, true);
				res = -1;
				bContinue = true;
				ErrorBox("Nothing to do!\nSelect at least one item.");
				}
			//the layout menu must have been visited
			if(res > 0 && !bLayout){
				Dlg->SetCheck(5, 0L, bLayout = true);
				res = -1;
				}
			break;
			}
		}while (res <0);
	if(res == 1 && n && rX && rY){				//OK pressed
		Command(CMD_FLUSH, 0L, 0L);
		nPoints = n;
		if(Dlg->GetText(101, TmpTxt)) xRange = strdup(TmpTxt);
		if(Dlg->GetText(103, TmpTxt)) yRange = strdup(TmpTxt);
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;		Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		//Create graphic objects
		rX->GetFirst(&i, &j);	rY->GetFirst(&k, &l);
		rX->GetNext(&i, &j);	rY->GetNext(&k, &l);
		i1 = i;	j1 = j;	k1 = k;	l1 = l;
		ic = c = 0;
		if(Dlg->GetCheck(200)) Symbols = (Symbol**)calloc(nPoints, sizeof(Symbol*));
		if((BarType = Dlg->GetCheck(255) ? BAR_VERTB : Dlg->GetCheck(256) ? BAR_HORL : 0))
			Bars = (Bar**)calloc(nPoints, sizeof(Bar*));
		BarType |= BAR_RELWIDTH;
		if(Dlg->GetCheck(204)) DropLines = (DropLine**)calloc(nPoints, sizeof(DropLine*));
		if(Dlg->GetCheck(203)) Arrows = (Arrow**)calloc(nPoints, sizeof(Arrow*));
		if(Dlg->GetCheck(301) && rE) {					//error bars ?
			Errors = (ErrorBar**)calloc(nPoints, sizeof(ErrorBar*));
			if(Dlg->GetText(304, TmpTxt)) ErrRange = strdup(TmpTxt);
			rE->GetFirst(&m, &n);	rE->GetNext(&m, &n);
			}
		if(Dlg->GetCheck(400) && rL) {					//labels ?
			Labels = (Label**)calloc(nPoints, sizeof(Label*));
			if(Dlg->GetText(402, TmpTxt)) LbRange = strdup(TmpTxt);
			rL->GetFirst(&o, &p);	rL->GetNext(&o, &p);
			}
		if(Dlg->GetCheck(250) && nPoints >1) TheLine = new DataLine(this, data, xRange, yRange); 
		else if(Dlg->GetCheck(251) && nPoints >2) TheLine = new DataPolygon(this, data, xRange, yRange); 
		do {
			if(data->GetValue(j, i, &x) && data->GetValue(l, k, &y)){
				if(Symbols && (Symbols[ic] = new Symbol(this, data, x, y, DefSym, i, j, k, l))){
					Symbols[ic]->idx = c;
					}
				if(Bars)Bars[ic] = new Bar(this, data, x, y, BarType, i, j, k, l);
				if(DropLines) DropLines[ic] = new DropLine(this, data, x, y, 
					DL_YAXIS | DL_XAXIS, i, j, k, l);
				if(Arrows) {
					if(ic){
						fp1.fx = fp2.fx;	fp1.fy = fp2.fy;
						}
					else {
						fp1.fx = x;			fp1.fy = y;
						}
					fp2.fx = x;			fp2.fy = y;
					Arrows[ic] = new Arrow(this, data, ic ? fp1 : fp2, fp2, ARROW_LINE,
						i1, j1, k1, l1, i, j, k, l);
					//the first arrow has zero length
					//all other arrows conncect to the following point
					i1 = i;	j1 = j;	k1 = k;	l1 = l;
					}
				if(Labels && rL) {
					if(data->GetText(p, o, TmpTxt, TMP_TXT_SIZE)) 
						Labels[ic] = new Label(this, data, x, y, &lbdef, 
							LB_X_DATA | LB_Y_DATA, i, j, k, l, o, p);
					rL->GetNext(&o, &p);
					}
				if(Errors && rE){
					if(data->GetValue(n, m, &e))
						Errors[ic]= new ErrorBar(this, data, x, y, e, ErrType,
						i, j, k, l, m, n);
					rE->GetNext(&m, &n);
					}
				else CheckBounds(x, y);
				ic++;
				}
			else {
				if(Labels && rL) rL->GetNext(&o, &p);
				if(Errors && rE) rE->GetNext(&m, &n);
				}
			c++;
			}while(rX->GetNext(&i, &j) && rY->GetNext(&k, &l));
		if(ic) bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rX) delete rX;	if(rY) delete rY;	if(rE) delete rE;	if(rL) delete rL;
	return (dirty = bRet);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Regression properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Regression::PropertyDlg()
{
	TabSHEET tab1 = {0, 40, 10, "Data"};
	TabSHEET tab2 = {40, 90, 10, "Transform"};
	char text1[100], text2[100];
	DlgInfo RegDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 140, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 140, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 130, 85},
		{5, 10, 200, ISPARENT, SHEET, &tab2, 5, 10, 130, 85},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for X Data", 10, 20, 60, 8},
		{101, 102, 0, 0x0L, EDTEXT, text1, 20, 30, 100, 10},
		{102, 103, 0, 0x0L, LTEXT, (void*)"range for Y Data", 10, 45, 60, 8},
		{103, 104, 0, 0x0L, EDTEXT, text2, 20, 55, 100, 10},
		{104, 105, 0, CHECKED, CHECKBOX, (void*)" include symbols in plot", 10, 70, 100, 8},
		{105, 0, 0, 0x0L, CHECKBOX, (void*) " draw SD ellipse", 10, 80, 100, 8}, 
		{200, 210, 201, CHECKED | ISPARENT, GROUPBOX, (void*)"  x-values  ", 10, 30, 58, 50},
		{201, 202, 0, CHECKED, RADIO1, (void*)"x = x", 20, 40, 30, 8},
		{202, 203, 0, 0x0L, RADIO1, (void*)"x = log(x)", 20, 48, 30, 8},
		{203, 204, 0, 0x0L, RADIO1, (void*)"x = 1/x", 20, 56, 30, 8},
		{204, 0, 0, 0x0L, RADIO1, (void*)"x = sqrt(x)", 20, 64, 30, 8},
		{210, 0, 211, CHECKED | ISPARENT, GROUPBOX, (void*)"  y-values  ", 72, 30, 58, 50},
		{211, 212, 0, CHECKED, RADIO1, (void*)"y = y", 82, 40, 30, 8},
		{212, 213, 0, 0x0L, RADIO1, (void*)"y = log(y)", 82, 48, 30, 8},
		{213, 214, 0, 0x0L, RADIO1, (void*)"y = 1/y", 82, 56, 30, 8},
		{214, 0, 0, LASTOBJ, RADIO1, (void*)"y = sqrt(y)", 82, 64, 30, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int c, i, j, k, l, ic, res, width, height, n;
	double x, y;
	AccRange *rX, *rY;
	bool bRet = false, bContinue = false, dValid;
	lfPOINT *values = 0L;

	rX = rY = 0L;
	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);
	sprintf(text2, "b1:b%d", height);
	Dlg = new DlgRoot(RegDlg);
	hDlg = CreateDlgWnd("Linear regression analysis step 1/2", 50, 50, 380, 225, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:								// focus lost
			if(bContinue) res = -1;
			else if(Dlg->GetCheck(10)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 1:								// OK
			if(rX) delete rX;	if(rY) delete rY;
			rX = rY = 0L;						// check x-range
			if(Dlg->GetText(101, TmpTxt)) rX = new AccRange(TmpTxt);
			if(!(n = rX ? rX->CountItems() : 0)) {
				Dlg->SetCheck(4, 0L, true);
				res = -1;
				bContinue = true;
				ErrorBox("X-range not specified\nor not valid.");
				}
			else {							// check y-range
				if(Dlg->GetText(103, TmpTxt)) rY = new AccRange(TmpTxt);
				if(n != (rY ? rY->CountItems() : 0)) {
					res = -1;
					bContinue = true;
					ErrorBox("Y-range missing\nor not valid.\n"
						"Size must match X-range.");
					}
				}
			}
		}while (res <0);
	if(res==1 && n && rX && rY && (values =(lfPOINT*)calloc(nPoints=n, sizeof(lfPOINT)))){				//OK pressed
		Command(CMD_FLUSH, 0L, 0L);
		if(Dlg->GetText(101, TmpTxt)) xRange = strdup(TmpTxt);
		if(Dlg->GetText(103, TmpTxt)) yRange = strdup(TmpTxt);
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;		Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		rX->GetFirst(&i, &j);	rY->GetFirst(&k, &l);
		rX->GetNext(&i, &j);	rY->GetNext(&k, &l);
		if(Dlg->GetCheck(202)) type = 0x100;
		else if(Dlg->GetCheck(203)) type = 0x200;
		else if(Dlg->GetCheck(204)) type = 0x300;
		if(Dlg->GetCheck(212)) type |= 0x1000;
		else if(Dlg->GetCheck(213)) type |= 0x2000;
		else if(Dlg->GetCheck(214)) type |= 0x3000;
		ic = c = 0;
		if(Dlg->GetCheck(104)) Symbols = (Symbol**)calloc(nPoints, sizeof(Symbol*));
		do {
			if(data->GetValue(j, i, &x) && data->GetValue(l, k, &y)){
				dValid = true;
				switch(type & 0x700) {
				case 0x100:					//logarithmic x
					if(dValid = x > defs.min4log) values[ic].fx = log10(x);
					break;
				case 0x200:					//reciprocal x
					if(dValid = fabs(x) >defs.min4log) values[ic].fx = 1.0/x;
					break;
				case 0x300:					//square root x
					if(dValid = fabs(x) >defs.min4log) values[ic].fx = sqrt(x);
					break;
				default:	values[ic].fx = x;	break;		//linear x
					}
				if(dValid) switch(type & 0x7000) {
				case 0x1000:				//logarithmic y
					if(dValid = y > defs.min4log) values[ic].fy = log10(y);
					break;
				case 0x2000:				//reciprocal y
					if(dValid = fabs(y) > defs.min4log) values[ic].fy = 1.0/y;
					break;
				case 0x3000:				//square root y
					if(dValid = fabs(y) > defs.min4log) values[ic].fy = sqrt(y);
					break;
				default:	values[ic].fy = y;	break;		//linear y
					}
				if(dValid && Symbols && (Symbols[ic] = new Symbol(this, data, x, y, 
					SYM_CIRCLE, i, j, k, l))){
					Symbols[ic]->idx = c;
					}
				if(dValid) {
					CheckBounds(x, y);
					ic++;
					}
				}
			c++;
			}while(rX->GetNext(&i, &j) && rY->GetNext(&k, &l));
		if(ic) {
			if(Dlg->GetCheck(105) && (sde = new SDellipse(this, data, values, ic, type | 0x2))&&
				(bRet= sde->Command(CMD_INIT, 0L, 0L)))sde->Command(CMD_BOUNDS, &Bounds, 0L);
			else if((rLine = new RegLine(this, data, values, ic, type)) && 
				(bRet= rLine->PropertyDlg()))rLine->Command(CMD_BOUNDS, &Bounds, 0L);
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rX) delete rX;	if(rY) delete rY;
	if(values) free(values);
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Bubble plot properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
BubblePlot::PropertyDlg()
{
	TabSHEET tab1 = {0, 40, 10, "Data"};
	TabSHEET tab2 = {40, 85, 10, "Layout"};
	TabSHEET tab3 = {85, 130, 10, "Scaling"};
	char text1[100], text2[100], text3[100];
	FillDEF ShowFill;
	DlgInfo PlotDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 148, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 148, 25, 45, 12},
		{3, 500, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 130, 120},
		{5, 6, 200, ISPARENT, SHEET, &tab2, 5, 10, 130, 120},
		{6, 10, 300, ISPARENT, SHEET, &tab3, 5, 10, 130, 120},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for X Data", 10, 40, 60, 8},
		{101, 102, 0, 0x0L, EDTEXT, text1, 20, 50, 100, 10},
		{102, 103, 0, 0x0L, LTEXT, (void*)"range for Y Data", 10, 65, 60, 8},
		{103, 104, 0, 0x0L, EDTEXT, text2, 20, 75, 100, 10},
		{104, 105, 0, 0x0L, LTEXT, (void*)"range for sizes", 10, 90, 60, 8},
		{105, 0, 0, 0x0L, EDTEXT, text3, 20, 100, 100, 10},
		{200, 201, 0, 0x0L, LTEXT, (void*)"Select one of the following shapes", 10, 30, 110, 8},
		{201, 202, 0, CHECKED, SYMRADIO, (void *)SYM_CIRCLE, 30, 40, 20, 20},
		{202, 203, 0, 0x0L, SYMRADIO, (void *)SYM_RECT, 50, 40, 20, 20},
		{203, 204, 0, 0x0L, SYMRADIO, (void *)SYM_TRIAU, 70, 40, 20, 20},
		{204, 205, 0, 0x0L, SYMRADIO, (void *)SYM_TRIAD, 90, 40, 20, 20},
		{205, 206, 0, 0x0L, LTEXT, (void*)"outline:", 7, 67, 45, 8},
		{206, 207, 0, 0x0L, RTEXT, (void*)"color", 7, 75, 20, 8},
		{207, 208, 0, OWNDIALOG, COLBUTTON, (void *)BubbleLine.color, 29, 75, 25, 10},
		{208, 209, 0, 0x0L, RTEXT, (void*)"line width", 67, 75, 20, 8},
		{209, 210, 0, 0x0L, EDVAL1, &BubbleLine.width, 88, 75, 25, 10},
		{210, 211, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 114, 75, 15, 8},
		{211, 212, 0, 0x0L, LTEXT, (void*)"fill:", 7, 97, 45, 8},
		{212, 213, 0, 0x0L, RTEXT, (void*)"color", 7, 105, 20, 8},
		{213, 214, 0, TOUCHEXIT | OWNDIALOG, COLBUTTON, (void *)BubbleFill.color, 29, 105, 25, 10},
		{214, 215, 0, 0x0L, RTEXT, (void*)"pattern", 67, 105, 20, 8},
		{215, 0, 0, TOUCHEXIT | OWNDIALOG, FILLBUTTON, (void *)&ShowFill, 88, 105, 25, 10},
		{300, 301, 0, 0x0L, LTEXT, (void*)"Sizes are given as", 10, 30, 110, 8},
		{301, 302, 400, ISPARENT | CHECKED, GROUP, NULL, 0, 0, 0, 0},
		{302, 303, 0, 0x0L, LTEXT, (void*)"Proportionality (relative to circle)", 10, 75, 110, 8},
		{303, 0, 410, ISPARENT | CHECKED, GROUP, NULL, 0, 0, 0, 0},
		{400, 401, 0, CHECKED, RADIO1, (void *) Units[defs.cUnits].display, 40, 40, 45, 8},
		{401, 402, 0, 0x0L, RADIO1, (void*)"scaling with X axis", 40, 50, 45, 8},
		{402, 0, 0, 0x0L, RADIO1, (void*)"scaling with Y axis", 40, 60, 45, 8},
		{410, 411, 0, CHECKED, RADIO1, (void*)"diameter", 40, 85, 45, 8},
		{411, 412, 0, 0x0L, RADIO1, (void*)"circumference", 40, 95, 45, 8},
		{412, 0, 0, LASTOBJ, RADIO1, (void*)"area", 40, 105, 45, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, j, k, l, m, n, ic, res, width, height, BubbleType;
	double x, y, s;
	double tmp;
	bool bRetVal = false, bFillChanged, bContinue = false;
	AccRange *rX, *rY, *rS;
	LineDEF ShowFillLine ={0.2f, 1.0f, 0x0L, 0x0L};

	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);
	sprintf(text2, "b1:b%d", height);
	sprintf(text3, "c1:c%d", height);
	memcpy(&ShowFill, &BubbleFill, sizeof(FillDEF));
	if(BubbleFill.hatch) memcpy(&ShowFillLine, BubbleFill.hatch, sizeof(LineDEF));
	ShowFill.hatch = &ShowFillLine;
	Dlg = new DlgRoot(PlotDlg);
	hDlg = CreateDlgWnd("Create Bubble Plot", 50, 50, 400, 300, Dlg, 0x0L);
	rX = rY = rS = 0L;
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:								// focus lost
			if(bContinue) res = -1;
			else if(Dlg->GetCheck(10)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 213:					//fillcolor changed
			Dlg->GetColor(213, &ShowFill.color);
			Dlg->DoPlot(NULL);
			res = -1;
			break;
		case 215:					//copy color from pattern dialog
			Dlg->SetColor(213, ShowFill.color);
			bFillChanged = true;
			res = -1;
			break;
		case 1:						//OK button
			if(Dlg->GetText(101, text1) && Dlg->GetText(103, text2) && 
				Dlg->GetText(105, text3) && (rX = new AccRange(text1)) &&
				(rY = new AccRange(text2)) && (rS = new AccRange(text3))) {
				if((i = rX->CountItems()) == rY->CountItems() && i == rS->CountItems()){
					// OK pressed and ranges checked: exit loop and process data
					}
				else {
					if(rX) delete (rX);	if(rY) delete (rY);	if(rS) delete (rS);
					rX = rY = rS = 0L;
					ErrorBox("Ranges must be of equal size");
					Dlg->SetCheck(4, 0L, bContinue = true);
					res = -1;
					}
				}
			else res = -1;				//continue with dialog if error
			}
		}while (res <0);
	if(res ==1 && rX && rY && rS && (nPoints = rX->CountItems()) && 
		(Bubbles = (Bubble**)calloc(nPoints, sizeof(Bubble*)))) {
		//accept settings and create bubbles for plot
		if(Dlg->GetCheck(202)) BubbleType = BUBBLE_SQUARE;
		else if(Dlg->GetCheck(203)) BubbleType = BUBBLE_UPTRIA;
		else if(Dlg->GetCheck(204)) BubbleType = BUBBLE_DOWNTRIA;
		else BubbleType = BUBBLE_CIRCLE;
		if(Dlg->GetCheck(401)) BubbleType |= BUBBLE_XAXIS;
		else if(Dlg->GetCheck(402)) BubbleType |= BUBBLE_YAXIS;
		if(Dlg->GetCheck(411)) BubbleType |= BUBBLE_CIRCUM;
		else if(Dlg->GetCheck(412)) BubbleType |= BUBBLE_AREA;
		if(Dlg->GetValue(209, &tmp)) BubbleLine.width = (float)tmp;
		Dlg->GetColor(207, &BubbleLine.color);		Dlg->GetColor(213, &BubbleFill.color);
		rX->GetFirst(&i, &j);		rY->GetFirst(&k, &l);	rS->GetFirst(&m, &n);
		rX->GetNext(&i, &j);		rY->GetNext(&k, &l);	rS->GetNext(&m, &n);
		ic = 0;
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;		Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		if(Bubbles) do {
			if(data->GetValue(j, i, &x) && data->GetValue(l, k, &y) && data->GetValue(n, m, &s)){
				CheckBounds(x, y);
				Bubbles[ic++] = new Bubble(this, data, x, y, s, BubbleType, &ShowFill, 
					&BubbleLine, i, j, k, l, m, n);
				}
			}while(rX->GetNext(&i, &j) && rY->GetNext(&k, &l) && rS->GetNext(&m, &n));
		bRetVal = ic >0;
		}
	CloseDlgWnd(hDlg);
	if(rX) delete (rX);		if(rY) delete (rY);		if(rS) delete (rS);
	delete Dlg;
	return bRetVal;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Polar plot properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
PolarPlot::AddPlot()
{
	char text1[100], text2[100];
	DlgInfo PolDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 140, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 140, 25, 45, 12},
		{3, 0, 200, ISPARENT | CHECKED, GROUPBOX, (void*)" select template and data range ", 5, 10, 131, 100},
		{200, 201, 0, CHECKED | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 10, 20, 20, 20},
		{201, 202, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 30, 20, 20, 20},
		{202, 203, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 50, 20, 20, 20},
		{203, 204, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 70, 20, 20, 20},
		{204, 210, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 90, 20, 20, 20},
		{210, 211, 0, 0x0L, LTEXT, (void*)"range for x-data (circular or angular data)", 10, 50, 50, 8},
		{211, 212, 0, 0x0L, EDTEXT, (void*)text1, 20, 62, 100, 10},
		{212, 213, 0, 0x0L, LTEXT, (void*)"range for y-data (radial data)", 10, 75, 50, 8},
		{213, 0, 0, LASTOBJ, EDTEXT, (void*)text2, 20, 87, 100, 10}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, j, k, l, ic, n, res, width, height, cType = 200;
	bool bRet = false;
	double x, y;
	AccRange *rX = 0L, *rY = 0L;
	Symbol **Symbols = 0L;
	DataLine *TheLine = 0L;
	Plot **tmpPlots;
	Function *func;

	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);
	sprintf(text2, "b1:b%d", height);
	if(!(Dlg = new DlgRoot(PolDlg)))return false;
	hDlg = CreateDlgWnd("Add Polar Plot", 50, 50, 388, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 200: case 201:	case 202:	case 203:	case 204:
			if(res == 204) {
				Dlg->Activate(211, false);			Dlg->Activate(213, false);
				}
			else if(cType == 204) {
				Dlg->Activate(211, true);			Dlg->Activate(213, true);
				}
			if(res == cType) res = 1;
			else {
				cType = res;
				res = -1;
				}
			break;
			}
		}while (res <0);
	if(res == 1 && Dlg->GetText(211, text1) && Dlg->GetText(213, text2) && 
		(rX = new AccRange(text1)) && (rY = new AccRange(text2)) &&
		(n = rX ? rX->CountItems() : 0) && 
		(tmpPlots = (Plot**)realloc(Plots, (nPlots+2)*sizeof(Plot*)))) {
		Plots = tmpPlots;
		if(Dlg->GetCheck(200) || Dlg->GetCheck(201)) 
			Symbols = (Symbol**) calloc(n+1, sizeof(Symbol*));
		if(Dlg->GetCheck(201) || Dlg->GetCheck(202)) 
			TheLine = new DataLine(this, data, text1, text2);
		else if(Dlg->GetCheck(203))
			TheLine = new DataPolygon(this, data, text1, text2);
		else if(Dlg->GetCheck(204)) {
			if(func = new Function(this, data)){
				if(bRet = func->PropertyDlg()){
					Undo.SetGO(this, (GraphObj**) &Plots[nPlots++], func, 0L);
					memcpy(&Bounds, &Plots[nPlots-1]->Bounds, sizeof(fRECT));
					}
				else DeleteGO(func);
				}
			}
		rX->GetFirst(&i, &j);	rY->GetFirst(&k, &l);
		rX->GetNext(&i, &j);	rY->GetNext(&k, &l);
		ic = 0;
		if(Symbols || TheLine) {
			do {
				if(data->GetValue(j, i, &x) && data->GetValue(l, k, &y)){
					CheckBounds(y, y);
					if(Symbols)Symbols[ic++] = new Symbol(this,data,x,y,SYM_CIRCLE,i,j,k,l);
					}
				}while(rX->GetNext(&i, &j) && rY->GetNext(&k, &l));
			Undo.SetGO(this, (GraphObj**) &Plots[nPlots++], 
				new PlotScatt(this, data, ic, Symbols, TheLine), 0L);
			bRet = true;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rX) delete rX;	if(rY) delete rY;
	return bRet;
}

bool
PolarPlot::Config()
{
	TabSHEET tab1 = {0, 40, 10, "Plot"};
	DlgInfo PPDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 102, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 102, 25, 45, 12},
		{3, 0, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 90, 90},
		{100, 101, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 8, 30, 90, 50},
		{101, 0, 0, LASTOBJ, CHECKBOX, (void*)"show radial axis", 15, 85, 60, 9}};
	DlgRoot *Dlg;
	void *hDlg;
	int res;
	bool bRet = false;
	LineDEF OutLine;

	memcpy(&OutLine, defs.GetOutLine(), sizeof(LineDEF));
	if(Axes && Axes[0]) {
		OutLine.color = Axes[0]->GetColor(COL_AXIS);
		OutLine.width = Axes[0]->GetSize(SIZE_AXIS_LINE);
		}
	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)&OutLine, 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)&Fill, 0);
	Dlg = new DlgRoot(PPDlg);
	if(!(type & 0x01))Dlg->SetCheck(101, 0L, true);
	hDlg = CreateDlgWnd("Polar Plot properties", 50, 50, 310, 234, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		}while (res < 0);
	if(res == 1){						//OK pressed
		if(Dlg->GetCheck(101)) type &= ~0x01;
		else type |= 0x01;
		OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&OutLine, 0);
		if(Axes && Axes[0]) {
			Axes[0]->SetColor(COL_AXIS, OutLine.color);
			Axes[0]->SetSize(SIZE_AXIS_LINE, OutLine.width);
			}
		OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&Fill, 0);
		if(Fill.hatch) memcpy(&FillLine, Fill.hatch, sizeof(LineDEF));
		Fill.hatch = &FillLine;
		bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

bool
PolarPlot::PropertyDlg()
{
	TabSHEET tab1 = {0, 45, 10, "Coordinates"};
	TabSHEET tab2 = {45, 70, 10, "Type"};
	char text1[100], text2[100];
	double lox = 0.0, hix = 360.0, fcx =10.0, fcy = 20.0, frad=40.0;
	DlgInfo PolDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 140, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 140, 25, 45, 12},
		{3, 50, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 131, 100},
		{5, 10, 200, ISPARENT | TOUCHEXIT, SHEET, &tab2, 5, 10, 131, 100},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"angular range (full circle)", 10, 25, 60, 8},
		{101, 102, 0, 0x0L, RTEXT, (void*)"min =", 5, 37, 25, 8},
		{102, 103, 0, 0x0L, EDVAL1, &lox, 30, 37, 30, 10},
		{103, 104, 0, 0x0L, RTEXT, (void*)"max =", 60, 37, 25, 8},
		{104, 105, 0, 0x0L, EDVAL1, &hix, 85, 37, 30, 10},
		{105, 106, 0, 0x0L, RTEXT, (void*)"angular offset:", 10, 49, 50, 8},
		{106, 107, 0, 0x0L, EDVAL1, &offs, 62, 49, 30, 10},
		{107, 108, 0, 0x0L, LTEXT, (void*)"position of center:", 10, 65, 40, 8},
		{108, 109, 0, 0x0L, RTEXT, (void*)"x =", 5, 77, 25, 8},
		{109, 110, 0, 0x0L, EDVAL1, &fcx, 30, 77, 30, 10},
		{110, 111, 0, 0x0L, RTEXT, (void*)"y =", 60, 77, 25, 8},
		{111, 112, 0, 0x0L, EDVAL1, &fcy, 85, 77, 30, 10},
		{112, 113, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 117, 77, 15, 8}, 
		{113, 114, 0, 0x0L, EDVAL1, &frad, 62, 89, 30, 10},
		{114, 115, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 94, 89, 15, 8},
		{115, 0, 0, 0x0L, RTEXT, (void*)"radius:", 10, 89, 50, 8},
		{200, 201, 0, CHECKED | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 10, 25, 20, 20},
		{201, 202, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 30, 25, 20, 20},
		{202, 203, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 50, 25, 20, 20},
		{203, 204, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 70, 25, 20, 20},
		{204, 210, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PolarTempl, 90, 25, 20, 20},
		{210, 211, 0, 0x0L, LTEXT, (void*)"range for x-data (circular or angular data)", 10, 55, 50, 8},
		{211, 212, 0, 0x0L, EDTEXT, (void*)text1, 20, 67, 100, 10},
		{212, 213, 0, 0x0L, LTEXT, (void*)"range for y-data (radial data)", 10, 80, 50, 8},
		{213, 0, 0, LASTOBJ, EDTEXT, (void*)text2, 20, 92, 100, 10}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, width, height, i, j, k, l, n, ic, cType = 200;
	double x, y;
	bool bRet = false, bType = false;
	AccRange *rX = 0L, *rY = 0L;
	Symbol **Symbols = 0L;
	DataLine *TheLine = 0L;
	TextDEF tlbdef;
	AxisDEF ang_axis, rad_axis;

	if(Plots) return Config();
	if(parent) {
		frad = (parent->GetSize(SIZE_DRECT_BOTTOM) - parent->GetSize(SIZE_DRECT_TOP))/2.0f;
		fcx = parent->GetSize(SIZE_GRECT_LEFT) + parent->GetSize(SIZE_DRECT_LEFT)*1.5 + frad;
		fcy = parent->GetSize(SIZE_GRECT_TOP) + parent->GetSize(SIZE_DRECT_TOP) + frad;
		}
	else return false;
	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);
	sprintf(text2, "b1:b%d", height);
	tlbdef.ColTxt = defs.Color(COL_AXIS);
	tlbdef.ColBg = 0x00ffffffL;
	tlbdef.RotBL = tlbdef.RotCHAR = 0.0f;
	tlbdef.fSize = defs.GetSize(SIZE_TICK_LABELS);
	tlbdef.Align = TXA_VCENTER | TXA_HRIGHT;
	tlbdef.Style = TXS_NORMAL;
	tlbdef.Mode = TXM_TRANSPARENT;
	tlbdef.Font = FONT_HELVETICA;
	tlbdef.text = 0L;
	if(!(Dlg = new DlgRoot(PolDlg)))return false;
	hDlg = CreateDlgWnd("Create Polar Plot", 50, 50, 388, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:
			if(Dlg->GetCheck(10)) res = -1;
			break;
		case 5:
			bType = true;
			res = -1;
			break;
		case 1:
			if(!bType) {		//the 'Type' sheet must have been visited
				bType = true;
				Dlg->SetCheck(5, 0L, true);
				res = -1;
				}
			break;
		case 200: case 201:	case 202:	case 203:	case 204:
			if(res == 204) {
				Dlg->Activate(211, false);			Dlg->Activate(213, false);
				}
			else if(cType == 204) {
				Dlg->Activate(211, true);			Dlg->Activate(213, true);
				}
			if(res == cType) res = 1;
			else {
				cType = res;
				res = -1;
				}
			break;
			}
		}while (res <0);
	if(res == 1) {
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;		Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		//set axis information in ang_axis and rad_axis
		ang_axis.owner = rad_axis.owner = 0L;
		ang_axis.breaks = rad_axis.breaks = 0L;
		ang_axis.nBreaks = rad_axis.nBreaks = 0;
		ang_axis.flags = AXIS_ANGULAR;	
		rad_axis.flags = AXIS_RADIAL | AXIS_DEFRECT;
		Dlg->GetValue(109, &ang_axis.Center.fx);	
		rad_axis.Center.fx = ang_axis.Center.fx;
		Dlg->GetValue(111, &ang_axis.Center.fy);	
		rad_axis.Center.fy = ang_axis.Center.fy;
		Dlg->GetValue(113, &ang_axis.Radius);
		rad_axis.Radius = ang_axis.Radius;
		Dlg->GetValue(102, &ang_axis.min);
		Dlg->GetValue(104, &ang_axis.max);
		Dlg->GetValue(106, &offs);
		ang_axis.loc[0].fy = ang_axis.loc[1].fy = ang_axis.Center.fy + ang_axis.Radius;
		ang_axis.loc[0].fx = ang_axis.Center.fx - ang_axis.Radius;
		ang_axis.loc[1].fx = ang_axis.Center.fx + ang_axis.Radius;
		rad_axis.loc[0].fx = rad_axis.loc[1].fx = 
			parent->GetSize(SIZE_GRECT_LEFT) + parent->GetSize(SIZE_DRECT_LEFT);
		rad_axis.loc[0].fy = rad_axis.Center.fy - rad_axis.Radius;
		rad_axis.loc[1].fy = rad_axis.Center.fy;
		if(Dlg->GetText(211, text1) && Dlg->GetText(213, text2) && 
			(rX = new AccRange(text1)) && (rY = new AccRange(text2)) &&
			(n = rX ? rX->CountItems() : 0) && (Plots = (Plot**)calloc(2, sizeof(Plot*)))) {
			if(Dlg->GetCheck(200) || Dlg->GetCheck(201)) 
				Symbols = (Symbol**) calloc(n+1, sizeof(Symbol*));
			if(Dlg->GetCheck(201) || Dlg->GetCheck(202)) 
				TheLine = new DataLine(this, data, text1, text2);
			else if(Dlg->GetCheck(203))
				TheLine = new DataPolygon(this, data, text1, text2);
			else if(Dlg->GetCheck(204)) {
				if(Plots[nPlots++] = new Function(this, data)){
					if(bRet = Plots[nPlots-1]->PropertyDlg())
						memcpy(&Bounds, &Plots[nPlots-1]->Bounds, sizeof(fRECT));
					else {
						DeleteGO(Plots[nPlots-1]);
						Plots[nPlots-1] = 0L;
						}
					}
				}
			rX->GetFirst(&i, &j);	rY->GetFirst(&k, &l);
			rX->GetNext(&i, &j);	rY->GetNext(&k, &l);
			ic = 0;
			if(Symbols || TheLine) do {
				if(data->GetValue(j, i, &x) && data->GetValue(l, k, &y)){
					CheckBounds(y, y);
					if(Symbols) Symbols[ic++] = new Symbol(this, data, x, y, 
						SYM_CIRCLE, i, j, k, l);
					}
				}while(rX->GetNext(&i, &j) && rY->GetNext(&k, &l));
			rad_axis.min = Bounds.Ymin;			rad_axis.max = Bounds.Ymax;
			NiceAxis(&rad_axis, 4);
			ang_axis.Start = ang_axis.Step = 0.0;
			if(Symbols || TheLine) 
				Plots[nPlots++] = new PlotScatt(this, data, ic, Symbols, TheLine);
			if(Plots[0] && (Axes = (GraphObj**)calloc(3, sizeof(Axis*)))){
				Axes[0] = new Axis(this, data, &ang_axis, ang_axis.flags);
				Axes[1] = new Axis(this, data, &rad_axis, 
					rad_axis.flags | AXIS_AUTOTICK | AXIS_NEGTICKS);
				Axes[1]->SetSize(SIZE_LB_XDIST, 
					NiceValue(-defs.GetSize(SIZE_AXIS_TICKS)*6.0)); 
				Axes[1]->SetSize(SIZE_TLB_XDIST, 
					NiceValue(-defs.GetSize(SIZE_AXIS_TICKS)*2.0)); 
				Axes[1]->Command(CMD_TLB_TXTDEF, (void*)&tlbdef, 0L);
				nAxes = 2;
				bRet = true;
				}
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rX) delete rX;	if(rY) delete rY;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Box plot properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
BoxPlot::PropertyDlg()
{
	TabSHEET tab1 = {0, 36, 10, "Summary"};
	TabSHEET tab2 = {36, 56, 10, "Box"};
	TabSHEET tab3 = {56, 89, 10, "Whisker"};
	TabSHEET tab4 = {89, 119, 10, "Symbol"};
	TabSHEET tab5 = {119, 140, 10, "Line"};
	char text1[100];
	DlgInfo PlotDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 158, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 158, 25, 45, 12},
		{3, 800, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 0, 0x0L, LTEXT, (void*)"spreadsheet range for common X values", 15, 88, 120, 8},
		{5, 6, 0, 0x0L, EDTEXT, text1, 25, 100, 100, 10},
		{6, 7, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 140, 75},
		{7, 8, 200, ISPARENT, SHEET, &tab2, 5, 10, 140, 75},
		{8, 9, 300, ISPARENT, SHEET, &tab3, 5, 10, 140, 75},
		{9, 10, 400, ISPARENT, SHEET, &tab4, 5, 10, 140, 75},
		{10, 20, 500, ISPARENT, SHEET, &tab5, 5, 10, 140, 75},
		{20, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"items:", 15, 30, 15, 8},
		{101, 102, 0, 0x0L, CHECKBOX, (void*)" boxes (rectangles)", 40, 30, 60, 8},
		{102, 103, 0, 0x0L, CHECKBOX, (void*)" whiskers (error bars)", 40, 40, 60, 8},
		{103, 104, 0, 0x0L, CHECKBOX, (void*)" symbol in the middle", 40, 50, 60, 8},
		{104, 105, 0, 0x0L, CHECKBOX, (void*)" line connecting close - open", 40, 60, 60, 8},
		{105, 0, 0, 0x0L, CHECKBOX, (void*)" horizontal plot", 15, 72, 60, 8},
		{200, 201, 0, 0x0L, LTEXT, (void*)"range for high values", 15, 30, 60, 8},
		{201, 202, 0, 0x0L, EDTEXT, 0L, 25, 40, 100, 10},
		{202, 203, 0, 0x0L, LTEXT, (void*)"range for low values", 15, 55, 60, 8},
		{203, 0, 0, 0x0L, EDTEXT, 0L, 25, 65, 100, 10},
		{300, 301, 0, 0x0L, LTEXT, (void*)"range for maxima", 15, 30, 60, 8},
		{301, 302, 0, 0x0L, EDTEXT, 0L, 25, 40, 100, 10},
		{302, 303, 0, 0x0L, LTEXT, (void*)"range for minima", 15, 55, 60, 8},
		{303, 0, 0, 0x0L, EDTEXT, 0L, 25, 65, 100, 10},
		{400, 401, 0, 0x0L, LTEXT, (void*)"mark centers with symbols,", 15, 30, 60, 8},
		{401, 402, 0, 0x0L, LTEXT, (void*)"range for centers (means):", 15, 40, 60, 8},
		{402, 0, 0, 0x0L, EDTEXT, 0L, 25, 55, 100, 10},
		{500, 501, 0, 0x0L, LTEXT, (void*)"range for first value (open)", 15, 30, 60, 8},
		{501, 502, 0, 0x0L, EDTEXT, 0L, 25, 40, 100, 10},
		{502, 503, 0, 0x0L, LTEXT, (void*)"range for second value (close)", 15, 55, 60, 8},
		{503, 0, 0, LASTOBJ, EDTEXT, 0L, 25, 65, 100, 10}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, j, k, l, m, n, ic, res, width, height;
	bool bHor, bRet, bContinue = false;
	lfPOINT fp1, fp2;
	double x, y1, y2;
	AccRange *rX, *rB1, *rB2, *rW1, *rW2, *rS, *rL1, *rL2;

	rX = rB1 = rB2 = rW1 = rW2 = rS = rL1 = rL2 = 0L;
	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);
	Dlg = new DlgRoot(PlotDlg);
	hDlg = CreateDlgWnd("Box and Whisker Plot", 50, 50, 420, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:
			if(bContinue) res = -1;
			else if(Dlg->GetCheck(20)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 1:
			if(rX) delete rX;
			if(rB1) delete rB1;			if(rB2) delete rB2;
			if(rW1) delete rW1;			if(rW2) delete rW2;
			if(rS) delete rS;
			if(rL1) delete rL1;			if(rL2) delete rL2;
			rX = rB1 = rB2 = rW1 = rW2 = rS = rL1 = rL2 = 0L;
			bHor = Dlg->GetCheck(105);
			if(Dlg->GetText(5, text1)) rX = new AccRange(text1);
			n = rX ? rX->CountItems() : 0;
			if(!n) {
				ErrorBox("Common X-range not specified\nor not valid.");
				bContinue = true;
				res = -1;
				}
			if(n && Dlg->GetCheck(101)) {		//do boxes ?
				if(Dlg->GetText(201, TmpTxt)) rB1 = new AccRange(TmpTxt);
				if(Dlg->GetText(203, TmpTxt)) rB2 = new AccRange(TmpTxt);
				if(!rB1 || !rB2 || n != rB1->CountItems() || n != rB2->CountItems()) {
					ErrorBox("Range for boxes missing\nor not valid.\n"
						"Size must match common X-range.");
					Dlg->SetCheck(7, 0L, true);
					bContinue = true;
					res = -1;
					}
				}
			if(n && Dlg->GetCheck(102)) {		//do whiskers ?
				if(Dlg->GetText(301, TmpTxt)) rW1 = new AccRange(TmpTxt);
				if(Dlg->GetText(303, TmpTxt)) rW2 = new AccRange(TmpTxt);
				if(!rW1 || !rW2 || n != rW1->CountItems() || n != rW2->CountItems()) {
					ErrorBox("Range for whiskers missing\nor not valid.\n"
						"Size must match common X-range.");
					Dlg->SetCheck(8, 0L, true);
					bContinue = true;
					res = -1;
					}
				}
			if(n && Dlg->GetCheck(103)) {		//do symbols ?
				if(Dlg->GetText(402, TmpTxt)) rS = new AccRange(TmpTxt);
				if(!rS || n != rS->CountItems()) {
					ErrorBox("Range for symbols missing\nor not valid.\n"
						"Size must match common X-range.");
					bContinue = true;
					Dlg->SetCheck(9, 0L, true);
					res = -1;
					}
				}
			if(n && Dlg->GetCheck(104)) {		//do line ?
				if(Dlg->GetText(501, TmpTxt)) rL1 = new AccRange(TmpTxt);
				if(Dlg->GetText(503, TmpTxt)) rL2 = new AccRange(TmpTxt);
				if(!rL1 || !rL2 || n != rL1->CountItems() || n != rL2->CountItems()) {
					ErrorBox("Range for line missing\nor not valid.\n"
						"Size must match common X-range.");
					Dlg->SetCheck(10, 0L, true);
					bContinue = true;
					res = -1;
					}
				}
			if(n && res > 0 && !rB1 && !rB2 && !rW1 && !rW2 && !rS && !rL1 && !rL2) {
				ErrorBox("Nothing to do !\n\nSelect at least one of either\n"
					"Box, Whisker, Symbol or Line.");
				bContinue = true;
				res = -1;
				}
			break;
			}
		}while (res < 0);
	bRet = false;
	if(res == 1 && n && rX){			//ok: create objects for plot
		nPoints = n;
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;		Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		if(rB1 && rB2) {
			//DEBUG: delete existing objects first
			Boxes =(Box**)calloc(nPoints, sizeof(Box*));
			if(Boxes) {
				rX->GetFirst(&i, &j);	rB1->GetFirst(&k, &l);	rB2->GetFirst(&m, &n);
				rX->GetNext(&i, &j);	rB1->GetNext(&k, &l);	rB2->GetNext(&m, &n);
				ic = 0;
				do {
					if(data->GetValue(j, i, &x) && data->GetValue(l, k, &y1) && 
						data->GetValue(n, m, &y2)){
						if(bHor) {
							fp1.fx = y2;	fp2.fx = y1;		fp1.fy = fp2.fy = x;
							CheckBounds(y1, x);			CheckBounds(y2, x);
							Boxes[ic++] = new Box(this, data, fp1, fp2, 0, m, n, i, j, k, l, i, j);
							}
						else {
							fp1.fy = y2;	fp2.fy = y1;		fp1.fx = fp2.fx = x;
							CheckBounds(x, y1);			CheckBounds(x, y2);
							Boxes[ic++] = new Box(this, data, fp1, fp2, 0, i, j, m, n, i, j, k, l);
							}
						}
					}while(rX->GetNext(&i, &j) && rB1->GetNext(&k, &l) && rB2->GetNext(&m, &n));
				if(ic) bRet = true;
				BoxDist.fx = BoxDist.fy = GetSize(bHor ? SIZE_BOXMINY : SIZE_BOXMINX);
				}
			}
		if(rW1 && rW2) {
			Whiskers = (Whisker**)calloc(nPoints, sizeof(Whisker*));
			if(Whiskers) {
				rX->GetFirst(&i, &j);	rW1->GetFirst(&k, &l);	rW2->GetFirst(&m, &n);
				rX->GetNext(&i, &j);	rW1->GetNext(&k, &l);	rW2->GetNext(&m, &n);
				ic = 0;
				do {
					if(data->GetValue(j, i, &x) && data->GetValue(l, k, &y1) && 
						data->GetValue(n, m, &y2)){
						if(bHor) {
							fp1.fx = y2;	fp2.fx = y1;		fp1.fy = fp2.fy = x;
							CheckBounds(y1, x);			CheckBounds(y2, x);
							Whiskers[ic++] = new Whisker(this, data, fp1, fp2, 0, m, n, i, j, k, l, i, j);
							}
						else {
							fp1.fy = y2;	fp2.fy = y1;		fp1.fx = fp2.fx = x;
							CheckBounds(x, y1);			CheckBounds(x, y2);
							Whiskers[ic++] = new Whisker(this, data, fp1, fp2, 0, i, j, m, n, i, j, k, l);
							}
						}
					}while(rX->GetNext(&i, &j) && rW1->GetNext(&k, &l) && rW2->GetNext(&m, &n));
				if(ic) bRet = true;
				}
			}
		if(rS) {
			Symbols = (Symbol**)calloc(nPoints, sizeof(Symbol*));
			if(Symbols) {
				rX->GetFirst(&i, &j);	rS->GetFirst(&k, &l);
				rX->GetNext(&i, &j);	rS->GetNext(&k, &l);
				ic = 0;
				do {
					if(data->GetValue(j, i, &x) && data->GetValue(l, k, &y1)){
						if(bHor) {
							CheckBounds(y1, x);
							Symbols[ic++] = new Symbol(this, data, y1, x, 
								SYM_PLUS, k, l, i, j);
							}
						else {
							CheckBounds(x, y1);
							Symbols[ic++] = new Symbol(this, data, x, y1, 
								SYM_PLUS, i, j, k, l);
							}
						}
					}while(rX->GetNext(&i, &j) && rS->GetNext(&k, &l));
				if(ic) bRet = true;
				}
			}
		if(rL1 && rL2) {
			Dlg->GetText(501, TmpTxt);			i = strlen(TmpTxt);
			TmpTxt[i++] = ';';					TmpTxt[i++] = ' ';
			Dlg->GetText(503, TmpTxt+i);
			TheLine = new DataLine(this, data, text1, TmpTxt);
			bRet = true;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rX) delete rX;
	if(rB1) delete rB1;			if(rB2) delete rB2;
	if(rW1) delete rW1;			if(rW2) delete rW2;
	if(rS) delete rS;
	if(rL1) delete rL1;			if(rL2) delete rL2;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// create density distribution plot 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
DensDisp::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Data"};
	TabSHEET tab2 = {25, 52, 10, "Style"};
	char text1[100], text2[100];
	DlgInfo PlotDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 148, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 148, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 130, 100},
		{5, 10, 200, TOUCHEXIT | ISPARENT, SHEET, &tab2, 5, 10, 130, 100},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for direction (time, depth) data", 10, 30, 60, 8},
		{101, 102, 0, 0x0L, EDTEXT, text1, 20, 40, 100, 10},
		{102, 103, 0, 0x0L, LTEXT, (void*)"range for width (density) data", 10, 55, 60, 8},
		{103, 104, 0, 0x0L, EDTEXT, text2, 20, 65, 100, 10},
		{104, 0, 0, 0x0L, CHECKBOX, (void*)"vertical profile", 10, 90, 100, 8},
		{200, 201, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 25, 30, 90, 45},
		{201, 202, 0, TOUCHEXIT | CHECKED, RADIO1, (void*)"symmetric bars", 25, 80, 60, 8},
		{202, 203, 0, TOUCHEXIT, RADIO1, 0L, 25, 88, 60, 8},
		{203, 0, 0, TOUCHEXIT | LASTOBJ, RADIO1, 0L, 25, 96, 60, 9}};
	DlgRoot *Dlg;
	void *hDlg;
	int n, res, width, height, align = 0;
	bool bRet = false, bContinue = false, bVert;
	AccRange *rX = 0L, *rY = 0L;

	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)defs.GetOutLine(), 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)defs.GetFill(), 0);
	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);
	sprintf(text2, "b1:b%d", height);
	Dlg = new DlgRoot(PlotDlg);
	hDlg = CreateDlgWnd("Density profile", 50, 50, 420, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:
			if(bContinue) res = -1;
			else if(Dlg->GetCheck(10)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 5:
			if(Dlg->GetCheck(104)) {
				Dlg->SetText(202, "bars right");	Dlg->SetText(203, "bars left");
				}
			else {
				Dlg->SetText(202, "bars up");		Dlg->SetText(203, "bars down");
				}
			res = -1;
			break;
		case 201:	case 202:	case 203:
			align = res - 201;
			res = -1;
			break;
		case 1:
			if(rX) delete rX;	if(rY) delete rY;
			rX = rY = 0L;
			if(Dlg->GetText(101, TmpTxt)) rX = new AccRange(TmpTxt);
			n = rX ? rX->CountItems() : 0;
			if(!n) {
				ErrorBox("direction range not specified\nor not valid.");
				bContinue = true;
				res = -1;
				}
			if(n && Dlg->GetText(103, TmpTxt) && (rY = new AccRange(TmpTxt))){
				if(n != rY->CountItems()) {
					ErrorBox("both ranges must be given\nand must have same size");
					bContinue = true;
					res = -1;
					}
				}
			}
		}while (res < 0);
	if(res == 1 && n && rX && rY) {
		type = (bVert = Dlg->GetCheck(104)) ? align | 0x10 : align;
		if(Dlg->GetText(101, TmpTxt)) xRange=strdup(TmpTxt);
		if(Dlg->GetText(103, TmpTxt)) yRange=strdup(TmpTxt);
		OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&DefLine, 0);
		OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&DefFill, 0);
		if(DefFill.hatch) memcpy(&DefFillLine, DefFill.hatch, sizeof(LineDEF));
		DefFill.hatch = &DefFillLine;
		DoUpdate();
		bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rX) delete rX;		if(rY) delete rY;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// create stacked bar or stacked polygon 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int com_StackDlg(int res, DlgRoot *Dlg, AccRange **rX, int *nx, char ***rd, int *currYR,
	AccRange **rY, bool *bContinue, int *ny, int *maxYR, bool *updateYR)
{
	char **tmprd;

	switch (res) {
		case 1:
			if(rX && nx && Dlg->GetText(101, TmpTxt) && TmpTxt[0] && 
				(*rX = new AccRange(TmpTxt))) *nx = rX[0]->CountItems();
			else if(nx) *nx = 0;
			if(Dlg->GetText(154, TmpTxt) && TmpTxt[0]) {
				if(rd[0][*currYR]) free(rd[0][*currYR]);
				rd[0][*currYR] = strdup(TmpTxt);
				}
			break;
		case 155:
			res = -1;
			*ny = 0;
			if(rX) {
				if(!(*currYR) && Dlg->GetText(101, TmpTxt) && TmpTxt[0]) {
					if(*rX = new AccRange(TmpTxt)){
						*nx = rX[0]->CountItems();
						delete *rX;
						*rX = 0L;
						}
					}
				if(!(*nx)) {
					ErrorBox("X-range is empty\nor not valid!\n\nEnter a valid range\n"
						"for common x-values.");
					*bContinue = true;
					break;
					}
				}
			if(Dlg->GetText(154, TmpTxt) && TmpTxt[0]) {
				if(*rY = new AccRange(TmpTxt)){
					*ny = rY[0]->CountItems();
					delete *rY;
					*rY = 0L;
					}
				}
			if(!(*ny)) {
				ErrorBox("Y-range is empty\nor not valid!\n\nEnter a valid range\n"
					"for y-values with the same\nsize as the x-range.");
				*bContinue = true;
				break;
				}
			if((*currYR)+1 > *maxYR) {
				tmprd = (char**)realloc(*rd, sizeof(char*)*((*currYR)+2));
				if(tmprd) *rd = tmprd;
				else break;
				*maxYR = (*currYR)+1;
				rd[0][*currYR] = 0L;
				rd[0][(*currYR)+1] = 0L;
				}
			if(rd[0][*currYR]) free(rd[0][*currYR]);
			rd[0][*currYR] = strdup(TmpTxt);	//store y-ranges
			*updateYR = true;
			(*currYR)++;
			Dlg->SetText(154, rd[0][*currYR]);
			Dlg->Activate(154, true);
			break;
		case 156:
			if(Dlg->GetText(154, TmpTxt)){
				if(rd[0][*currYR]) free(rd[0][*currYR]);
				rd[0][*currYR] = strdup(TmpTxt);
				}
			else if(*currYR == *maxYR) (*maxYR)--;
			(*currYR)--;
			Dlg->SetText(154, rd[0][*currYR]);
			*updateYR = true;
			res = -1;
			break;
		}
	return res;
}

bool
StackBar::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Data"};
	TabSHEET tab2 = {25, 55, 10, "Details"};
	TabSHEET tab3 = {55, 90, 10, "Scheme"};
	DlgInfo StackBarDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 158, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 158, 25, 45, 12},
		{3, 0, 10, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{10, 11, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 140, 100},
		{11, 12, 200, ISPARENT, SHEET, &tab2, 5, 10, 140, 100},
		{12, 20, 300, ISPARENT, SHEET, &tab3, 5, 10, 140, 100},
		{20, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for common x values", 15, 30, 60, 8},
		{101, 152, 0, 0x0L, EDTEXT, TmpTxt, 25, 40, 100, 10},
		{152, 153, 0, ISPARENT | CHECKED, GROUPBOX, (void*)" ranges for y values ", 12, 60, 128, 45},
		{153, 154, 0, 0x0L, LTEXT, 0L, 25, 65, 60, 8},
		{154, 155, 0, 0x0L, EDTEXT, 0L, 25, 75, 100, 10},
		{155, 156, 0, 0x0L, PUSHBUTTON, (void*)"Next >>", 95, 87, 30, 12},
		{156, 0, 0, 0x0L, PUSHBUTTON, (void*)"<< Prev.", 60, 87, 35, 12},
		{200, 201, 0, CHECKED, RADIO1, (void*)" add each y to start value", 25, 35, 60, 8},
		{201, 202, 0, 0x0L, RADIO1, (void*)" subtract each y from start value", 25, 50, 60, 8},
		{202, 203, 0, 0x0L, RTEXT, (void*)"start value:", 31, 65, 38, 8},
		{203, 204, 0, 0x0L, EDVAL1, &StartVal, 70, 65, 30, 10},
		{204, 0, 0, 0x0L, CHECKBOX, (void*)" horizontal plot", 25, 90, 60, 8},
		{300, 0, 0, LASTOBJ | NOSELECT, ODBUTTON, (void*)(OD_scheme), 20, 35, 80, 60}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, sc, j, res, width, height, currYR = 0, maxYR = 0, nx = 0, ny;
	bool updateYR = true, bContinue = false, bSub, bRet = false, bHor;
	char **rd;
	AccRange *rX = 0L, *rY = 0L;

	data->GetSize(&width, &height);
	sprintf(TmpTxt, "a1:a%d", height);
	if(!(rd = (char**)calloc(1, sizeof(char*))))return false;
	Dlg = new DlgRoot(StackBarDlg);
	hDlg = CreateDlgWnd(Id == GO_STACKBAR ? (char*)"Stacked bar plot" : 
		(char*)"Stacked polygons", 50, 50, 420, 260, Dlg, 0x0L);
	do {
		if(updateYR) {
			if(currYR >0) {
				Dlg->ShowItem(156, true);				Dlg->Activate(101, false);
				}
			else {
				Dlg->ShowItem(156, false);				Dlg->Activate(101, true);
				}
			sprintf(TmpTxt,"y-values # %d/%d", currYR+1, maxYR+1);
			//SetText will also cause a redraw of the whole dialog
			Dlg->SetText(153, TmpTxt);
			updateYR = false;
			}
		LoopDlgWnd();
		res = Dlg->GetResult();
		ny = 0;
		if(rX) delete rX;
		rX = 0L;
		switch(res) {
		case 0:
			if(bContinue || Dlg->GetCheck(20)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 1:		
			Dlg->GetValue(203, &StartVal);
			bSub = Dlg->GetCheck(201);			bHor = Dlg->GetCheck(204);
		case 155:		case 156:
			res = com_StackDlg(res, Dlg, &rX, &nx, &rd, &currYR,
				&rY, &bContinue, &ny, &maxYR, &updateYR);
			break;
			}
		}while (res < 0);
	if(res == 1 && nx && rX && rd && rd[0] && rd[0][0]){	//accept settings and create plot
		maxYR++;
		for(i = j = 0; i < maxYR; i++) {
			if(i) j += sprintf(TmpTxt+j, "&");
			j += sprintf(TmpTxt+j, "%s", rd[i]);
			}
		ssYrange = strdup(TmpTxt);
		if(Dlg->GetText(101, TmpTxt)) ssXrange = strdup(TmpTxt);
		cum_data_mode = Dlg->GetCheck(200) ? 1 : 2;
		if(Id == GO_STACKPG) cum_data_mode += 2;
		CumData = CreaCumData(ssXrange, ssYrange, cum_data_mode, StartVal);
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;		Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		//do stacked bar
		if(Id == GO_STACKBAR){
			numPlots = maxYR;
			if(Boxes = (BoxPlot**)calloc(numPlots, sizeof(BoxPlot*))) 
				for(i = sc = 0; i < (maxYR); i++) {
					if(Boxes[i]= new BoxPlot(this, CumData, Dlg->GetCheck(204)?2:1, 0, i+1, i+2)){
					Boxes[i]->Command(CMD_UPDATE, 0L, 0L);
					Boxes[i]->Command(CMD_AUTOSCALE, 0L, 0L);
					Boxes[i]->Command(CMD_BOX_FILL, GetSchemeFill(&sc), 0L);
					}
				}
			}
		//do stacked polygon
		else if(Id == GO_STACKPG){
			numPG = maxYR;			sprintf(TmpTxt, "a1:a%d", nx*2);
			if(Polygons=(DataPolygon**)calloc(numPG,sizeof(DataPolygon*)))for(i=sc=0;i<maxYR;i++){
				sprintf(TmpTxt+20, "%c1:%c%d", 'c'+i, 'c'+i, nx*2);
				if(Dlg->GetCheck(204)) Polygons[i]=new DataPolygon(this,CumData,TmpTxt+20,TmpTxt);
				else Polygons[i] = new DataPolygon(this, CumData, TmpTxt, TmpTxt+20);
				if(Polygons[i]) {
					Polygons[i]->Command(CMD_AUTOSCALE, 0L, 0L);
					Polygons[i]->Command(CMD_PG_FILL, GetSchemeFill(&sc), 0L);
					}
				}
			}
		if(Bounds.Xmax >= Bounds.Xmin && Bounds.Ymax >= Bounds.Ymin) bRet = true;
		else bRet = false;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rd) {
		for (i = 0; i < maxYR; i++)	if(rd[i]) free(rd[i]);
		free(rd);
		}
	if(rX) delete rX;		if(rY) delete rY;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// create grouped bars chart
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
GroupBars::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Data"};
	TabSHEET tab2 = {25, 55, 10, "Details"};
	TabSHEET tab3 = {55, 90, 10, "Scheme"};
	double start = 1.0, step = 1.0, bw = 100.0, gg = 100.0;
	DlgInfo GBDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 130, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 130, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 90},
		{5, 6, 200, ISPARENT, SHEET, &tab2, 5, 10, 120, 90},
		{6, 10, 300, ISPARENT, SHEET, &tab3, 5, 10, 120, 90},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"Get values from spreadsheet:", 10, 25, 60, 8},
		{101, 150, 0, 0x0L, LTEXT, (void*)"All ranges should have equal size!", 10, 33, 60, 8},
		{150, 0, 153, ISPARENT | CHECKED, GROUPBOX, (void*)" ranges for y values ", 10, 50, 110, 45},
		{153, 154, 0, 0x0L, LTEXT, 0L, 15, 55, 60, 8},
		{154, 155, 0, 0x0L, EDTEXT, 0L, 15, 65, 100, 10},
		{155, 156, 0, 0x0L, PUSHBUTTON, (void*)"Next >>", 85, 77, 30, 12},
		{156, 0, 0, 0x0L, PUSHBUTTON, (void*)"<< Prev.", 50, 77, 35, 12},
		{200, 201, 0, 0x0L, RTEXT, (void*)"start value", 10, 35, 38, 8},
		{201, 202, 0, 0x0L, EDVAL1, (void*)&start, 58, 35, 35, 10},
		{202, 203, 0, 0x0L, RTEXT, (void*)"group step", 10, 50, 38, 8},
		{203, 204, 0, 0x0L, EDVAL1, (void*)&step, 58, 50, 35, 10},
		{204, 205, 0, 0x0L, RTEXT, (void*)"bar width", 10, 65, 38, 8},
		{205, 206, 0, 0x0L, EDVAL1, (void*)&bw, 58, 65, 35, 10},
		{206, 207, 0, 0x0L, LTEXT, (void*)"%", 95, 65, 8, 8},
		{207, 208, 0, 0x0L, RTEXT, (void*)"group gap", 10, 80, 38, 8},
		{208, 209, 0, 0x0L, EDVAL1, (void*)&gg, 58, 80, 35, 10},
		{209, 0, 0, 0x0L, LTEXT, (void*)"%", 95, 80, 8, 8},
		{300, 0, 0, LASTOBJ | NOSELECT, ODBUTTON, (void*)(OD_scheme), 20, 30, 90, 60}};
	DlgRoot *Dlg;
	void *hDlg;
	bool bRet = false, updateYR = true, bContinue = false;
	char **rd;
	Bar **bars = 0L;
	AccRange *rY = 0L;
	int i, ic, res, ix, iy, ny, sc = 0, currYR = 0, maxYR = 0;
	double x, y, xinc;

	Id = GO_STACKBAR;
	if(!(rd = (char**)calloc(1, sizeof(char*))))return false;
	if(!(Dlg = new DlgRoot(GBDlg)))return false;
	hDlg = CreateDlgWnd("Grouped bar chart", 50, 50, 370, 240, Dlg, 0x0L);
	do {
		if(updateYR) {
			if(currYR >0) Dlg->ShowItem(156, true);
			else Dlg->ShowItem(156, false);
			sprintf(TmpTxt,"y-values # %d/%d", currYR+1, maxYR+1);
			//SetText will also cause a redraw of the whole dialog
			Dlg->SetText(153, TmpTxt);
			updateYR = false;
			}
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:
			if(bContinue || Dlg->GetCheck(10)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 1:		
			Dlg->GetValue(201, &start);			Dlg->GetValue(203, &step);
			Dlg->GetValue(205, &bw);			Dlg->GetValue(208, &gg);
		case 155:		case 156:
			res = com_StackDlg(res, Dlg, 0L, 0L, &rd, &currYR,
				&rY, &bContinue, &ny, &maxYR, &updateYR);
			break;
			}
		} while(res < 0);
	if(res == 1 && rd && rd[0] && rd[0][0]){	//accept settings and create plots
		if(rd[maxYR]) maxYR++;
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;		Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		if(!(xyPlots = (PlotScatt**)calloc(maxYR, sizeof(PlotScatt*)))){
			CloseDlgWnd(hDlg);
			delete Dlg;
			if(rd) {
				for (i = 0; i < maxYR; i++)	if(rd[i]) free(rd[i]);
				free(rd);
				}
			return false;
			}
		xinc = fabs(step / ((double)maxYR + gg/100.0));
		start -= (xinc * ((double)maxYR-1))/2.0;
		for(i = 0; i < maxYR; i++) {
			x = start + xinc * (double)i;
			if(rd[i] && (rY = new AccRange(rd[i]))) ny = rY->CountItems();
			else {
				rY = 0L;	ny = 0;
				}
			rY->GetFirst(&ix, &iy);				rY->GetNext(&ix, &iy);
			if(ny && rY && (bars = (Bar **)calloc(ny, sizeof(Bar*)))){
				for(ic = 0; ic < ny; ic++) {
					if(data->GetValue(iy, ix, &y)){
						bars[ic] = new Bar(0L, data, x, y, BAR_VERTB | BAR_RELWIDTH,
							-1, -1, ix, iy);
						CheckBounds(x, y);
						}
					x += step;
					if(!rY->GetNext(&ix, &iy))break;
					}
				xyPlots[numXY++] = new PlotScatt(this, data, ic+1, bars);
				if(xyPlots[i]) {
					xyPlots[i]->SetSize(SIZE_BARMINX, xinc);
					xyPlots[i]->SetSize(SIZE_BAR, bw);
					xyPlots[i]->Command(CMD_BAR_FILL, GetSchemeFill(&sc), 0L);
					}
				for(ic = 0; ic < ny; ic++) if(bars[ic]) delete(bars[ic]);
				free(bars);
				bRet = true;
				}
			if(rY) delete(rY);
			rY = 0L;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rd) {
		for (i = 0; i < maxYR; i++)	if(rd[i]) free(rd[i]);
		free(rd);
		}
	if(rY) delete rY;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// create a waterfall graph
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Waterfall::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Data"};
	TabSHEET tab2 = {25, 55, 10, "Details"};
	TabSHEET tab3 = {55, 90, 10, "Scheme"};
	static DWORD colarr[] = {0x00000000L, 0x00ff0000L, 0x0000ff00L, 0x000000ffL,
		0x00ff00ff, 0x00ffff00L, 0x0000ffff, 0x00c0c0c0};
	static DWORD defcol = 0x0L;
	char text1[100];
	DlgInfo StackBarDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 158, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 158, 25, 45, 12},
		{3, 0, 10, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{10, 11, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 140, 100},
		{11, 12, 200, ISPARENT, SHEET, &tab2, 5, 10, 140, 100},
		{12, 20, 300, ISPARENT, SHEET, &tab3, 5, 10, 140, 100},
		{20, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for common x values", 15, 30, 60, 8},
		{101, 152, 0, 0x0L, EDTEXT, text1, 25, 40, 100, 10},
		{152, 153, 0, ISPARENT | CHECKED, GROUPBOX, (void*)" ranges for y values ", 12, 60, 128, 45},
		{153, 154, 0, 0x0L, LTEXT, 0L, 25, 65, 60, 8},
		{154, 155, 0, 0x0L, EDTEXT, 0L, 25, 75, 100, 10},
		{155, 156, 0, 0x0L, PUSHBUTTON, (void*)"Next >>", 95, 87, 30, 12},
		{156, 0, 0, 0x0L, PUSHBUTTON, (void*)"<< Prev.", 60, 87, 35, 12},
		{200, 201, 0, 0x0L, LTEXT, (void*)"line to line displacement:", 20, 35, 80, 8},
		{201, 202, 0, 0x0L, RTEXT, (void*)"dx =", 28, 45, 13, 8},
		{202, 203, 0, 0x0L, EDVAL1, &dspm.fx, 43, 45, 25, 10},
		{203, 204, 0, 0x0L, RTEXT, (void*)"dy =", 73, 45, 13, 8},
		{204, 205, 0, 0x0L, EDVAL1, &dspm.fy, 88, 45, 25, 10},
		{205, 0, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 115, 45, 15, 8}, 
		{300, 301, 0, CHECKED, RADIO1, (void*)" common color for lines:", 20, 35, 80, 9},
		{301, 302, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)defcol, 105, 35, 20, 10},
		{302, 303, 0, 0x0L, RADIO1, (void*)" increment color scheme:", 20, 55, 80, 9},
		{303, 304, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[0], 25, 70, 10, 10},
		{304, 305, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[1], 37, 70, 10, 10},
		{305, 306, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[2], 49, 70, 10, 10},
		{306, 307, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[3], 61, 70, 10, 10},
		{307, 308, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[4], 73, 70, 10, 10},
		{308, 309, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[5], 85, 70, 10, 10},
		{309, 310, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[6], 97, 70, 10, 10},
		{310, 0, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[7], 109, 70, 10, 10},
		{500, 0, 0, LASTOBJ, NONE, 0L, 0, 0, 0, 0}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, res, width, height, currYR=0, maxYR=0, nx=0, ny;
	char **rd;
	bool updateYR = true, bContinue = false, bRet = false, bUseSch;
	AccRange *rX = 0L, *rY = 0L;

	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);
	if(!(rd = (char**)calloc(1, sizeof(char*))))return false;
	Dlg = new DlgRoot(StackBarDlg);
	hDlg = CreateDlgWnd("Create waterfall plot", 50, 50, 420, 260, Dlg, 0x0L);
	do {
		if(updateYR) {
			if(currYR >0) {
				Dlg->ShowItem(156, true);
				Dlg->Activate(101, false);
				}
			else {
				Dlg->ShowItem(156, false);
				Dlg->Activate(101, true);
				}
			sprintf(TmpTxt,"y-values # %d/%d", currYR+1, maxYR+1);
			//SetText will also cause a redraw of the whole dialog
			Dlg->SetText(153, TmpTxt);
			updateYR = false;
			}
		LoopDlgWnd();
		res = Dlg->GetResult();
		ny = 0;
		if(rX) delete rX;
		rX = 0L;
		switch(res) {
		case 0:
			if(bContinue || Dlg->GetCheck(20)) res = -1;
			break;
		case -1:
			bContinue = false;			break;
		case 1:
			for(i = 0; i < 8; i++) Dlg->GetColor(303+i, &colarr[i]);
			Dlg->GetColor(301, &defcol);
			bUseSch = Dlg->GetCheck(302);
			Dlg->GetValue(202, &dspm.fx);	Dlg->GetValue(204, &dspm.fy);
			//execute com_StackDlg for <OK>
		case 155:		case 156:
			res = com_StackDlg(res, Dlg, &rX, &nx, &rd, &currYR,
				&rY, &bContinue, &ny, &maxYR, &updateYR);
			break;
		case 301:
			Dlg->SetCheck(300, 0L, true);
			res = -1;	break;
		case 303:	case 304:	case 305:	case 306:
		case 307:	case 308:	case 309:	case 310:
			Dlg->SetCheck(302, 0L, true);
			res = -1;	break;
			}
		}while (res < 0);
	if(res == 1 && nx && rX && rd && rd[0] && rd[0][0]) {
		maxYR++;
		numPL = maxYR;
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;		Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		Dlg->GetText(101, text1);
		if(Lines=(DataLine**)calloc(numPL,sizeof(DataLine*)))for(i=0;i<maxYR;i++){
			if(rd[i] && rd[i][0]) Lines[i] = new DataLine(this, data, text1, rd[i]);
			if(Lines[i]) {
				if(bUseSch) Lines[i]->SetColor(COL_DATA_LINE, colarr[(i & 0x07)]);
				else Lines[i]->SetColor(COL_DATA_LINE, defcol);
				bRet = true;
				}
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rd) {
		for (i = 0; i < maxYR; i++)	if(rd[i]) free(rd[i]);
		free(rd);
		}
	if(rX) delete rX;		if(rY) delete rY;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Pie and ring chart properties
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
PieChart::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Data"};
	TabSHEET tab2 = {25, 55, 10, "Details"};
	TabSHEET tab3 = {55, 90, 10, "Scheme"};
	double fcx =10.0, fcy = 20.0, frad=40.0, firad = 30.0;
	char txt2[80];
	DlgInfo PieDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 130, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 130, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 103},
		{5, 6, 200, ISPARENT, SHEET, &tab2, 5, 10, 120, 103},
		{6, 10, 300, ISPARENT, SHEET, &tab3, 5, 10, 120, 103},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"spread sheet range for values", 10, 25, 60, 8},
		{101, 105, 0, 0x0L, EDTEXT, TmpTxt, 15, 35, 100, 10},
		{105, 106, 500, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{106, 107, 600, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{107, 108, 0, 0x0L, EDVAL1, &frad, 58, 59, 30, 10},
		{108, 0, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 89, 59, 15, 8}, 
		{200, 201, 0, 0x0L, LTEXT, (void*)"position of center:", 15, 30, 60, 8},
		{201, 202, 0, 0x0L, RTEXT, (void*)"x", 2, 42, 20, 8},
		{202, 204, 0, 0x0L, EDVAL1, &fcx, 23, 42, 30, 10},
		{204, 205, 0, 0x0L, RTEXT, (void*)"y", 47, 42, 20, 8},
		{205, 206, 0, 0x0L, EDVAL1, &fcy, 68, 42, 30, 10},
		{206, 207, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 99, 42, 15, 8}, 
		{207, 208, 0, 0x0L, RTEXT, (void*)"start angle", 27, 58, 20, 8},
		{208, 209, 0, 0x0L, EDVAL1, &CtDef.fx, 48, 58, 30, 10},
		{209, 210, 0, 0x0L, LTEXT, (void*)"degree", 79, 58, 15, 8}, 
		{210, 211, 400, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{211, 212, 410, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{212, 0, 0, 0x0L, LTEXT, (void*)"style:", 15, 80, 30, 8},
		{300, 0, 0, NOSELECT, ODBUTTON, (void*)(OD_scheme), 20, 35, 80, 60},
		{400, 401, 0, TOUCHEXIT | CHECKED | ISRADIO, ODBUTTON, (void*)OD_PieTempl, 40, 75, 30, 30},
		{401, 0, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PieTempl, 70, 75, 30, 30},
		{410, 411, 0, TOUCHEXIT | CHECKED | ISRADIO, ODBUTTON, (void*)OD_PieTempl, 40, 75, 30, 30},
		{411, 0, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PieTempl, 70, 75, 30, 30},
		{500, 501, 0, CHECKED, RADIO1, (void*)"fixed radius", 10, 59, 20, 8},
		{501, 502, 0, 0x0L, RADIO1, (void*)"pick radii from spreadsheet range", 10, 71, 40, 8},
		{502, 503, 0, 0x0L, EDTEXT, TmpTxt+100, 15, 82, 100, 10},
		{503, 504, 0, 0x0L, LTEXT, (void*)"x  factor", 15, 94, 10, 8},
		{504, 505, 0, 0x0L, EDVAL1, &FacRad, 42, 94, 25, 10},
		{505, 0, 0, 0x0L, LTEXT, &txt2, 70, 94, 15, 8},
		{600, 601, 0, 0x0L, RTEXT, (void*)"outer radius", 8, 59, 45, 8},
		{601, 602, 0, 0x0L, RTEXT, (void*)"inner radius", 8, 74, 45, 8},
		{602, 603, 0, 0x0L, EDVAL1, &firad, 58, 74, 30, 10},
		{603, 0, 0, LASTOBJ, LTEXT, (void *) Units[defs.cUnits].display, 89, 74, 15, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, ix, iy, rix, riy, ny, res, width, height, cf;
	bool bRet = false, bContinue = false;
	double sum = 0.0, dang1, dang2;
	double fv;
	lfPOINT fpCent;
	AccRange *rY = 0L, *rR = 0L;

	data->GetSize(&width, &height);
	sprintf(TmpTxt, "a1:a%d", height);
	sprintf(TmpTxt+100, "b1:b%d", height);
	sprintf(txt2, "= [%s]", Units[defs.cUnits].display);
	if(parent) {
		frad = (parent->GetSize(SIZE_DRECT_BOTTOM) - parent->GetSize(SIZE_DRECT_TOP))/2.0;
		fcx = parent->GetSize(SIZE_GRECT_LEFT) + (parent->GetSize(SIZE_DRECT_LEFT))/2.0 + frad;
		fcy = parent->GetSize(SIZE_GRECT_TOP) + parent->GetSize(SIZE_DRECT_TOP) + frad;
		}
	firad = frad-frad/10.0f;
	Dlg = new DlgRoot(PieDlg);
	if(Id == GO_PIECHART) {
		Dlg->ShowItem(105, true);		Dlg->ShowItem(106, false);
		Dlg->ShowItem(210, true);		Dlg->ShowItem(211, false);
		}
	else {
		Dlg->ShowItem(105, false);		Dlg->ShowItem(106, true);
		Dlg->ShowItem(210, false);		Dlg->ShowItem(211, true);
		}
	hDlg = CreateDlgWnd(Id == GO_PIECHART ? (char*)"Create pie chart" : 
		(char*)"Create ring chart",	50, 50, 370, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		//rY is defined by OK. If other buttons use rY reset to 0L!
		switch(res) {
		case 0:							//lost focus ?
			if(bContinue) res = -1;
			else if(Dlg->GetCheck(10)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 400:	case 410:
			Dlg->SetText(208, "90");		Dlg->DoPlot(0L);
			CtDef.fy = 360.0;					res = -1;
			break;
		case 401:	case 411:
			Dlg->SetText(208, "180");		Dlg->DoPlot(0L);
			CtDef.fy = 180.0;					res = -1;
			break;
		case 1:
			if(Dlg->GetText(101, TmpTxt) && TmpTxt[0] && (rY = new AccRange(TmpTxt))) 
				ny = rY->CountItems();
			else ny = 0;
			Dlg->GetValue(208, &CtDef.fx);		Dlg->GetValue(202, &fcx);
			Dlg->GetValue(205, &fcy);			Dlg->GetValue(107, &frad);
			Dlg->GetValue(602, &firad);			Dlg->GetValue(504, &FacRad);
			if(Dlg->GetCheck(501) && ny && Dlg->GetText(502, TmpTxt) && 
				(rR = new AccRange(TmpTxt))){
				if(rR->CountItems() != ny) {
					delete rR;
					delete rY;
					rR = rY = 0L;
					ErrorBox("Range for values and\nrange for radii must\nhave the same size!");
					bContinue = true;
					res = -1;
					}
				}
			break;
			}
		}while (res < 0);

	if(res == 1 && rY && ny >1 && (Segments = (segment **)calloc(ny, sizeof(segment*)))) {
		nPts = ny;
		if(Dlg->GetText(101, TmpTxt)) ssRefA = strdup(TmpTxt);
		if(rR && Dlg->GetText(502, TmpTxt)) ssRefR = strdup(TmpTxt);
		Bounds.Xmax = Bounds.Ymax = 100.0;		Bounds.Xmin = Bounds.Ymin = -100.0;
		fpCent.fx = fcx;					fpCent.fy = fcy;
		rY->GetFirst(&ix, &iy);				rY->GetNext(&ix, &iy);
		for(i = 0; i < ny; i++){
			if(data->GetValue(iy, ix, &fv)) sum += fv;
			rY->GetNext(&ix, &iy);
			}
		sum /= CtDef.fy;
		dang1 = dang2 = CtDef.fx;
		rY->GetFirst(&ix, &iy);				rY->GetNext(&ix, &iy);
		if(rR) {
			rR->GetFirst(&rix, &riy);		rR->GetNext(&rix, &riy);
			}
		for(i = cf = 0; i < ny; i++){
			if(data->GetValue(iy, ix, &fv)) {
				dang2 -= (double)fv / sum;
				if(dang2 < 0.0) dang2 += 360.0;
				if(rR && data->GetValue(riy, rix, &frad)) frad *= FacRad;
				Segments[i] = new segment(this, data, &fpCent, 
					Id == GO_PIECHART ? 0.0 : firad, frad,
					dang1, dang2);
				if(Segments[i])Segments[i]->Command(CMD_SEG_FILL, GetSchemeFill(&cf), 0L);
				dang1 = dang2;
				}
			rY->GetNext(&ix, &iy);
			if(rR) rR->GetNext(&rix, &riy);
			}
		bRet = true;
		}
	if(rY) delete rY;		if(rR) delete rR;
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Create a star chart
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
StarChart::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Data"};
	TabSHEET tab2 = {25, 55, 10, "Labels"};
	double sa = 90.0, factor = 1.0, lbdist = NiceValue(defs.GetSize(SIZE_TEXT)*1.2);
	char txt1[80], txt2[80];
	DlgInfo StarDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 130, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 130, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 103},
		{5, 10, 200, ISPARENT, SHEET, &tab2, 5, 10, 120, 103},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"spread sheet range for values", 10, 30, 60, 8},
		{101, 102, 0, 0x0L, EDTEXT, txt1, 15, 45, 100, 10},
		{102, 103, 0, 0x0L, RTEXT, (void*)"x  factor", 17, 57, 30, 8},
		{103, 104, 0, 0x0L, EDVAL1, &factor, 48, 57, 30, 10},
		{104, 105, 0, 0x0L, LTEXT, &txt2, 79, 57, 15, 8},
		{105, 106, 0, 0x0L, RTEXT, (void*)"start angle", 17, 72, 30, 8},
		{106, 107, 0, 0x0L, EDVAL1, &sa, 48, 72, 30, 10},
		{107, 108, 0, 0x0L, LTEXT, (void*)"degree", 79, 72, 15, 8}, 
		{108, 109, 0, CHECKED, CHECKBOX, (void*)"draw polygon", 25, 87, 20, 8},
		{109, 0, 0, CHECKED, CHECKBOX, (void*)"draw rays", 25, 97, 20, 8},
		{200, 201, 0, 0x0L, CHECKBOX, (void*)"add labels to data points", 15, 28, 50, 8},
		{201, 202, 0, 0x0L, EDTEXT, (void*)txt1, 15, 51, 100, 10},
		{202, 203, 0, 0x0L, LTEXT, (void*)"spread sheet range for labels:", 15, 40, 60, 8},
		{203, 204, 0, 0x0L, RTEXT, (void*)"distance:", 10, 70, 40, 8},
		{204, 205, 0, 0x0L, EDVAL1, &lbdist, 52, 70, 30, 10},
		{205, 0, 0, LASTOBJ, LTEXT, (void*)Units[defs.cUnits].display, 85, 70, 10, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, ix, iy, res, width, height, ny;
	bool bRet = false, bContinue = false;
	AccRange *rY = 0L, *rL = 0L;
	Label *lb;
	lfPOINT *fp = 0L, *fpt = 0L, fl[2];
	double fx, fy, tmpval, frad;
	double sia, csia;
	polyline *plo;
	TextDEF td = {0x00000000L, 0x00ffffffL, defs.GetSize(SIZE_TEXT), 0.0, 0.0, 0,
		TXA_HCENTER | TXA_VCENTER, TXM_TRANSPARENT, TXS_NORMAL, FONT_HELVETICA, 0L}; 


	data->GetSize(&width, &height);
	sprintf(txt1, "a1:a%d", height);
	sprintf(txt2, "= [%s]", Units[defs.cUnits].display);
	if(parent) {
		frad = (parent->GetSize(SIZE_DRECT_BOTTOM) - parent->GetSize(SIZE_DRECT_TOP))/2.0f;
		fPos.fx = parent->GetSize(SIZE_GRECT_LEFT) + parent->GetSize(SIZE_DRECT_LEFT) + frad;
		fPos.fy = parent->GetSize(SIZE_GRECT_TOP) + parent->GetSize(SIZE_DRECT_TOP) + frad;
		}
	if(!(Dlg = new DlgRoot(StarDlg)))return false;
	hDlg = CreateDlgWnd("Create star chart", 50, 50, 370, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 0:							//lost focus ?
			if(bContinue) res = -1;
			else if(Dlg->GetCheck(10)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 1:
			if(Dlg->GetText(101, TmpTxt) && TmpTxt[0] && (rY = new AccRange(TmpTxt))) 
				ny = rY->CountItems();
			else ny = 0;
			Dlg->GetValue(106, &sa);			Dlg->GetValue(103, &factor);
			Dlg->GetValue(204, &lbdist);
			break;
			}
		}while (res < 0);
	if(res == 1 && rY && ny >1 && (fp = (lfPOINT*)calloc(ny+1, sizeof(lfPOINT))) &&
		(fpt = (lfPOINT*)calloc(ny+1, sizeof(lfPOINT)))){
		Bounds.Xmax = Bounds.Ymax = 100.0;		Bounds.Xmin = Bounds.Ymin = -100.0;
		rY->GetFirst(&ix, &iy);
		for(i = 0; i < ny; i++){
			rY->GetNext(&ix, &iy);
			if(data->GetValue(iy, ix, &tmpval)){
				tmpval *= factor;
				sia = sin(sa * 0.01745329252);			csia = cos(sa * 0.01745329252);
				fx = (tmpval * csia);					fy = (-tmpval * sia);
				}
			else fx = fy = 0.0f;
			fp[i].fx = fpt[i].fx = fx;			fp[i].fy = fpt[i].fy = fy;
			fpt[i].fx += lbdist *csia;			fpt[i].fy += (-lbdist * sia);
			sa -= 360.0/ny;
			}
		fp[i].fx = fp[0].fx;		fp[i].fy = fp[0].fy;
		if(Dlg->GetCheck(108)){
			if((plo = new polygon(this, data, fp, ny+1))) {		//ny+1 to close the shape!
				if(!(bRet = Command(CMD_DROP_OBJECT, (void*)plo, 0L))) delete plo;
				}
			}
		if(Dlg->GetCheck(109)){
			fl[0].fx = fl[0].fy = 0.0f;
			for(i = 0; i < ny; i++) {
				fl[1].fx = fp[i].fx;		fl[1].fy = fp[i].fy;
				if((plo = new polyline(this, data, fl, 2))) {
					if(Command(CMD_DROP_OBJECT, (void*)plo, 0L)) bRet = true;
					else delete plo;
					}
				}
			}
		if(Dlg->GetCheck(200) && Dlg->GetText(201, TmpTxt) && TmpTxt[0] && (rL = new AccRange(TmpTxt))){
			rL->GetFirst(&ix, &iy);
			td.text = TmpTxt;
			for(i = 0; i < ny; i++) {
				rL->GetNext(&ix, &iy);
				if(data->GetText(iy, ix, TmpTxt, TMP_TXT_SIZE)){
					if((lb = new Label(this, data, fpt[i].fx, fpt[i].fy, &td, 0L))) {
						if(Command(CMD_DROP_OBJECT, (void*)lb, 0L)) bRet = true;
						else delete lb;
						}
					}
				}
			}
		}
	if(rY) delete rY;			if(rL) delete rL;
	if(fp) free(fp);			if(fpt) free(fpt);
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Scatt3D is a layer representing most simple 3D plots
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Scatt3D::PropertyDlg()
{
	TabSHEET tab1 = {0, 22, 10, "Data"};
	TabSHEET tab2 = {22, 50, 10, "Layout"};
	TabSHEET tab3 = {50, 75, 10, "Axes"};
	char text1[100], text2[100], text3[100];
	DlgInfo Dlg3D[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 142, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 142, 25, 45, 12},
		{3, 50, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 5, 100, TOUCHEXIT | ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 131, 100},
		{5, 6, 200, TOUCHEXIT | ISPARENT, SHEET, &tab2, 5, 10, 131, 100},
		{6, 10, 400, TOUCHEXIT | ISPARENT, SHEET, &tab3, 5, 10, 131, 100},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{50, 60, 0, NOSELECT, ODBUTTON, (void*)(OD_AxisDesc3D), 142, 65, 45, 45},
		{60, 61, 0, 0x0L, ICON, (void*)ICO_INFO, 10, 114, 20, 20},
		{61, 62, 0, 0x0L, LTEXT, (void*)"Use [arrow keys], [shift]+[arrow key],", 30, 116, 100, 6},
		{62, 0, 0, 0x0L, LTEXT, (void*)"and [r], [R], [l] or [L] to rotate graph.", 30, 122, 100, 6},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for X Data", 10, 30, 60, 8},
		{101, 102, 0, 0x0L, EDTEXT, text1, 20, 40, 100, 10},
		{102, 103, 0, 0x0L, LTEXT, (void*)"range for Y Data", 10, 55, 60, 8},
		{103, 104, 0, 0x0L, EDTEXT, text2, 20, 65, 100, 10},
		{104, 105, 0, 0x0L, LTEXT, (void*)"range for Z Data", 10, 80, 60, 8},
		{105, 0, 0, 0x0L, EDTEXT, text3, 20, 90, 100, 10},
		{200, 201, 0, 0x0L, LTEXT, (void*)"select style:", 25, 30, 60, 8},
		{201, 202, 0, 0x0L, CHECKBOX, (void*)" balls", 30, 55, 60, 8},
		{202, 203, 0, TOUCHEXIT, CHECKBOX, (void*)" columns", 30, 65, 60, 8},
		{203, 204, 0, TOUCHEXIT, CHECKBOX, (void*)" line", 30, 45, 60, 8},
		{204, 205, 0, TOUCHEXIT, CHECKBOX, (void*)" drop lines", 30, 75, 60, 8},
		{205, 0, 0, TOUCHEXIT, CHECKBOX, (void*)" arrows", 30, 85, 60, 8},
		{400, 410, 0, 0x0L, LTEXT, (void*)"select template:", 20, 30, 60, 8},
		{410, 411, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl3D), 20, 42, 25, 25},
		{411, 412, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl3D), 45, 42, 25, 25},
		{412, 0, 0, LASTOBJ | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl3D), 70, 42, 25, 25}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, width, height, n1, n2, n3, ic = 0;
	int i, j, k, l, m, n, i2, j2, k2, l2, m2;
	double x, y, z, bar_w, bar_d, rad;
	bool bRet = false, bContinue = false;
	AccRange *rX, *rY, *rZ;
	fPOINT3D pos1, pos2;

	if(!data || !parent || parent->Id != GO_PLOT3D)return false;
	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);		sprintf(text2, "b1:b%d", height);
	sprintf(text3, "c1:c%d", height);
	if(!(Dlg = new DlgRoot(Dlg3D)))return false;
	Dlg->SetCheck(410 + AxisTempl3D, 0L, true);
	for(i = 0; i < 5; i++) Dlg->SetCheck(201+i, 0L, (c_flags & (1<<i))!=0);
	Dlg->ShowItem(6, (c_flags & 0x1000) == 0x1000); 
	rX = rY = rZ = 0L;
	rad = defs.GetSize(SIZE_SYMBOL);
#ifdef _WINDOWS
	for(i = 61; i <= 62; i++) Dlg->TextSize(i, 12);
#else
	for(i = 61; i <= 62; i++) Dlg->TextSize(i, 10);
#endif
	hDlg = CreateDlgWnd("Create 3D Plot", 50, 50, 388, 300, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:								// focus lost
			if(bContinue) res = -1;
			else if(Dlg->GetCheck(10)) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 4:		case 5:		case 6:		//the tab sheets
			res = -1;
			break;
		case 202:
			Dlg->SetCheck(204, 0L, false);
			res = -1;
			break;
		case 204:
			Dlg->SetCheck(202, 0L, false);
			res = -1;
			break;
		case 203:
			Dlg->SetCheck(205, 0L, false);
			res = -1;
			break;
		case 205:
			Dlg->SetCheck(203, 0L, false);
			res = -1;
			break;
		case 410:	case 411:	case 412:	//axis templates
			AxisTempl3D = res-410;
			res = -1;
			break;
		case 1:
			if(rX) delete rX;	if(rY) delete rY;	if(rZ) delete rZ;
			rX = rY = rZ = 0L;	n1 = n2 = n3 = 0;
			if(Dlg->GetText(101, text1) && (rX = new AccRange(text1))) n1 = rX->CountItems();
			if(Dlg->GetText(103, text2) && (rY = new AccRange(text2))) n2 = rY->CountItems();
			if(Dlg->GetText(105, text3) && (rZ = new AccRange(text3))) n3 = rZ->CountItems();
			if(n1 && n2 && n3){
				if(n1 == n2 && n2 == n3) {
					//o.k., three ranges of equal size have been defined
					c_flags = 0;
					for(i = 0; i < 5; i++) if(Dlg->GetCheck(201+i)) c_flags |= (1<<i);
					}
				else {
					InfoBox("All ranges must have\nthe same size."); 
					res = -1;	bContinue = true;
					}
				}
			else {
				sprintf(TmpTxt, "Ranges for\n%s%s%s\n\nnot given or not valid.",
					n1 == 0 ? "\n  X Data" : "", n2 == 0 ? "\n  Y Data" : "",
					n3 == 0 ? "\n  Z Data" : "");
				InfoBox(TmpTxt);
				res = -1;	bContinue = true;
				}
			break;
			}
		}while (res <0);
	if(res == 1 && rX && rY && rZ) {
		Bounds.Xmin = Bounds.Ymin = HUGE_VAL;	Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
		xBounds.fx = yBounds.fx = zBounds.fx = HUGE_VAL;
		xBounds.fy = yBounds.fy = zBounds.fy = -HUGE_VAL;
		bar_w = bar_d = (defs.GetSize(SIZE_BAR)/2.0);
		if(c_flags & 0x01) (Balls = (Sphere**)calloc((nBalls = n1)+1, sizeof(Sphere*)));
		if(c_flags & 0x02) (Columns = (Brick**)calloc((nColumns = n1)+1, sizeof(Brick*)));
		if(c_flags & 0x04) Line = new Line3D(this, data, text1, text2, text3);
		if(c_flags & 0x08) (DropLines = (DropLine3D**)calloc((nDropLines = n1)+1, sizeof(DropLine3D*)));
		if(c_flags & 0x010) (Arrows = (Arrow3D**)calloc((nArrows = n1)+1, sizeof(Arrow3D*)));
		rX->GetFirst(&i, &j);		rX->GetNext(&i, &j);
		rY->GetFirst(&k, &l);		rY->GetNext(&k, &l);
		rZ->GetFirst(&m, &n);		rZ->GetNext(&m, &n);
		i2 = i;	j2 = j;	k2 = k;	l2 = l;	m2 = m;	n2 = n;
		do {
			if(data->GetValue(j, i, &x) && data->GetValue(l, k, &y) && 
				data->GetValue(n, m, &z)){
				if(ic) {
					pos1.fx = pos2.fx;		pos1.fy = pos2.fy;	pos1.fz = pos2.fz;
					}
				else {
					pos1.fx = x;			pos1.fy = y;		pos1.fz = z;
					}
				pos2.fx = x;	pos2.fy = y;	pos2.fz = z;
				if(!bRet) memcpy(&pos1, &pos2, sizeof(fPOINT3D));
				if(Balls) Balls[ic] = new Sphere(this, data, 0, x, y, z, rad, i, j, k, l, m, n);
				if(Columns)Columns[ic] = new Brick(this, data, x, 0.0, z, 
					bar_d, bar_w, y, 0x800L, i, j, -1, -1, m, n, -1, -1, -1, -1, k, l);
				if(DropLines) DropLines[ic] = new DropLine3D(this, data, &pos2, i, j, k, l, m, n);
				if(Arrows) Arrows[ic] = new Arrow3D(this, data, &pos1, &pos2, 
					i, j, k, l, m, n, i2, j2, k2, l2, m2, n2);
				((Plot3D *)parent)->CheckBounds3D(x, y, z);		CheckBounds3D(x, y, z);
				bRet = true;
				}
			i2 = i;	j2 = j;	k2 = k;	l2 = l;	m2 = m;	n2 = n;
			ic++;
			}while(rX->GetNext(&i, &j) && rY->GetNext(&k, &l) && rZ->GetNext(&m, &n));
		if(!bRet) InfoBox("The selected data range\nis empty or does not contain\nvalid"
			" data triplets!");
		bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rX) delete rX;	if(rY) delete rY;	if(rZ) delete rZ;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// user defined function properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Function::PropertyDlg()
{
	TabSHEET tab1 = {0, 37, 10, "Function"};
	TabSHEET tab2 = {37, 60, 10, "Line"};
	DlgInfo FuncDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 160, 10, 32, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 160, 25, 32, 12},
		{3, 10, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT, SHEET, &tab1, 5, 10, 149, 110},
		{5, 0, 500, ISPARENT | CHECKED, SHEET, &tab2, 5, 10, 149, 110},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"plot user defined function", 10, 24, 100, 8},
		{101, 102, 0, 0x0L, RTEXT, (void*)"where x=", 10, 40, 28, 8}, 
		{102, 103, 0, 0x0L, EDVAL1, &x1, 38, 40, 25, 10},
		{103, 104, 0, 0x0L, RTEXT, (void*)"until", 61, 40, 17, 8}, 
		{104, 105, 0, 0x0L, EDVAL1, &x2, 78, 40, 25, 10},
		{105, 106, 0, 0x0L, RTEXT, (void*)"step", 102, 40, 17, 8}, 
		{106, 107, 0, 0x0L, EDVAL1, &xstep, 119, 40, 25, 10},
		{107, 200, 0, 0x0L, RTEXT, (void*)"y=", 10, 56, 10, 8}, 
		{200, 0, 0, 0x0L, TEXTBOX, (void*)cmdxy, 22, 54, 122, 40},
		{500, 0, 0, LASTOBJ | NOSELECT, ODBUTTON, (void*)OD_linedef, 15, 25, 130, 100}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, undo_level = *Undo.pcb;
	bool bRet = false, bNew = (dl == 0L);
	DWORD undo_flags = 0L;
	LineDEF newLine;
	double o_x1, n_x1, o_x2, n_x2, o_xstep, n_xstep;

	if(!parent) return false;
	if(parent->Id == GO_FITFUNC) return parent->PropertyDlg();
	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&Line, 0);
	if(!(Dlg = new DlgRoot(FuncDlg))) return false;
	if(!bNew) Dlg->ShowItem(10, false);
	Dlg->GetValue(102, &o_x1);		n_x1 = o_x1;
	Dlg->GetValue(104, &o_x2);		n_x2 = o_x2;
	Dlg->GetValue(106, &o_xstep);	n_xstep = o_xstep;
	hDlg = CreateDlgWnd("Function Plot", 50, 50, 400, 276, Dlg, 0x0L);
	if(bNew) Dlg->SetCheck(4, 0L, true);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:
			if(Dlg->GetCheck(10)) res = -1;
			break;
			}
		}while (res < 0);
	while(*Undo.pcb > undo_level)	Undo.Pop();
	if(res == 1){						//OK pressed
		if(bNew) {						//create function
			OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&Line, 0);
			Dlg->GetValue(102, &x1);		Dlg->GetValue(104, &x2);
			Dlg->GetValue(106, &xstep);		Dlg->GetText(200, TmpTxt);
			cmdxy = strdup(TmpTxt);
			bRet = Update(0L, 0L);
			}
		else {							//edit existing function
			Dlg->GetValue(102, &n_x1);		Dlg->GetValue(104, &n_x2);
			Dlg->GetValue(106, &n_xstep);
			undo_flags = CheckNewFloat(&x1, o_x1, n_x1, this, undo_flags);
			undo_flags = CheckNewFloat(&x2, o_x2, n_x2, this, undo_flags);
			undo_flags = CheckNewFloat(&xstep, o_xstep, n_xstep, this, undo_flags);
			Dlg->GetText(200, TmpTxt);
			if(cmdxy && strcmp(cmdxy, TmpTxt)) {
				Undo.String(this, &cmdxy, undo_flags);
				free(cmdxy);	cmdxy = strdup(TmpTxt); undo_flags |= UNDO_CONTINUE;
				}
			if(undo_flags & UNDO_CONTINUE) Update(0L, UNDO_CONTINUE);
			OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
			if(cmpLineDEF(&Line, &newLine)) {
				Undo.Line(parent, &Line, undo_flags);	undo_flags |= UNDO_CONTINUE;
				memcpy(&Line, &newLine, sizeof(LineDEF));
				}
			bRet = (undo_flags & UNDO_CONTINUE) != 0;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// fit function by nonlinear regression
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
FitFunc::PropertyDlg()
{
	TabSHEET tab1 = {0, 22, 10, "Data"};
	TabSHEET tab2 = {22, 59, 10, "Function"};
	TabSHEET tab3 = {59, 82, 10, "Line"};
	char text1[100], text2[100];
	double iter;
	bool bNew = (dl == 0L);
	DlgInfo FuncDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 160, 10, 32, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 160, 25, 32, 12},
		{3, 10, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 5, 400, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 149, 125},
		{5, 6, 100, ISPARENT, SHEET, &tab2, 5, 10, 149, 125},
		{6, 7, 500, ISPARENT, SHEET, &tab3, 5, 10, 149, 125},
		{7, 0, 0, 0x0L, PUSHBUTTON, (void*)"Fit", 160, 123, 32, 12},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"fit function by nonlinear regression", 10, 24, 100, 8},
		{101, 102, 0, 0x0L, LTEXT, (void*)"parameters and initial values:", 10, 34, 100, 8},
		{102, 150, 0, 0x0L, TEXTBOX, (void*)parxy, 22, 44, 122, 25},
		{150, 151, 0, 0x0L, LTEXT, (void*)"function, y=f(x):", 10, 72, 10, 8}, 
		{151, 152, 0, 0x0L, RTEXT, (void*)"y=", 10, 86, 10, 8}, 
		{152, 153, 0, 0x0L, RTEXT, (void*)"converg.:", 20, 118, 26, 8}, 
		{153, 154, 0, 0x0L, EDVAL1, &conv, 46, 118, 25, 10},
		{154, 155, 0, 0x0L, RTEXT, (void*)"iterations:", 72, 118, 47, 8}, 
		{155, 200, 0, 0x0L, EDVAL1, &iter, 119, 118, 25, 10},
		{200, 0, 0, 0x0L, TEXTBOX, (void*)cmdxy, 22, 84, 122, 30},
		{400, 401, 0, 0x0L, LTEXT, (void*)"range for X Data", 10, 30, 60, 8},
		{401, 402, 0, 0x0L, EDTEXT, (void*)ssXref, 20, 40, 100, 10},
		{402, 403, 0, 0x0L, LTEXT, (void*)"range for Y Data", 10, 55, 60, 8},
		{403, 404, 0, 0x0L, EDTEXT, (void*)ssYref, 20, 65, 100, 10},
		{404, 0, 0, CHECKED, CHECKBOX, (void*)"draw symbols", 20, 95, 60, 8},
		{500, 550, 501, CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{501, 502, 0, 0x0L, RTEXT, (void*)"plot x=", 10, 30, 28, 8}, 
		{502, 503, 0, 0x0L, EDVAL1, &x1, 38, 30, 25, 10},
		{503, 504, 0, 0x0L, RTEXT, (void*)"until", 61, 30, 17, 8}, 
		{504, 505, 0, 0x0L, EDVAL1, &x2, 78, 30, 25, 10},
		{505, 506, 0, 0x0L, RTEXT, (void*)"step", 102, 30, 17, 8}, 
		{506, 0, 0, 0x0L, EDVAL1, &xstep, 119, 30, 25, 10},
		{550, 0, 0, LASTOBJ | NOSELECT, ODBUTTON, (void*)OD_linedef, 15, bNew ? 35:45, 130, 100}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, undo_level = *Undo.pcb, i, j, k, l, cs;
	bool bRet = false, bContinue = false;
	DWORD undo_flags = 0L;
	LineDEF newLine;
	double tmp, tmpy, o_x1, n_x1, o_x2, n_x2, o_xstep, n_xstep;
	AccRange *rX, *rY;
	char *o_cmdxy, *o_parxy, *tmp_char;

	if(!parent || !data) return false;
	if(!(o_cmdxy = strdup(cmdxy))) return false;
	if(!(o_parxy = strdup(parxy))) return false;
	iter = (double)maxiter;
	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&Line, 0);
	if(!(Dlg = new DlgRoot(FuncDlg))) return false;
	if(!bNew){
		Dlg->ShowItem(10, false);		Dlg->Activate(401, false);
		Dlg->Activate(403, false);		Dlg->SetCheck(6, 0L, true);
		Dlg->SetCheck(4, 0L, false);	Dlg->ShowItem(404, false);
		}
	else {
		Dlg->ShowItem(500, false);
		}
	Dlg->GetValue(502, &o_x1);		n_x1 = o_x1;
	Dlg->GetValue(504, &o_x2);		n_x2 = o_x2;
	Dlg->GetValue(506, &o_xstep);	n_xstep = o_xstep;
	hDlg = CreateDlgWnd("Fit Function to Data", 50, 50, 400, 306, Dlg, 0x0L);
	if(bNew) Dlg->SetCheck(4, 0L, true);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:
			if(Dlg->GetCheck(10)) res = -1;
			if(bContinue) res = -1;
			bContinue = false;
			break;
		case 1:
			if(!bNew) break;
		case 7:								//Start: do nonlinear regression
			if(Dlg->GetCheck(5)) {			//  the function tab must be shown
				if(Dlg->CurrDisp) Dlg->CurrDisp->MouseCursor(MC_WAIT, true);
				Dlg->GetText(401, text1);		Dlg->GetText(403, text2);
				if(Dlg->GetText(102, TmpTxt) && parxy) {
					free(parxy);	parxy = strdup(TmpTxt);
					}
				if(Dlg->GetText(200, TmpTxt) && cmdxy) {
					free(cmdxy);	cmdxy = strdup(TmpTxt);
					}
				Dlg->GetValue(153, &conv);	Dlg->GetValue(155, &iter);
				ReshapeFormula(&parxy);		ReshapeFormula(&cmdxy);
				i = do_fitfunc(data, text1, text2, 0L, &parxy, cmdxy, conv, (int)iter);
				Dlg->SetText(102, parxy);
				if(i >1 || res == 7) {
					sprintf(TmpTxt, "The Levenberg-Marquart algorithm\nexited after %d iterations.", i);
					InfoBox(TmpTxt);
					}
				bContinue = true;
				if(res == 7) res = -1;
				if(Dlg->CurrDisp) Dlg->CurrDisp->MouseCursor(MC_ARROW, true);
				}
			else {							//diplay function tab first
				Dlg->SetCheck(5, 0L, true);
				res = -1;
				}
			break;
			}
		}while (res < 0);
	while(*Undo.pcb > undo_level)	Undo.Pop();
	if(res == 1){						//OK pressed
		//get ranges for x- and y data (again).
		Dlg->GetText(401, text1);		Dlg->GetText(403, text2);
		if(ssXref) free(ssXref);		if(ssYref) free(ssYref);
		ssXref = strdup(text1);			ssYref = strdup(text2);
		if(bNew) {						//create function
			if(!(rX = new AccRange(text1)) || ! (rY = new AccRange(text2))) return false;
			i = rX->CountItems();	maxiter = int(iter);
			if(Dlg->GetCheck(404)) Symbols = (Symbol**)calloc(i, sizeof(Symbol*));
			x1 = HUGE_VAL;	x2 = -HUGE_VAL;	cs = 0;
			Bounds.Xmin = Bounds.Ymin = HUGE_VAL;
			Bounds.Xmax = Bounds.Ymax = -HUGE_VAL;
			rX->GetFirst(&i, &j);	rY->GetFirst(&k, &l);
			rX->GetNext(&i, &j);	rY->GetNext(&k, &l);
			do {
				if(data->GetValue(j, i, &tmp) && data->GetValue(l, k, &tmpy)){
					if(tmp < x1) x1 = tmp;			if(tmp > x2) x2 = tmp;
					if(Symbols) Symbols[cs++] = new Symbol(this, data, tmp, tmpy, SYM_CIRCLE, i, j, k, l);
					nPoints = cs;					CheckBounds(tmp, tmpy);
					}
				}while(rX->GetNext(&i, &j) && rY->GetNext(&k, &l));
			delete rX;	delete rY;
			if(x1 >= x2 || !(dl = new Function(this, data))){
				CloseDlgWnd(hDlg);
				delete Dlg;
				return false;
				}
			xstep = (x2 - x1)/100.0;
			OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&Line, 0);
			dl->SetSize(SIZE_MIN_X, x1);		dl->SetSize(SIZE_MAX_X, x2);
			dl->SetSize(SIZE_XSTEP, xstep);		dl->Command(CMD_SETFUNC, cmdxy, 0L);
			dl->Command(CMD_SETPARAM, parxy, 0L);
			dl->Command(CMD_SET_LINE, &Line, 0L);
			dl->Command(CMD_AUTOSCALE, 0L, 0L);
			CheckBounds(dl->Bounds.Xmin, dl->Bounds.Ymin);
			CheckBounds(dl->Bounds.Xmax, dl->Bounds.Ymax);
			bRet = true;
			}
		else {							//edit existing function
			Dlg->GetValue(502, &n_x1);		Dlg->GetValue(504, &n_x2);
			Dlg->GetValue(506, &n_xstep);
			undo_flags = CheckNewFloat(&x1, o_x1, n_x1, this, undo_flags);
			undo_flags = CheckNewFloat(&x2, o_x2, n_x2, this, undo_flags);
			if(o_parxy && parxy && strcmp(o_parxy, parxy)) {
				tmp_char = parxy;	parxy = o_parxy;
				Undo.String(this, &parxy, undo_flags);
				free(parxy);	parxy = tmp_char;	undo_flags |= UNDO_CONTINUE;
				o_parxy = 0L;
				}
			if(o_cmdxy && cmdxy && strcmp(o_cmdxy, cmdxy)) {
				tmp_char = cmdxy;	cmdxy = o_cmdxy;
				Undo.String(this, &cmdxy, undo_flags);
				free(cmdxy);	cmdxy = tmp_char;	undo_flags |= UNDO_CONTINUE;
				o_cmdxy = 0L;
				}
			if(undo_flags & UNDO_CONTINUE) {
				Undo.ValInt(parent, (int*)&dirty, undo_flags);
				Command(CMD_MRK_DIRTY, 0L, 0L);
				}
			undo_flags = CheckNewFloat(&xstep, o_xstep, n_xstep, this, undo_flags);
//			Dlg->GetText(200, TmpTxt);
//			if(cmdxy && strcmp(cmdxy, TmpTxt)) {
//				Undo.String(this, &cmdxy, undo_flags);
//				free(cmdxy);	cmdxy = strdup(TmpTxt); undo_flags |= UNDO_CONTINUE;
//				}
//			if(undo_flags & UNDO_CONTINUE) Update(0L, UNDO_CONTINUE);
//			cmdxy = strdup(TmpTxt);
//			bRet = Update(0L, 0L);
			OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
			if(cmpLineDEF(&Line, &newLine)) {
				Undo.Line(parent, &Line, undo_flags);	undo_flags |= UNDO_CONTINUE;
				memcpy(&Line, &newLine, sizeof(LineDEF));
				}
			bRet = (undo_flags & UNDO_CONTINUE) != 0;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(o_parxy) free(o_parxy);		if(o_cmdxy) free(o_cmdxy);
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Create a three dimensional graph
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Plot3D::AddPlot(int family)
{
	DlgInfo PlotsDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 150, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 25, 45, 12},
		{3, 0, 560, ISPARENT | CHECKED, GROUPBOX, (void *)"  select template  ", 5, 10, 140, 70},
		{560, 561, 0, TOUCHEXIT | CHECKED | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 25, 20, 25, 25},
		{561, 562, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 50, 20, 25, 25},
		{562, 563, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 75, 20, 25, 25},
		{563, 0, 0, LASTOBJ | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 100, 20, 25, 25}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, cSel = 560;
	bool bRet = false;
	Plot *p;

	if(!(Dlg = new DlgRoot(PlotsDlg)))return false;
	hDlg = CreateDlgWnd("Add Plot", 50, 50, 410, 190, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 560:	case 561:	case 562:	case 563:
			if(res == cSel) res = 1;
			else {
				cSel = res;
				res = -1;
				}
			break;
			}
		}while (res < 0);
	if(res == 1){						//OK pressed
		if(Dlg->GetCheck(560)) p = new Scatt3D(this, data, 0x01);
		else if(Dlg->GetCheck(561)) p = new Scatt3D(this, data, 0x02);
		else if(Dlg->GetCheck(562)) p = new Scatt3D(this, data, 0x04);
		else if(Dlg->GetCheck(563)) p = new BubblePlot3D(this, data);
		if(p && p->PropertyDlg()) {
			if(p->Id == GO_PLOT3D) delete p;
			else if(!(bRet = Command(CMD_DROP_PLOT, p, (anyOutput *)NULL))) delete p;
			}
		else if(p) delete p;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

bool
Plot3D::PropertyDlg()
{
	Plot *p;
	bool bRet = false;

	if(plots) {
		//plots already created - jump to configuration dialog
		return false;
		}
	if((p = new Scatt3D(this, data, crea_flags)) && p->PropertyDlg()) {
		if(!(bRet = Command(CMD_DROP_PLOT, p, (anyOutput *)NULL))) DeleteGO(p);
		}
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Create a 2.5 dimensional chart
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Chart25D::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Data"};
	TabSHEET tab2 = {25, 55, 10, "Details"};
	TabSHEET tab3 = {55, 90, 10, "Scheme"};
	static DWORD colarr[] = {0x000080ffL, 0x00ff8000L, 0x0000ff00L, 0x000000ffL,
		0x00ff00ff, 0x00ffff00L, 0x0000ffff, 0x00c0c0c0};
	static DWORD defcol = 0x00ffffffL;
	char text1[100];
	double start_z = 1.0;
	DlgInfo Bar3D_Dlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 158, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 158, 25, 45, 12},
		{3, 0, 10, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{10, 11, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 140, 100},
		{11, 12, 200, ISPARENT, SHEET, &tab2, 5, 10, 140, 100},
		{12, 20, 300, ISPARENT, SHEET, &tab3, 5, 10, 140, 100},
		{20, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for common x values", 15, 30, 60, 8},
		{101, 152, 0, 0x0L, EDTEXT, text1, 25, 40, 100, 10},
		{152, 153, 0, ISPARENT | CHECKED, GROUPBOX, (void*)" ranges for y values ", 12, 60, 128, 45},
		{153, 154, 0, 0x0L, LTEXT, 0L, 25, 65, 60, 8},
		{154, 155, 0, 0x0L, EDTEXT, 0L, 25, 75, 100, 10},
		{155, 156, 0, 0x0L, PUSHBUTTON, (void*)"Next >>", 95, 87, 30, 12},
		{156, 0, 0, 0x0L, PUSHBUTTON, (void*)"<< Prev.", 60, 87, 35, 12},
		{200, 201, 0, 0x0L, LTEXT, (void*)"distances:", 20, 35, 80, 8},
		{201, 202, 0, 0x0L, RTEXT, (void*)"start z =", 48, 45, 13, 8},
		{202, 203, 0, 0x0L, EDVAL1, &start_z, 65, 45, 25, 10},
		{203, 204, 0, 0x0L, RTEXT, (void*)"step =", 48, 57, 13, 8},
		{204, 0, 0, 0x0L, EDVAL1, &dspm.fz, 65, 57, 25, 10},
		{300, 301, 0, CHECKED, RADIO1, (void*)" common color for columns:", 15, 35, 80, 9},
		{301, 302, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)defcol, 110, 35, 20, 10},
		{302, 303, 0, 0x0L, RADIO1, (void*)" increment color scheme:", 15, 55, 80, 9},
		{303, 304, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[0], 25, 70, 10, 10},
		{304, 305, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[1], 37, 70, 10, 10},
		{305, 306, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[2], 49, 70, 10, 10},
		{306, 307, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[3], 61, 70, 10, 10},
		{307, 308, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[4], 73, 70, 10, 10},
		{308, 309, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[5], 85, 70, 10, 10},
		{309, 310, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[6], 97, 70, 10, 10},
		{310, 0, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[7], 109, 70, 10, 10},
		{500, 0, 0, LASTOBJ, NONE, 0L, 0, 0, 0, 0}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, ic, res, width, height, currYR=0, maxYR=0, nx=0, ny, rx, cx, ry, cy, oax;
	char **rd;
	double fx, fy, fz, fsz;
	bool updateYR = true, bContinue = false, bRet = false, bUseSch;
	AccRange *rX = 0L, *rY = 0L;
	Brick **cols;
	Scatt3D *plot;
	AxisDEF *ax;

	if(plots) {
		//Plots alredy defined: jump to config dialog
		return false;
		}
	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);
	if(!(rd = (char**)calloc(1, sizeof(char*))))return false;
	Dlg = new DlgRoot(Bar3D_Dlg);
	hDlg = CreateDlgWnd("Create 3D Bar Chart", 50, 50, 420, 260, Dlg, 0x0L);
	do {
		if(updateYR) {
			if(currYR >0) {
				Dlg->ShowItem(156, true);
				Dlg->Activate(101, false);
				}
			else {
				Dlg->ShowItem(156, false);
				Dlg->Activate(101, true);
				}
			sprintf(TmpTxt,"y-values # %d/%d", currYR+1, maxYR+1);
			//SetText will also cause a redraw of the whole dialog
			Dlg->SetText(153, TmpTxt);
			updateYR = false;
			}
		LoopDlgWnd();
		res = Dlg->GetResult();
		ny = 0;
		if(rX) delete rX;
		rX = 0L;
		switch(res) {
		case 0:
			if(bContinue || Dlg->GetCheck(20)) res = -1;
			break;
		case -1:
			bContinue = false;			break;
		case 1:
			for(i = 0; i < 8; i++) Dlg->GetColor(303+i, &colarr[i]);
			Dlg->GetColor(301, &defcol);
			bUseSch = Dlg->GetCheck(302);
			Dlg->GetValue(202, &start_z);	Dlg->GetValue(204, &dspm.fz);
			//execute com_StackDlg for <OK>
		case 155:		case 156:
			res = com_StackDlg(res, Dlg, &rX, &nx, &rd, &currYR,
				&rY, &bContinue, &ny, &maxYR, &updateYR);
			break;
		case 301:
			Dlg->SetCheck(300, 0L, true);
			res = -1;	break;
		case 303:	case 304:	case 305:	case 306:
		case 307:	case 308:	case 309:	case 310:
			Dlg->SetCheck(302, 0L, true);
			res = -1;	break;
			}
		}while (res < 0);
	if(res == 1 && nx && rX && rd && rd[0] && rd[0][0]) {
		if(rd[maxYR]) maxYR++;
		fsz = defs.GetSize(SIZE_BAR)/2.0;	fz = start_z;
		oax = AxisTempl3D;	AxisTempl3D = 1;	CreateAxes();
		if(Axes && nAxes > 2 && Axes[2] && (ax = Axes[2]->GetAxis())){
			ax->flags = AXIS_3D | AXIS_INVERT | AXIS_DEFRECT;
			ax->min = start_z-dspm.fz;
			ax->max = start_z+dspm.fz*maxYR;
			if(Axes[1] && (ax = Axes[1]->GetAxis())){
				ax->flags |= AXIS_GRIDLINE;
				i = 0x0c;
				Axes[1]->Command(CMD_SET_GRIDTYPE, &i, 0L);
				}
			AxisTempl3D = oax;
			}
		for(i = 0; i < maxYR; i++, fz += dspm.fz) {
			if(rd[i] && (cols = (Brick**)calloc(nx, sizeof(Brick*))) && (rY = new AccRange(rd[i]))) {
				ic = 0;
				if(rX->GetFirst(&cx, &rx) && rX->GetNext(&cx, &rx) &&
					rY->GetFirst(&cy, &ry) && rY->GetNext(&cy, &ry)) {
					do {
						if(data->GetValue(rx, cx, &fx) && data->GetValue(ry, cy, &fy)){
							cols[ic] = new Brick(this, data, fx, 0.0, fz, 
								fsz, fsz, fy, 0x800L, cx, rx, -1, -1, -1, -1,
								-1, -1, -1, -1, cy, ry);
							}
						ic++;
						}while(rX->GetNext(&cx, &rx) && rY->GetNext(&cy, &ry));
					if(ic) bRet = true;
					}
				delete(rY);		rY = 0L;
				if(plot = new Scatt3D(this, data, cols, ic)){
					if(bUseSch) plot->SetColor(COL_BAR_FILL, colarr[(i & 0x07)]);
					else plot->SetColor(COL_BAR_FILL, defcol);
					if(!(Command(CMD_DROP_PLOT, plot, 0L)))delete(plot);
					}
				}
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rd) {
		for (i = 0; i < maxYR; i++)	if(rd[i]) free(rd[i]);
		free(rd);
		}
	if(rX) delete rX;		if(rY) delete rY;
	if(bRet) {
		Command(CMD_MRK_DIRTY, 0L, 0L);
		}
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Create a 2.5 dimensional ribbon chart
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Ribbon25D::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Data"};
	TabSHEET tab2 = {25, 55, 10, "Details"};
	TabSHEET tab3 = {55, 90, 10, "Scheme"};
	static DWORD colarr[] = {0x000080ffL, 0x00ff8000L, 0x0000ff00L, 0x000000ffL,
		0x00ff00ff, 0x00ffff00L, 0x0000ffff, 0x00c0c0c0};
	static DWORD defcol = 0x00ffffffL;
	char text1[100];
	double start_z = 1.0;
	DlgInfo Bar3D_Dlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 158, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 158, 25, 45, 12},
		{3, 0, 10, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{10, 11, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 140, 100},
		{11, 12, 200, ISPARENT, SHEET, &tab2, 5, 10, 140, 100},
		{12, 20, 300, ISPARENT, SHEET, &tab3, 5, 10, 140, 100},
		{20, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for common x values", 15, 30, 60, 8},
		{101, 152, 0, 0x0L, EDTEXT, text1, 25, 40, 100, 10},
		{152, 153, 0, ISPARENT | CHECKED, GROUPBOX, (void*)" ranges for y values ", 12, 60, 128, 45},
		{153, 154, 0, 0x0L, LTEXT, 0L, 25, 65, 60, 8},
		{154, 155, 0, 0x0L, EDTEXT, 0L, 25, 75, 100, 10},
		{155, 156, 0, 0x0L, PUSHBUTTON, (void*)"Next >>", 95, 87, 30, 12},
		{156, 0, 0, 0x0L, PUSHBUTTON, (void*)"<< Prev.", 60, 87, 35, 12},
		{200, 201, 0, 0x0L, LTEXT, (void*)"distances:", 20, 35, 80, 8},
		{201, 202, 0, 0x0L, RTEXT, (void*)"start z =", 48, 45, 13, 8},
		{202, 203, 0, 0x0L, EDVAL1, &start_z, 65, 45, 25, 10},
		{203, 204, 0, 0x0L, RTEXT, (void*)"step =", 48, 57, 13, 8},
		{204, 0, 0, 0x0L, EDVAL1, &dspm.fz, 65, 57, 25, 10},
		{300, 301, 0, CHECKED, RADIO1, (void*)" common color for ribbons:", 15, 35, 80, 9},
		{301, 302, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)defcol, 110, 35, 20, 10},
		{302, 303, 0, 0x0L, RADIO1, (void*)" increment color scheme:", 15, 55, 80, 9},
		{303, 304, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[0], 25, 70, 10, 10},
		{304, 305, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[1], 37, 70, 10, 10},
		{305, 306, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[2], 49, 70, 10, 10},
		{306, 307, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[3], 61, 70, 10, 10},
		{307, 308, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[4], 73, 70, 10, 10},
		{308, 309, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[5], 85, 70, 10, 10},
		{309, 310, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[6], 97, 70, 10, 10},
		{310, 0, 0, OWNDIALOG | TOUCHEXIT, COLBUTTON, (void*)colarr[7], 109, 70, 10, 10},
		{500, 0, 0, LASTOBJ, NONE, 0L, 0, 0, 0, 0}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, res, width, height, currYR=0, maxYR=0, nx=0, ny, oax;
	char **rd;
	double fz;
	bool updateYR = true, bContinue = false, bRet = false, bUseSch;
	AccRange *rX = 0L, *rY = 0L;
	AxisDEF *ax;
	Ribbon *plot;

	if(plots) {
		//Plots alredy defined: jump to config dialog
		return false;
		}
	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);
	if(!(rd = (char**)calloc(1, sizeof(char*))))return false;
	Dlg = new DlgRoot(Bar3D_Dlg);
	hDlg = CreateDlgWnd("Create 3D Ribbon Chart", 50, 50, 420, 260, Dlg, 0x0L);
	do {
		if(updateYR) {
			if(currYR >0) {
				Dlg->ShowItem(156, true);		Dlg->Activate(101, false);
				}
			else {
				Dlg->ShowItem(156, false);		Dlg->Activate(101, true);
				}
			sprintf(TmpTxt,"y-values # %d/%d", currYR+1, maxYR+1);
			//SetText will also cause a redraw of the whole dialog
			Dlg->SetText(153, TmpTxt);
			updateYR = false;
			}
		LoopDlgWnd();
		res = Dlg->GetResult();
		ny = 0;		if(rX) delete rX;		rX = 0L;
		switch(res) {
		case 0:
			if(bContinue || Dlg->GetCheck(20)) res = -1;
			break;
		case -1:
			bContinue = false;			break;
		case 1:
			for(i = 0; i < 8; i++) Dlg->GetColor(303+i, &colarr[i]);
			Dlg->GetColor(301, &defcol);	bUseSch = Dlg->GetCheck(302);
			Dlg->GetValue(202, &start_z);	Dlg->GetValue(204, &dspm.fz);
			//execute com_StackDlg for <OK>
		case 155:		case 156:
			res = com_StackDlg(res, Dlg, &rX, &nx, &rd, &currYR,
				&rY, &bContinue, &ny, &maxYR, &updateYR);
			break;
		case 301:
			Dlg->SetCheck(300, 0L, true);
			res = -1;	break;
		case 303:	case 304:	case 305:	case 306:
		case 307:	case 308:	case 309:	case 310:
			Dlg->SetCheck(302, 0L, true);
			res = -1;	break;
			}
		}while (res < 0);
	if(res == 1 && nx && rX && rd && rd[0] && rd[0][0]) {
		if(rd[maxYR]) maxYR++;					fz = start_z;
		oax = AxisTempl3D;	AxisTempl3D = 1;	CreateAxes();
		Dlg->GetText(101, text1);
		if(Axes && nAxes > 2 && Axes[2] && (ax = Axes[2]->GetAxis())){
			ax->flags = AXIS_3D | AXIS_INVERT | AXIS_DEFRECT;
			ax->min = start_z-dspm.fz;
			ax->max = start_z+dspm.fz*maxYR;
			if(Axes[1] && (ax = Axes[1]->GetAxis())){
				ax->flags |= AXIS_GRIDLINE;				i = 0x0c;
				Axes[1]->Command(CMD_SET_GRIDTYPE, &i, 0L);
				}
			AxisTempl3D = oax;
			}
		for(i = 0; i < maxYR; i++, fz += dspm.fz) {
			if(plot = new Ribbon(this, data, fz, dspm.fz, text1, rd[i])){
				if(bUseSch) plot->SetColor(COL_POLYGON, colarr[(i & 0x07)]);
				else plot->SetColor(COL_POLYGON, defcol);
				if(!(Command(CMD_DROP_PLOT, plot, 0L)))delete(plot);
				}
			}
		Command(CMD_MRK_DIRTY, 0L, 0L);		Command(CMD_AUTOSCALE, 0L, 0L);
		bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rd) {
		for (i = 0; i < maxYR; i++)	if(rd[i]) free(rd[i]);
		free(rd);
		}
	if(rX) delete rX;		if(rY) delete rY;
	if(bRet) {
		Command(CMD_MRK_DIRTY, 0L, 0L);
		}
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Create a 3 dimensional bubble plot
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
BubblePlot3D::PropertyDlg()
{
	TabSHEET tab1 = {0, 22, 10, "Data"};
	TabSHEET tab3 = {22, 47, 10, "Axes"};
	char text1[100], text2[100], text3[100], text4[100];
	DlgInfo BubDlg3D[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 142, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 142, 25, 45, 12},
		{3, 50, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 5, 100, TOUCHEXIT | ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 131, 142},
		{5, 10, 400, TOUCHEXIT | ISPARENT, SHEET, &tab3, 5, 10, 131, 142},
		{10, 0, 0, 0x0L, CHECKPIN, 0L, 5, 0, 12, 8},
		{50, 0, 0, NOSELECT, ODBUTTON, (void*)(OD_AxisDesc3D), 142, 65, 45, 45},
		{100, 101, 0, 0x0L, LTEXT, (void*)"range for X Data", 10, 25, 60, 8},
		{101, 102, 0, 0x0L, EDTEXT, text1, 20, 35, 100, 10},
		{102, 103, 0, 0x0L, LTEXT, (void*)"range for Y Data", 10, 48, 60, 8},
		{103, 104, 0, 0x0L, EDTEXT, text2, 20, 58, 100, 10},
		{104, 105, 0, 0x0L, LTEXT, (void*)"range for Z Data", 10, 71, 60, 8},
		{105, 106, 0, 0x0L, EDTEXT, text3, 20, 81, 100, 10},
		{106, 0, 150, ISPARENT | CHECKED, GROUPBOX, (void*)" diameter ", 8, 98, 125, 50},
		{150, 151, 0, 0x0L, LTEXT, (void*)"range for diameters", 12, 102, 60, 8},
		{151, 152, 0, 0x0L, EDTEXT, text4, 20, 112, 100, 10},
		{152, 153, 0, 0x0L, LTEXT, (void*)"scaling:", 12, 125, 20, 8},
		{153, 154, 0, TOUCHEXIT | CHECKED, RADIO1, (void*)Units[defs.cUnits].display, 38, 125, 20, 8},
		{154, 155, 0, TOUCHEXIT, RADIO1, (void*)"with x-values", 70, 125, 20, 8},
		{155, 156, 0, TOUCHEXIT, RADIO1, (void*)"with y-values", 20, 135, 20, 8},
		{156, 0, 0, TOUCHEXIT, RADIO1, (void*)"with z-values", 70, 135, 20, 8},
		{400, 410, 0, 0x0L, LTEXT, (void*)"select template:", 20, 30, 60, 8},
		{410, 411, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl3D), 20, 42, 25, 25},
		{411, 412, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl3D), 45, 42, 25, 25},
		{412, 0, 0, LASTOBJ | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl3D), 70, 42, 25, 25}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, res, width, height, count;
	int cx, rx, cy, ry, cz, rz, cr, rr, s_type = 0;
	bool bRet = false;
	double fx, fy, fz, fr;
	Sphere **Balls;
	AccRange *rX, *rY, *rZ, *rR;
	Scatt3D *sc_plot;

	if(!data || !parent)return false;
	data->GetSize(&width, &height);
	sprintf(text1, "a1:a%d", height);		sprintf(text2, "b1:b%d", height);
	sprintf(text3, "c1:c%d", height);		sprintf(text4, "d1:d%d", height);
	if(!(Dlg = new DlgRoot(BubDlg3D)))return false;
	rX = rY = rZ = rR = 0L;
	Dlg->SetCheck(410 + AxisTempl3D, 0L, true);
	hDlg = CreateDlgWnd("Bubble Plot 3D", 50, 50, 388, 340, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 0:
			if(Dlg->GetCheck(10)) res = -1;
			break;
		case 4:		case 5:					//the tab sheets
			res = -1;
			break;
		case 153:	case 154:	case 155:	case 156:
			s_type = res - 153;
			res = -1;
			break;
		case 410:	case 411:	case 412:	//axis templates
			AxisTempl3D = res-410;
			res = -1;
			break;
			}
		}while (res <0);
	if(res == 1) {
		if(Dlg->GetText(101, TmpTxt)) rX = new AccRange(TmpTxt);
		if(Dlg->GetText(103, TmpTxt)) rY = new AccRange(TmpTxt);
		if(Dlg->GetText(105, TmpTxt)) rZ = new AccRange(TmpTxt);
		if(Dlg->GetText(151, TmpTxt)) rR = new AccRange(TmpTxt);
		if(rX && rY && rZ && rR && (count = rX->CountItems()) 
			&& (Balls = (Sphere**)calloc(count, sizeof(Sphere*)))) {
			rX->GetFirst(&cx, &rx);		rY->GetFirst(&cy, &ry);
			rZ->GetFirst(&cz, &rz);		rR->GetFirst(&cr, &rr);
			for(i = 0; i < count; i++){
				if(rX->GetNext(&cx, &rx) && rY->GetNext(&cy, &ry)
					&& rZ->GetNext(&cz, &rz) && rR->GetNext(&cr, &rr)
					&& data->GetValue(rx, cx, &fx) && data->GetValue(ry, cy, &fy)
					&& data->GetValue(rz, cz, &fz) && data->GetValue(rr, cr, &fr)) {
					Balls[i] = new Sphere(this, data, s_type, fx, fy, fz, fr, cx, rx,
						cy, ry, cz, rz, cr, rr);
					}
				}
			sc_plot = new Scatt3D(this, data, Balls, count);
			if(parent->Id == GO_PLOT3D) {
				if(!(parent->Command(CMD_DROP_PLOT, sc_plot, 0L))) delete(sc_plot);
				bRet = true;
				}
			else if(!(bRet = Command(CMD_DROP_PLOT, sc_plot, 0L))) delete(sc_plot);
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rX) delete rX;	if(rY) delete rY;	if(rZ) delete rZ;	if(rR) delete rR;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Grid line properties
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
GridLine::PropertyDlg()
{
	TabSHEET tab1 = {0, 21, 10, "Line"};
	int dh = ((flags & AXIS_ANGULAR) || (flags & AXIS_RADIAL))? -20 : 0;
	DlgInfo LineDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to LINE", 150, 10, 50, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Apply to AXIS", 150, 25, 50, 12},
		{3, 10, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 40, 50, 12},
		{10, 0, 100, ISPARENT | CHECKED, GROUPBOX, (void*)" grid line ", 5, 10, 139, 123+dh},
		{100, 101, 0, NOSELECT, ODBUTTON, (void*)OD_linedef, 10, 18, 130, 100},
		{101, 102, 112, HIDDEN | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{102, 103, 115, HIDDEN | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{103, 104, 120, HIDDEN | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{104, 105, 125, HIDDEN | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{105, 0, 130, HIDDEN | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{111, 0, 0, 0x0L, RTEXT, (void*)"line to:", 15, 117, 23, 8},
		{112, 113, 0, 0x0L, CHECKBOX, (void*)"left", 41, 117, 25, 8},
		{113, 114, 0, 0x0L, CHECKBOX, (void*)"right", 105, 117, 25, 8},
		{114, 111, 0, 0x0L, CHECKBOX, (void*)"y-axis", 70, 117, 25, 8},
		{115, 116, 0, 0x0L, CHECKBOX, (void*)"top", 41, 117, 25, 8},
		{116, 117, 0, 0x0L, CHECKBOX, (void*)"bottom", 105, 117, 25, 8},
		{117, 111, 0, 0x0L, CHECKBOX, (void*)"x-axis", 70, 117, 25, 8},
		{120, 121, 0, 0x0L, CHECKBOX, (void*) "x-axis", 55, 117, 25, 8},
		{121, 135, 0, 0x0L, CHECKBOX, (void*) "y-axis", 90, 117, 25, 8},
		{125, 126, 0, 0x0L, CHECKBOX, (void*) "x-axis", 55, 117, 25, 8},
		{126, 135, 0, 0x0L, CHECKBOX, (void*) "z-axis", 90, 117, 25, 8},
		{130, 131, 0, 0x0L, CHECKBOX, (void*) "y-axis", 55, 117, 25, 8},
		{131, 135, 0, 0x0L, CHECKBOX, (void*) "z-axis", 90, 117, 25, 8},
		{135, 0, 0, LASTOBJ, LTEXT, (void*)"parallel to:", 15, 117, 55, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmptype;
	bool bRet = false;
	DWORD undo_flags = 0L;
	LineDEF newLine;

	if(!parent || !parent->parent) return false;
	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)&LineDef, 0);
	if(!(Dlg = new DlgRoot(LineDlg)))return false;
	if ((flags & AXIS_ANGULAR) || (flags & AXIS_RADIAL)) {
		//no checkboxes
		}
	else if(flags &AXIS_3D) {
		Dlg->SetCheck(120, 0L, type & 0x01 ? true : false);
		Dlg->SetCheck(121, 0L, type & 0x02 ? true : false);
		Dlg->SetCheck(125, 0L, type & 0x04 ? true : false);
		Dlg->SetCheck(126, 0L, type & 0x08 ? true : false);
		Dlg->SetCheck(130, 0L, type & 0x10 ? true : false);
		Dlg->SetCheck(131, 0L, type & 0x20 ? true : false);
		switch(parent->parent->type) {
		case 1:	Dlg->ShowItem(105, true);	break;
		case 2:	Dlg->ShowItem(104, true);	break;
		case 3: Dlg->ShowItem(103, true);	break;
			}
		}
	else {
		Dlg->SetCheck(112, 0L, type & DL_LEFT ? true : false);
		Dlg->SetCheck(113, 0L, type & DL_RIGHT ? true : false);
		Dlg->SetCheck(114, 0L, type & DL_YAXIS ? true : false);
		Dlg->SetCheck(115, 0L, type & DL_TOP ? true : false);
		Dlg->SetCheck(116, 0L, type & DL_BOTTOM ? true : false);
		Dlg->SetCheck(117, 0L, type & DL_XAXIS ? true : false);
		if(type & 0x07) Dlg->ShowItem(101, true);
		else Dlg->ShowItem(102, true);
		}
	hDlg = CreateDlgWnd("Grid line properties", 50, 50, 415, 300 + dh*2, Dlg, 0x0L);
	do{												//dh*2 means dh * ybase
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 1:							//this line
		case 2:							//all lines of plot
			if(flags &AXIS_3D) {
				tmptype = 0;
				if(Dlg->GetCheck(120)) tmptype |= 0x01;
				if(Dlg->GetCheck(121)) tmptype |= 0x02;
				if(Dlg->GetCheck(125)) tmptype |= 0x04;
				if(Dlg->GetCheck(126)) tmptype |= 0x08;
				if(Dlg->GetCheck(130)) tmptype |= 0x10;
				if(Dlg->GetCheck(131)) tmptype |= 0x20;
				}
			else {
				tmptype = (type & ~0xff);
				if(Dlg->GetCheck(112)) tmptype |= DL_LEFT;
				if(Dlg->GetCheck(113)) tmptype |= DL_RIGHT;
				if(Dlg->GetCheck(114)) tmptype |= DL_YAXIS;
				if(Dlg->GetCheck(115)) tmptype |= DL_TOP;
				if(Dlg->GetCheck(116)) tmptype |= DL_BOTTOM;
				if(Dlg->GetCheck(117)) tmptype |= DL_XAXIS;
				}
			OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&newLine, 0);
			break;
			}
		}while (res < 0);
	if(res == 1){			//Apply to line
		undo_flags = CheckNewInt(&type, type, tmptype, parent, undo_flags);
		if(cmpLineDEF(&LineDef, &newLine)) {
			Undo.Line(parent, &LineDef, undo_flags);	undo_flags |= UNDO_CONTINUE;
			memcpy(&LineDef, &newLine, sizeof(LineDEF));
			}
		if(undo_flags & UNDO_CONTINUE) bRet = bModified = true;
		}
	else if(res == 2) {		//Apply to axis
		if(parent->Id == GO_TICK && parent->parent->Id == GO_AXIS &&
			(tmptype != type || cmpLineDEF(&LineDef, &newLine))) {
			parent->parent->Command(CMD_SAVE_TICKS, 0L, 0L);
			if(cmpLineDEF(&LineDef, &newLine)) parent->parent->Command(CMD_SET_GRIDLINE, (void*)&newLine, 0L);
			if(tmptype != type) parent->parent->Command(CMD_SET_GRIDTYPE, (void*)(& tmptype), 0L);
			bRet = true;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Tick properties
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Tick::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Tick"};
	TabSHEET tab2 = {64, 90, 10, "Edit"};
	TabSHEET tab3 = {25, 64, 10, "Direction"};
	double tick_rot;
	DlgInfo TickDlg[] = {
		{1, 2, 0, 0x0L, PUSHBUTTON, (void*)"Apply to TICK", 100, 10, 50, 12},
		{2, 3, 0, DEFAULT, PUSHBUTTON, (void*)"Apply to AXIS", 100, 25, 50, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 100, 40, 50, 12},
		{4, 0, 5, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{5, 6, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 90, 100},
		{6, 7, 300, ISPARENT, SHEET, &tab3, 5, 10, 90, 100},
		{7, 0, 200, ISPARENT, SHEET, &tab2, 5, 10, 90, 100},
		{100, 101, 0, 0x0L, RTEXT, (void*)"tick size", 10, 30, 35, 8},
		{101, 102, 0, 0x0L, EDVAL1, &size, 50, 30, 25, 10},
		{102, 103, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 77, 30, 20, 8},
		{103, 104, 0, 0x0L, CHECKBOX, (void*)"major tick", 18, 45, 30, 8},
		{104, 105, 0, 0x0L, LTEXT, (void*)"type:", 18, 60, 20, 8},
		{105, 106, 0, 0x0L, RADIO1, 0L, 40, 70, 35, 8},
		{106, 107, 0, 0x0L, RADIO1, 0L, 40, 60, 35, 8},
		{107, 108, 0, 0x0L, RADIO1, (void*)"symetric", 40, 80, 35, 8},
		{108, 0, 0, 0x0L, CHECKBOX, (void*)"draw grid line(s)", 18, 95, 30, 8},
		{200, 201, 0, 0x0L, RTEXT, (void*)"value:", 10, 35, 23, 8},
		{201, 202, 0, 0x0L, EDVAL1, &value, 40, 35, 35, 10},
		{202, 203, 0, 0x0L, LTEXT, (void*)"label:", 15, 50, 20, 8},
		{203, 0, 0, 0x0L, EDTEXT, (void*)0L, 15, 62, 70, 10},
		{300, 301, 0, 0x0L, LTEXT, (void*)"direction of ticks", 15, 30, 70, 8},
		{301, 302, 0, TOUCHEXIT, RADIO1, (void*)"perpendicular to axis", 15, 42, 70, 8},
		{302, 303, 0, TOUCHEXIT, RADIO1, (void*)"fixed angle", 15, 52, 70, 8},
		{303, 304, 0, TOUCHEXIT, RADIO1, (void*)"x-axis", 15, 74, 70, 8},
		{304, 305, 0, TOUCHEXIT, RADIO1, (void*)"y-axis", 15, 84, 70, 8},
		{305, 306, 0, TOUCHEXIT, RADIO1, (void*)"z-axis", 15, 94, 70, 8},
		{306, 307, 0, 0x0L, EDVAL1, &tick_rot, 28, 62, 35, 10},
		{307, 0, 0, LASTOBJ, LTEXT, (void*)"degree", 65, 62, 20, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	DWORD old_flags;
	double new_size, old_size, new_angle, old_angle, new_value, old_value;
	int res, tmp_type = type;
	bool bRet = false;
	DWORD new_flags = flags, undo_flags = 0;
	char *old_label = 0L;
	TextDEF *td;

	if(!parent || parent->Id != GO_AXIS) return false;
	switch(type & 0x0f) {
	case 1:		tick_rot = angle;					break;
	default:	tick_rot = trig2deg(lsi, lcsi);		break;
		}
	old_flags = flags;
	Dlg = new DlgRoot(TickDlg);
	Dlg->SetCheck(301 + (type & 0x07), 0L, true);
	if(flags & AXIS_ANGULAR) {
		Dlg->SetText(105, "outside");		Dlg->SetText(106, "inside");
		Dlg->ShowItem(303, false);			Dlg->ShowItem(304, false);
		Dlg->ShowItem(305, false);
		}
	else if(flags & AXIS_3D) {
		Dlg->SetText(105, "positive");		Dlg->SetText(106, "negative");
		if(parent->Id == GO_AXIS) {
			//disable tick direction onto the axis
			switch(parent->type) {
			case 1:	Dlg->Activate(303, false);	break;
			case 2:	Dlg->Activate(304, false);	break;
			case 3:	Dlg->Activate(305, false);	break;
				}
			}
		}
	else {
		Dlg->ShowItem(303, false);	Dlg->ShowItem(304, false);
		Dlg->ShowItem(305, false);
		if(abs(pts[1].x - pts[0].x) > abs(pts[1].y - pts[0].y)){
			Dlg->SetText(105, "right");		Dlg->SetText(106, "left");
			}
		else {
			Dlg->SetText(105, "up");		Dlg->SetText(106, "down");
			}
		}
	if(label) {
		label->Command(CMD_GETTEXT, &TmpTxt, 0L);
		if(TmpTxt[0]) {
			old_label = strdup(TmpTxt);
			Dlg->SetText(203, old_label);
			}
		if(label->Id != GO_LABEL) Dlg->Activate(203, false);
		}
	switch(flags &0x03) {
	case AXIS_NEGTICKS:		Dlg->SetCheck(106, 0L, true);		break;
	case AXIS_SYMTICKS:		Dlg->SetCheck(107, 0L, true);		break;
	default:				Dlg->SetCheck(105, 0L, true);		break;
		}
	if(flags & AXIS_GRIDLINE) Dlg->SetCheck(108, 0L, true); 
	if(!(flags & AXIS_MINORTICK)) Dlg->SetCheck(103, 0L, true);
	if(Dlg->GetValue(101, &old_size)) new_size = old_size;
	else new_size = old_size = size;
	if(Dlg->GetValue(306, &old_angle)) new_angle = old_angle;
	else new_angle = old_angle = tick_rot;
	if(Dlg->GetValue(201, &old_value)) new_value = old_value;
	else new_value = old_value = value;
	hDlg = CreateDlgWnd("Tick properties", 50, 50, 315, 260, Dlg, 0x0L);
	do {
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 1:		case 2:
			new_flags &= ~0x7;
			if(Dlg->GetCheck(105)) new_flags |= AXIS_POSTICKS;
			else if(Dlg->GetCheck(106)) new_flags |= AXIS_NEGTICKS;
			else new_flags |= AXIS_SYMTICKS;
			if(Dlg->GetCheck(108)) new_flags |= AXIS_GRIDLINE;
			Dlg->GetValue(101, &new_size);		Dlg->GetValue(306, &new_angle);
			Dlg->GetValue(201, &new_value);
			break;
		case 301:	case 302:	case 303:	case 304:	case 305:
			tmp_type = (tmp_type & ~0x0f) | (res -301);
			res = -1;
			break;
			}
		}while (res <0);
	if(res == 1) {
		if(Dlg->GetCheck(103)) new_flags &= ~AXIS_MINORTICK;
		else new_flags |= AXIS_MINORTICK;
		undo_flags = CheckNewDword(&flags, flags, new_flags, parent, undo_flags);
		undo_flags = CheckNewInt(&type, type, tmp_type, parent, undo_flags);
		undo_flags = CheckNewFloat(&size, old_size, new_size, parent, undo_flags);
		undo_flags = CheckNewFloat(&angle, old_angle, new_angle, parent, undo_flags);
		undo_flags = CheckNewFloat(&value, old_value, new_value, parent, undo_flags);
		if(label && label->Id == GO_LABEL) {
			td = ((Label*)label)->GetTextDef();
			if(!Dlg->GetText(203, TmpTxt)) TmpTxt[0] = 0;
			if(td->text && strcmp(td->text, TmpTxt)) {
				Undo.String(this, &td->text, undo_flags);
				undo_flags |= UNDO_CONTINUE;
				label->Command(CMD_SETTEXT, TmpTxt, 0L);
				}
			}
		if (undo_flags & UNDO_CONTINUE) bRet = true;
		}
	else if(res == 2) {
		parent->Command(CMD_SAVE_TICKS, 0L, 0L);
		if((new_flags & 0x07) != (old_flags & 0x07)) 
			parent->Command(CMD_SET_TICKSTYLE, &new_flags, 0L);
		parent->SetSize(SIZE_AXIS_TICKS, new_size);
		parent->Command(CMD_TICK_TYPE, &tmp_type, 0L);
		parent->SetSize(SIZE_TICK_ANGLE, new_angle);
		parent->Command(CMD_REDRAW, 0L, 0L);
		bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(old_label) free(old_label);
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Axis properties dialog
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Axis::ssTicks()
{
	DlgInfo TickDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 113, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 113, 25, 45, 12},
		{3, 4, 0, 0x0L, LTEXT, (void*)"range for major tick VALUES:", 5, 10, 100, 9},
		{4, 5, 0, 0x0L, EDTEXT, (void*)ssMATval, 10, 20, 90, 10},
		{5, 6, 0, 0x0L, LTEXT, (void*)"range for major tick LABELS:", 5, 32, 100, 9},
		{6, 7, 0, 0x0L, EDTEXT, (void*)ssMATlbl, 10, 42, 90, 10},
		{7, 8, 0, 0x0L, LTEXT, (void*)"minor tick VALUES:", 5, 54, 80, 8},
		{8, 0, 0, LASTOBJ, EDTEXT, (void*)ssMITval, 10, 64, 90, 10}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, n, n1, n2, n3;
	bool bRet = false, bContinue = false;
	AccRange *rT, *rL, *rMT;

	if(!data) return false;
	n = n1 = n2 = n3 = 0;			rT = rL = rMT = 0L;
	if(!(Dlg = new DlgRoot(TickDlg)))return false;
	hDlg = CreateDlgWnd("choose ticks from spreadsheet", 50, 50, 330, 190, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res) {
		case 0:								// focus lost
			if(bContinue) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 1:
			if(rT) delete rT;		if(rL) delete rL;		if(rMT) delete rMT;
			n = n1 = n2 = n3 = 0;	rT = rL = rMT = 0L;
			if(Dlg->GetText(4,TmpTxt) && (rT=new AccRange(TmpTxt)) && (n1=rT->CountItems())){
				if(Dlg->GetText(6,TmpTxt) && (rL = new AccRange(TmpTxt)) && 
					(n2 = rL->CountItems()) && n1 != n2){
					ErrorBox("Ranges for tick values\nand tick labels must"
						" have\nthe same size");
					res = -1;		bContinue = true;
					break;
					}
				}
			if(Dlg->GetText(8,TmpTxt) && (rMT=new AccRange(TmpTxt)) && (n3=rMT->CountItems())){
				//minor ticks are valid
				}
			if(!(n = n1 + n3)) {
				ErrorBox("Ranges not valid or\nno range specified");
				res = -1;			bContinue = true;
				}
			}
		}while (res < 0);
	if(res == 1 && n) {
		if(n1) {
			if(ssMATval) free(ssMATval);	if(ssMATlbl) free(ssMATlbl);
			if(ssMITval) free(ssMITval);	ssMATval = ssMATlbl = ssMITval = 0L;
			if(Dlg->GetText(4, TmpTxt))ssMATval = strdup(TmpTxt);
			if(Dlg->GetText(6, TmpTxt))ssMATlbl = strdup(TmpTxt);
			if(Dlg->GetText(8, TmpTxt))ssMITval = strdup(TmpTxt);
			UpdateTicks();
			}
		bRet = true;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(rT) delete rT;	if(rL) delete rL;	if(rMT) delete rMT;
	return bRet;
}

bool
Axis::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Axis"};
	TabSHEET tab2 = {25, 50, 10, "Ticks"};
	TabSHEET tab3 = {50, 92, 10, "Transforms"};
	TabSHEET tab4 = {92, 123, 10, "Breaks"};
	TabSHEET tab5 = {123, 148, 10, "Plots"};
	int v1 = (axis->flags & AXIS_3D) ? 77 : (axis->flags & AXIS_RADIAL) ? 83 : 89; 
	DlgInfo AxisDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 166, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 166, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 0, 0, 0, 0},
		{4, 5, 50, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 148, 165},
		{5, 6, 200, ISPARENT, SHEET, &tab2, 5, 10, 148, 165},
		{6, 7, 300, ISPARENT, SHEET, &tab3, 5, 10, 148, 165},
		{7, 8, 400, ISPARENT, SHEET, &tab4, 5, 10, 148, 165},
		{8, 0, 500, HIDDEN | ISPARENT, SHEET, &tab5, 5, 10, 148, 165},
		{50, 51, 100, ISPARENT | CHECKED, GROUPBOX, (void*)" scaling ", 10, 30, 138, 36},
		{51, 104, 0, TOUCHEXIT, CHECKBOX, (void*)" automatic scaling", 17, 37, 80, 8},
		{100, 101, 0, 0x0L, RTEXT, (void*)"axis from", 10, 51, 35, 8},
		{101, 102, 0, 0x0L, EDVAL1, &axis->min, 48, 51, 41, 10},
		{102, 103, 0, 0x0L, CTEXT, (void*)"to", 90, 51, 11, 8},
		{103, 0, 0, 0x0L, EDVAL1, &axis->max, 102, 51, 41, 10},
		{104, 120, 105, ISPARENT | CHECKED, GROUPBOX, (void*)" placement ", 10, 72, 138, 45},
		{105, 106, 0, TOUCHEXIT | ISRADIO, CHECKBOX, (void*)"left", 54, 77, 20, 8},
		{106, 107, 0, TOUCHEXIT | ISRADIO, CHECKBOX, (void*)"right", 84, 77, 20, 8},
		{107, 108, 0, TOUCHEXIT | ISRADIO, CHECKBOX, (void*)"top", 54, 77, 20, 8},
		{108, 109, 0, TOUCHEXIT | ISRADIO, CHECKBOX, (void*)"bottom", 84, 77, 20, 8},
		{109, 110, 0, 0x0L, RTEXT, (void*)"x", 10, v1, 15, 8},
		{110, 111, 0, 0x0L, EDVAL1, &axis->loc[0].fx, 27, v1, 45, 10},
		{111, 112, 0, 0x0L, LTEXT, (void*)"-", 75, v1, 5, 8},
		{112, 113, 0, 0x0L, EDVAL1, &axis->loc[1].fx, 81, v1, 45, 10},
		{113, 114, 0, 0x0L, LTEXT, (void*)0L, 129, v1, 15, 8},
		{114, 115, 0, 0x0L, RTEXT, (void*)"y", 10, v1+12, 15, 8},
		{115, 116, 0, 0x0L, EDVAL1, &axis->loc[0].fy, 27, v1+12, 45, 10},
		{116, 117, 0, 0x0L, LTEXT, (void*)"-", 75, v1+12, 5, 8},
		{117, 118, 0, 0x0L, EDVAL1, &axis->loc[1].fy, 81, v1+12, 45, 10},
		{118, 150, 0, 0x0L, LTEXT, (void*)0L, 129, v1+12, 15, 8},
		{150, 151, 0, 0x0L, RTEXT, (void*)"z", 10, v1+24, 15, 8},
		{151, 152, 0, 0x0L, EDVAL1, &axis->loc[0].fz, 27, v1+24, 45, 10},
		{152, 153, 0, 0x0L, LTEXT, (void*)"-", 75, v1+24, 5, 8},
		{153, 154, 0, 0x0L, EDVAL1, &axis->loc[1].fz, 81, v1+24, 45, 10},
		{154, 0, 0, 0x0L, LTEXT, (void*)0L, 129, v1+24, 15, 8},
		{120, 180, 121, ISPARENT | CHECKED, GROUPBOX, (void*)" line ", 10, 123, 138, 20},
		{121, 122, 0, 0x0L, RTEXT, (void*)"width", 10, 128, 25, 8},
		{122, 123, 0, 0x0L, EDVAL1, &sizAxLine, 37, 128, 25, 10},
		{123, 124, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 63, 128, 10, 8},
		{124, 125, 0, 0x0L, RTEXT, (void*)"color", 82, 128, 25, 8},
		{125, 130, 0, OWNDIALOG, COLBUTTON, (void *)colAxis, 109, 128, 25, 10},
		{130, 0, 131, ISPARENT | CHECKED, GROUPBOX, (void*)" axis label ", 10, 149, 138, 20},
		{131, 0, 0, 0x0L, EDTEXT, (void*)"abc", 15, 154, 128, 10},
		{180, 0, 181, HIDDEN | ISPARENT | CHECKED, GROUPBOX, (void*)" placement ", 10, 72, 138, 45},
		{181, 182, 0, 0x0L, RTEXT, (void*)"center x", 10, v1-12, 50, 8},
		{182, 183, 0, 0x0L, EDVAL1, &axis->Center.fx, 62, v1-12, 45, 10},
		{183, 184, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 109, v1-12, 15, 8},
		{184, 185, 0, 0x0L, RTEXT, (void*)"y", 10, v1, 50, 8},
		{185, 186, 0, 0x0L, EDVAL1, &axis->Center.fy, 62, v1, 45, 10},
		{186, 187, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 109, v1, 15, 8},
		{187, 188, 0, 0x0L, RTEXT, (void*)"radius", 10, v1+12, 50, 8},
		{188, 189, 0, 0x0L, EDVAL1, &axis->Radius, 62, v1+12, 45, 10},
		{189, 0, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 109, v1+12, 15, 8},
		{200, 201, 0, TOUCHEXIT, RADIO1, (void*)"no ticks", 20, 35, 40, 8},
		{201, 202, 0, TOUCHEXIT, RADIO1, (void*)"automatic", 20, 47, 40, 8},
		{202, 204, 0, TOUCHEXIT, RADIO1, (void*)"leave unchanged", 20, 59, 40, 8},
		{203, 205, 0, TOUCHEXIT, RADIO1, (void*)"set manually", 20, 71, 40, 8},
		{204, 203, 250, CHECKED | ISPARENT, GROUPBOX, (void*)"                            ", 15, 75, 110, 50},
		{205, 206, 0, 0x0L, PUSHBUTTON, (void*)"use spread sheet values", 30, 130, 80, 12},
		{206, 0, 0, TOUCHEXIT, RADIO1, 0L, 20, 130, 8, 8},
		{250, 251, 0, 0x0L, RTEXT, (void*)"start value", 30, 83, 45, 8},
		{251, 252, 0, 0x0L, EDVAL1, &axis->Start, 77, 83, 35, 10},
		{252, 253, 0, 0x0L, RTEXT, (void*)"interval", 30, 95, 45, 8},
		{253, 254, 0, 0x0L, EDVAL1, &axis->Step, 77, 95, 35, 10},
		{254, 255, 0, 0x0L, RTEXT, (void*)"minor ticks per interval", 20, 107, 75, 8},
		{255, 0, 0, 0x0L, EDTEXT, (void*)"0", 97, 107, 15, 10},
		{300, 301, 0, 0x0L, LTEXT, (void*)"Transforms:", 10, 30, 110, 8},
		{301, 302, 0, TOUCHEXIT, RADIO1, (void*)"none (linear)", 20, 45, 70, 8},
		{302, 303, 0, TOUCHEXIT, RADIO1, (void*)"logarithmic (log base 10)", 20, 57, 70, 8},
		{303, 304, 0, TOUCHEXIT, RADIO1, (void*)"reciprocal (1/x)", 20, 69, 70, 8},
		{304, 305, 0, TOUCHEXIT, RADIO1, (void*)"square root", 20, 81, 70, 8},
		{305, 0, 0, 0x0L, CHECKBOX, axis->loc[0].fx == axis->loc[1].fx ? 
			(void*)"low vaues top of graph" : (void*)"low values right of graph", 20, 115, 80, 12},
		{400, 450, 0, 0x0L, LTEXT, (void*)"style:", 10, 30, 110, 8},
		{401, 402, 0, ISRADIO, ODBUTTON, (void*)(OD_BreakTempl), 29, 40, 25, 25},
		{402, 403, 0, ISRADIO, ODBUTTON, (void*)(OD_BreakTempl), 54, 40, 25, 25},
		{403, 404, 0, ISRADIO, ODBUTTON, (void*)(OD_BreakTempl), 79, 40, 25, 25},
		{404, 405, 0, ISRADIO, ODBUTTON, (void*)(OD_BreakTempl), 104, 40, 25, 25},
		{405, 406, 0, 0x0L, RTEXT, (void*)"break gap", 15, 75, 48, 8},
		{406, 407, 0, 0x0L, EDVAL1, &brkgap, 65, 75, 29, 10},
		{407, 408, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 97, 75, 10, 8},
		{408, 409, 0, 0x0L, RTEXT, (void*)"symbol size", 15, 87, 48, 8},
		{409, 410, 0, 0x0L, EDVAL1, &brksymsize, 65, 87, 29, 10},
		{410, 0, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 97, 87, 10, 8},
		{450, 451, 0, ISPARENT | CHECKED, GROUPBOX, (void*)" break data ", 10, 110, 138, 50},
		{451, 452, 0, 0x0L, LTEXT, 0L, 20, 115, 60, 8},
		{452, 453, 0, 0x0L, PUSHBUTTON, (void*)"Next >>", 98, 142, 41, 12},
		{453, 454, 0, 0x0L, PUSHBUTTON, (void*)"<< Prev.", 57, 142, 41, 12},
		{454, 455, 0, 0x0L, RTEXT, (void*)"from", 15, 125, 20, 8},
		{455, 456, 0, 0x0L, EDTEXT, 0L, 37, 125, 41, 10},
		{456, 457, 0, 0x0L, RTEXT, (void*)"to", 82, 125, 9, 8},
		{457, 458, 0, 0x0L, EDTEXT, 0L, 93, 125, 41, 10},
		{458, 401, 0, 0x0L, PUSHBUTTON, (void*)"Delete", 16, 142, 41, 12},
		{500, 0, 0, NOSELECT, ODBUTTON, (void*)OD_axisplot, 25, 30, 110, 140},
		{600, 0, 0, LASTOBJ, NONE, 0L, 0, 0, 0, 0}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, j, res, nbrk, cbrk, ttmpl;
	double tmp, tmp2, old_x1, old_x2, old_y1, old_y2;
	bool bRet = false, bChanged = false, upd_brk = true, bContinue = false;
	DWORD new_color, undo_flags = 0L;
	lfPOINT *brks = 0L, *tmpbrks = 0L;
	char *old_Label = 0L, *type_txt;
	TextDEF label_def, *lb_def;
	char **names;
	GraphObj **somePlots = 0L, **scp = 0L;
	AxisDEF old_a, new_a;
	void *sv_ptr;


	nbrk = cbrk = 0;
	if(!parent) return false;
	if(parent->Id == GO_GRAPH && (res=((Graph*)parent)->nscp)){
		scp = ((Graph*)parent)->Sc_Plots;
		CurrAxes = ((Graph*)parent)->Axes;
		if(!scp || !(names = (char**)calloc(res+2, sizeof(char*))) ||
			!(somePlots = (GraphObj**)calloc(res+2, sizeof(GraphObj*))))
			return false;
		names[j=0] = strdup("[unchanged]");
		for(i = 0, j = 1; i < res; i++) {
			if(scp[i] && scp[i]->name){
				names[j] = strdup(scp[i]->name);
				somePlots[j++] = scp[i];
				}
			}
		}
	else {
		names = (char**)calloc(2, sizeof(char*));
		names[0] = strdup("n.a.");
		}
	OD_axisplot(OD_ACCEPT, 0L, 0L, 0L, names, 0);
	if(!(Dlg = new DlgRoot(AxisDlg)))return false;
	if(names && somePlots) Dlg->ShowItem(8, true);		//show tab
	if(axis->breaks && axis->nBreaks) {
		if(!(brks = (lfPOINT*)calloc(axis->nBreaks+2, sizeof(lfPOINT)))) return false;
		memcpy(brks, axis->breaks, axis->nBreaks*sizeof(lfPOINT));
		nbrk = axis->nBreaks-1;
		WriteNatFloatToBuff(TmpTxt, brks[cbrk].fx);
		Dlg->SetText(455, TmpTxt+1);
		WriteNatFloatToBuff(TmpTxt, brks[cbrk].fy);
		Dlg->SetText(457, TmpTxt+1);
		}
	switch(brksym) {
	case 2:		Dlg->SetCheck(402, 0L, true);	break;
	case 3:		Dlg->SetCheck(403, 0L, true);	break;
	case 4:		Dlg->SetCheck(404, 0L, true);	break;
	default:	Dlg->SetCheck(401, 0L, true);	break;
		}
	if(!(axis->flags & 0x03)) Dlg->SetCheck(ttmpl = 200, 0L, true);
	else if(axis->flags & AXIS_AUTOTICK)Dlg->SetCheck(ttmpl = 201, 0L, true);
	else if(Ticks) Dlg->SetCheck(ttmpl = 202, 0L, true);
	else Dlg->SetCheck(ttmpl = 201, 0L, true);
	Dlg->Activate(251, false);	Dlg->Activate(253, false);	Dlg->Activate(255, false);
	Dlg->SetCheck(305, 0L, (AXIS_INVERT == (axis->flags & AXIS_INVERT)));
	if(axis->flags & AXIS_AUTOSCALE) {
		Dlg->SetCheck(51, 0L, true);
		Dlg->Activate(101, false);		Dlg->Activate(103, false);
		}
	//check transforms
	switch(axis->flags & 0x7000L) {
	case AXIS_LINEAR:	Dlg->SetCheck(301, 0L, true);	break;
	case AXIS_LOG:		Dlg->SetCheck(302, 0L, true);	break;
	case AXIS_RECI:		Dlg->SetCheck(303, 0L, true);	break;
	case AXIS_SQR:		Dlg->SetCheck(304, 0L, true);	break;
		}
	//align to frame ?
	if(axis->flags & AXIS_3D) {
		Dlg->ShowItem(105, false);	Dlg->ShowItem(106, false);
		Dlg->ShowItem(107, false);	Dlg->ShowItem(108, false);
		}
	else if(axis->flags & AXIS_ANGULAR) {
		Dlg->ShowItem(104, false);	Dlg->ShowItem(130, false);
		Dlg->ShowItem(180, true);	Dlg->ShowItem(7, false);
		}
	else {
		if(axis->flags & AXIS_RADIAL) {
			Dlg->ShowItem(105, false);	Dlg->ShowItem(106, false);
			Dlg->ShowItem(107, false);	Dlg->ShowItem(108, false);
			}
		Dlg->ShowItem(150, false);	Dlg->ShowItem(151, false);
		Dlg->ShowItem(152, false);	Dlg->ShowItem(153, false);
		Dlg->ShowItem(154, false);
		if(axis->loc[0].fx != axis->loc[1].fx) {
			Dlg->ShowItem(105, false);	Dlg->ShowItem(106, false);
			}
		if(axis->loc[0].fy != axis->loc[1].fy) {
			Dlg->ShowItem(107, false);	Dlg->ShowItem(108, false);
			}
		}
	switch(axis->flags & 0x70) {
		case AXIS_LEFT: Dlg->SetCheck(105, 0L, true);	break;
		case AXIS_RIGHT: Dlg->SetCheck(106, 0L, true);	break;
		case AXIS_TOP: Dlg->SetCheck(107, 0L, true);	break;
		case AXIS_BOTTOM: Dlg->SetCheck(108, 0L, true);	break;
		}
	if(axis->flags & AXIS_X_DATA) Dlg->SetText(113, "[data]");
	else Dlg->SetText(113, Units[defs.cUnits].display);
	if(axis->flags & AXIS_Y_DATA) Dlg->SetText(118, "[data]");
	else Dlg->SetText(118, Units[defs.cUnits].display);
	if(axis->flags & AXIS_Z_DATA) Dlg->SetText(118, "[data]");
	else Dlg->SetText(154, Units[defs.cUnits].display);
	//any label ?
	if(axisLabel){
		TmpTxt[0] = 0;
		axisLabel->Command(CMD_GETTEXT, TmpTxt, 0L);
		Dlg->SetText(131,TmpTxt);
		old_Label = strdup(TmpTxt);
		if(axisLabel->Id == GO_MLABEL) Dlg->Activate(131, false);
		}
	else Dlg->SetText(131, 0L);
	//remember: any updated values ?
	Dlg->GetValue(110, &old_x1);		Dlg->GetValue(112, &old_x2);
	Dlg->GetValue(115, &old_y1);		Dlg->GetValue(117, &old_y2);
	switch(type) {
	case 1:		type_txt = (char*)(&"X-a");		break;
	case 2:		type_txt = (char*)(&"Y-a");		break;
	case 3:		type_txt = (char*)(&"Z-a");		break;
	default:	type_txt = (char*)(&"A");		break;
		}
	//angular radial axis specials
	if(axis->flags & AXIS_ANGULAR){
		Dlg->SetText(305, "set direction cw");
		type_txt = (char*)(&"angular a");
		}
	if(axis->flags & AXIS_RADIAL) type_txt = (char*)(&"radial a");
	//save old axis definition
	memcpy(&old_a, axis, sizeof(AxisDEF));
	Dlg->GetValue(101, &old_a.min);			Dlg->GetValue(103, &old_a.max);
	Dlg->GetValue(110, &old_a.loc[0].fx);	Dlg->GetValue(112, &old_a.loc[1].fx);
	Dlg->GetValue(115, &old_a.loc[0].fy);	Dlg->GetValue(117, &old_a.loc[1].fy);
	Dlg->GetValue(151, &old_a.loc[0].fz);	Dlg->GetValue(153, &old_a.loc[1].fz);
	Dlg->GetValue(182, &old_a.Center.fx);	Dlg->GetValue(185, &old_a.Center.fy);
	Dlg->GetValue(188, &old_a.Radius);
	memcpy(&new_a, &old_a, sizeof(AxisDEF));
	sprintf(TmpTxt, "%sxis properties", type_txt);
	hDlg = CreateDlgWnd(TmpTxt, 50, 50, 436, 384, Dlg, 0x0L);
	switch(axis->flags & 0x70) {
		case AXIS_LEFT: 
		case AXIS_RIGHT:
			Dlg->Activate(110, false);			Dlg->Activate(112, false);
			break;
		case AXIS_TOP:
		case AXIS_BOTTOM:
			Dlg->Activate(115, false);			Dlg->Activate(117, false);
			break;
			}
	do{
		if(upd_brk) {
			Dlg->ShowItem(453, cbrk > 0);
			sprintf(TmpTxt,"break # %d/%d", cbrk+1, nbrk+1);
			Dlg->SetText(451, TmpTxt);
			upd_brk = false;
			}
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 0:							//lost focus ?
			if(bContinue) res = -1;
			ShowDlgWnd(hDlg);
			break;
		case -1:
			bContinue = false;
			break;
		case 51:
			if(Dlg->GetCheck(51)) {
				Dlg->Activate(101, false);		Dlg->Activate(103, false);
				}
			else {
				Dlg->Activate(101, true);		Dlg->Activate(103, true);
				}
			res = -1;
			break;
		case 105:	case 106:	case 107:	case 108:		//axis left | right | top | bottom
			if(Dlg->GetCheck(105) || Dlg->GetCheck(106)) {
				Dlg->Activate(110, false);			Dlg->Activate(112, false);
				}
			else {
				Dlg->Activate(110, true);			Dlg->Activate(112, true);
				}
			if(Dlg->GetCheck(107) || Dlg->GetCheck(108)) {
				Dlg->Activate(115, false);			Dlg->Activate(117, false);
				}
			else {
				Dlg->Activate(115, true);			Dlg->Activate(117, true);
				}
			res = -1;
			break;
		case 301:	case 302:	case 303:	case 304:		//transform radiobuttons
			new_a.flags &= ~0x7000L;
			if(res == 302) new_a.flags |= AXIS_LOG;
			else if(res == 303) new_a.flags |= AXIS_RECI;
			else if(res == 304) new_a.flags |= AXIS_SQR;
			res = -1;
			break;
		case 200:	case 201:	case 202:
			ttmpl = res;
			Dlg->Activate(251, false);	Dlg->Activate(253, false);	Dlg->Activate(255, false);
			res = -1;
			break;
		case 203:
			ttmpl = res;
			Dlg->Activate(251, true);	Dlg->Activate(253, true);	Dlg->Activate(255, true);
			res = -1;
			break;
		case 205:	case 206:
			Dlg->SetCheck(206, 0L, true);
			if (ssTicks()) {
				Dlg->SetCheck(ttmpl = 202, 0L, true);	Dlg->Activate(251, false);
				Dlg->Activate(253, false);	Dlg->Activate(255, false);
				undo_flags |= UNDO_CONTINUE;	res = 1;
				}
			else {
				Dlg->SetCheck(ttmpl, 0L, true);
				res = -1;
				}
			bContinue = true;
			break;
		case 452:			//next break
			if(Dlg->GetValue(455, &tmp) && Dlg->GetValue(457, &tmp2)){
				if(!brks && (brks = (lfPOINT*)calloc(2, sizeof(lfPOINT)))) {
					brks[0].fx = tmp;		brks[0].fy = tmp2;
					cbrk = nbrk = 0;
					}
				if(!brks) return false;		//mem allocation error
				if(cbrk && cbrk >= nbrk) {
					if(tmpbrks = (lfPOINT*)realloc(brks, (cbrk+2)*sizeof(lfPOINT))){
						brks = tmpbrks;
						brks[cbrk].fx = tmp;		brks[cbrk].fy = tmp2;
						brks[cbrk+1].fx = brks[cbrk+1].fy = 0.0;
						}
					else return false;		//mem allocation error
					}
				else {
					brks[cbrk].fx = tmp;		brks[cbrk].fy = tmp2;
					}
				cbrk++;
				}
			if(cbrk>nbrk){
				nbrk = cbrk;
				Dlg->SetText(455,0L);		Dlg->SetText(457,0L);
				}
			else if(nbrk){
				if(brks[cbrk].fx == brks[cbrk].fy && cbrk == nbrk) {
					Dlg->SetText(455,0L);		Dlg->SetText(457,0L);
					}
				else {
					WriteNatFloatToBuff(TmpTxt, brks[cbrk].fx);
					Dlg->SetText(455, TmpTxt+1);
					WriteNatFloatToBuff(TmpTxt, brks[cbrk].fy);
					Dlg->SetText(457, TmpTxt+1);
					}
				}
			bChanged = upd_brk = true;
			res= -1;
			break;
		case 453:			//previous break
			if(cbrk >0){
				if(Dlg->GetValue(455, &tmp) && Dlg->GetValue(457, &tmp2)){
					brks[cbrk].fx = tmp;		brks[cbrk].fy = tmp2;
					}
				else if(cbrk == nbrk)nbrk--;
				cbrk--;
				WriteNatFloatToBuff(TmpTxt, brks[cbrk].fx);
				Dlg->SetText(455, TmpTxt+1);
				WriteNatFloatToBuff(TmpTxt, brks[cbrk].fy);
				Dlg->SetText(457, TmpTxt+1);
				}
			bChanged = upd_brk = true;
			res= -1;
			break;
		case 458:			//delete break;
			if(brks && nbrk > cbrk) {
				for(i = cbrk; i < nbrk; i++) {
					brks[i].fx = brks[i+1].fx;
					brks[i].fy = brks[i+1].fy;
					}
				nbrk--;
				if(brks[cbrk].fx == brks[cbrk].fy && cbrk == nbrk) {
					Dlg->SetText(455,0L);		Dlg->SetText(457,0L);
					}
				else {
					WriteNatFloatToBuff(TmpTxt, brks[cbrk].fx);
					Dlg->SetText(455, TmpTxt+1);
					WriteNatFloatToBuff(TmpTxt, brks[cbrk].fy);
					Dlg->SetText(457, TmpTxt+1);
					}
				}
			else {
				Dlg->SetText(455,0L);		Dlg->SetText(457,0L);
				}
			bChanged = upd_brk = true;
			res = -1;
			break;
			}
		}while (res < 0);
	switch (res) {
	case 1:									//OK pressed
		bModified = true;
		if(names && CurrAxes && somePlots) {			//apply axis to plot ?
			for(i = 0; CurrAxes[i] != this; i++);		//find index 
			OD_axisplot(OD_ACCEPT, 0L, 0L, (anyOutput*) &res, 0L, 0);
			if(somePlots[res] && somePlots[res]->Command(CMD_USEAXIS, &i, 0L))
				undo_flags |= UNDO_CONTINUE;
			}
		if(Dlg->GetValue(455, &tmp) && Dlg->GetValue(457, &tmp2)){
			if(!brks && (brks = (lfPOINT*)calloc(2, sizeof(lfPOINT)))) {
				brks[0].fx = tmp;	brks[0].fy = tmp2;	cbrk = nbrk = 1;
				}
			else if(brks) {
				brks[cbrk].fx = tmp;	brks[cbrk].fy = tmp2;	nbrk++;
				}
			}
		Dlg->GetValue(101, &new_a.min);			Dlg->GetValue(103, &new_a.max);
		Dlg->GetValue(110, &new_a.loc[0].fx);	Dlg->GetValue(112, &new_a.loc[1].fx);
		Dlg->GetValue(115, &new_a.loc[0].fy);	Dlg->GetValue(117, &new_a.loc[1].fy);
		Dlg->GetValue(151, &new_a.loc[0].fz);	Dlg->GetValue(153, &new_a.loc[1].fz);
		Dlg->GetValue(182, &new_a.Center.fx);	Dlg->GetValue(185, &new_a.Center.fy);
		Dlg->GetValue(188, &new_a.Radius);
		new_a.breaks = brks;					new_a.nBreaks = nbrk;
		if(new_a.breaks) SortAxisBreaks(&new_a);
		brks = 0L;	nbrk = 0;
		if(Dlg->GetCheck(51)) {
			if(!(new_a.flags & AXIS_AUTOSCALE)) parent->Command(CMD_MRK_DIRTY, 0L, 0L);
			new_a.flags |= AXIS_AUTOSCALE;
			}
		else new_a.flags &= ~AXIS_AUTOSCALE;
		if(Dlg->GetCheck(201)) new_a.flags |= AXIS_AUTOTICK;
		else new_a.flags &= ~AXIS_AUTOTICK;
		if(Dlg->GetCheck(200)) new_a.flags &= ~0x03;
		if(Dlg->GetCheck(305)) new_a.flags |= AXIS_INVERT;
		else new_a.flags &= ~AXIS_INVERT;
		new_a.flags &= ~0x70;
		if(Dlg->GetCheck(105)) new_a.flags |= AXIS_LEFT;
		else if(Dlg->GetCheck(106)) new_a.flags |= AXIS_RIGHT;
		else if(Dlg->GetCheck(107)) new_a.flags |= AXIS_TOP;
		else if(Dlg->GetCheck(108)) new_a.flags |= AXIS_BOTTOM;
		if(cmpAxisDEF(&old_a, &new_a)) {
			bChanged = true;
			if(axis->flags != new_a.flags) parent->Command(CMD_MRK_DIRTY, 0L, 0L);
			Undo.AxisDef(this, axis, undo_flags);
			memcpy(axis, &new_a, sizeof(AxisDEF));	undo_flags |= UNDO_CONTINUE;
			}
		else if(new_a.breaks) free(new_a.breaks);
		if(axis->nBreaks && Dlg->GetValue(406, &tmp))
			undo_flags = CheckNewFloat(&brkgap, brkgap, tmp, this, undo_flags);
		if(axis->nBreaks && Dlg->GetValue(409, &tmp))
			undo_flags = CheckNewFloat(&brksymsize, brksymsize, tmp, this, undo_flags);
		if(Dlg->GetCheck(402)) i = 2;
		else if(Dlg->GetCheck(403)) i = 3;
		else if(Dlg->GetCheck(404)) i = 4;
		else i = 0;
		if(axis->nBreaks) undo_flags = CheckNewInt(&brksym, brksym, i, this, undo_flags);
		if(Dlg->GetColor(125, &new_color) && new_color != colAxis) {
			undo_flags = CheckNewDword(&colAxis, colAxis, new_color, this, undo_flags);
			if ((axis->flags & AXIS_ANGULAR) || (axis->flags & AXIS_RADIAL)) {
				Undo.ValDword(this, &GridLine.color, undo_flags);
				GridLine.color = new_color;
				}
			if(Ticks || axisLabel) {
				SavVarInit();
				if(axisLabel){
					axisLabel->FileIO(SAVE_VARS);
					axisLabel->SetColor(COL_TEXT, colAxis);
					}
				if(Ticks) for(i = 0; i < NumTicks; i++)  if(Ticks[i]){
					Ticks[i]->FileIO(SAVE_VARS);
					Ticks[i]->SetColor(COL_AXIS, colAxis);
					}
				sv_ptr = SavVarFetch();
				Undo.SavVarBlock(this, &sv_ptr, undo_flags);
				}
			}
		if(Dlg->GetValue(122, &tmp)) 
			undo_flags = CheckNewFloat(&sizAxLine, sizAxLine, tmp, this, undo_flags);
		if(Dlg->GetText(131, TmpTxt) && TmpTxt[0]) {
			if(old_Label && strcmp(old_Label,TmpTxt) && axisLabel->Id == GO_LABEL){
				lb_def = ((Label*)axisLabel)->GetTextDef();
				Undo.String(axisLabel, &lb_def->text, undo_flags);
				if(lb_def->text) free(lb_def->text);
				lb_def->text = strdup(TmpTxt);		undo_flags |= UNDO_CONTINUE;
				}
			else if(!axisLabel) {
				label_def.ColTxt = colAxis;				label_def.ColBg = 0x00ffffffL;
				label_def.fSize = defs.GetSize(SIZE_TICK_LABELS)*1.2;
				label_def.RotBL = fabs(si)>0.80 ? 90.0 : 0.0;
				label_def.RotCHAR = 0.0f;				label_def.iSize = 0;
				label_def.Align = TXA_VCENTER | TXA_HCENTER;
				label_def.Mode = TXM_TRANSPARENT;		label_def.Style = TXS_NORMAL;
				label_def.Font = FONT_HELVETICA;		label_def.text = TmpTxt;
				Undo.SetGO(this, &axisLabel, new Label(this, data, 0, 0, &label_def,
					LB_Y_PARENT | LB_X_PARENT), undo_flags);
				undo_flags |= UNDO_CONTINUE;
				}
			}
		else if(axisLabel) {
			Undo.DeleteGO(&axisLabel, undo_flags, 0L);	undo_flags |= UNDO_CONTINUE;
			}
		if((!(axis->flags & 0x03) && Ticks && NumTicks)	|| (Dlg->GetCheck(203)) ||
			((old_a.flags & 0x7000) != (new_a.flags & 0x7000) && (new_a.flags & AXIS_AUTOTICK))
			|| ((new_a.flags & AXIS_AUTOTICK) &&(new_a.min != old_a.min || new_a.max != old_a.max))){
			Undo.DropListGO(this, (GraphObj ***)&Ticks, &NumTicks, undo_flags);
			undo_flags |= UNDO_CONTINUE;
			}
		if(Dlg->GetCheck(203)) {			//set ticks manually
			if(!Dlg->GetValue(255, &tmp)) tmp = 0.0;
			i = (int)tmp;
			if(!Dlg->GetValue(251, &tmp)) tmp = axis->Start;
			if(!Dlg->GetValue(253, &tmp2)) tmp2 = axis->Step;
			if(!(axis->flags & 0x03)){
				if(axis->flags & AXIS_ANGULAR) axis->flags |= AXIS_POSTICKS;
				else axis->flags |= AXIS_SYMTICKS;
				}
			axis->flags &= ~AXIS_AUTOTICK;
			ManuTicks(tmp, tmp2, i, axis->flags);
			}
		if(!(new_a.flags & 0x03) && (new_a.flags & AXIS_AUTOTICK)){
			if(new_a.flags & AXIS_ANGULAR) axis->flags |= AXIS_POSTICKS;
			else axis->flags |= AXIS_SYMTICKS;
			}
		if(undo_flags & UNDO_CONTINUE) {
			bRet= true;
			if((axis->flags & AXIS_RADIAL)||(axis->flags & AXIS_ANGULAR))
				parent->Command(CMD_AXIS, this, 0L);
			}
		break;
		}
	if(brks && nbrk) free(brks);
	if(old_Label) free(old_Label);
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(names) {
		for(j = 0; names[j]; j++) if(names[j]) free(names[j]);
		free(names);
		}
	if(somePlots) free(somePlots);
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Graph dialogs
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Graph::AddPlot(int family)
{
	DlgInfo GraphDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 150, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 25, 45, 12},
		{3, 0, 520, ISPARENT | CHECKED, GROUPBOX, (void *)"  select template  ", 5, 10, 140, 95},
		{520, 521, 0, TOUCHEXIT | CHECKED | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 25, 20, 25, 25},
		{521, 522, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 50, 20, 25, 25},
		{522, 523, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 75, 20, 25, 25},
		{523, 524, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 100, 20, 25, 25},
		{524, 525, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 25, 45, 25, 25},
		{525, 526, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 50, 45, 25, 25},
		{526, 528, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 75, 45, 25, 25},
		{528, 529, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 100, 45, 25, 25},
		{529, 530, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 25, 70, 25, 25},
		{530, 540, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 50, 70, 25, 25},
		{540, 541, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 75, 70, 25, 25},
		{541, 0, 0, LASTOBJ | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 100, 70, 25, 25}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, res, cSel = 520;
	bool bRet = false;
	Plot *p;

	switch(type) {
	case GT_STANDARD:
		break;
	case GT_POLARPLOT:
		for(i = 0; i < NumPlots; i++) {
			if(Plots[i] && Plots[i]->Id == GO_POLARPLOT) {
				if (((PolarPlot*)Plots[i])->AddPlot()) 
					return Command(CMD_REDRAW, 0L, 0L);
				}
			}
		return false;
	default:
		InfoBox("Don\'t know how to\nadd a plot to the\ncurrent graph.");
		return false;
		}
	Dlg = new DlgRoot(GraphDlg);
	hDlg = CreateDlgWnd("Add Plot", 50, 50, 410, 240, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 520:	case 521:	case 522:	case 523:	case 524:
		case 525:	case 526:	case 528:	case 529:	case 530:
		case 540:	case 541:
			if(res == cSel) res = 1;
			else {
				cSel = res;				res = -1;
				}
			break;
			}
		}while (res < 0);
	if(res == 1){						//OK pressed
		if(Dlg->GetCheck(524)) p = new BubblePlot(this, data);
		else if(Dlg->GetCheck(525)) p = new BoxPlot(this, data);
		else if(Dlg->GetCheck(521)) p = new PlotScatt(this, data, 0x03);
		else if(Dlg->GetCheck(522)) p = new PlotScatt(this, data, 0x08);
		else if(Dlg->GetCheck(523)) p = new PlotScatt(this, data, 0x04);
		else if(Dlg->GetCheck(526)) p = new Regression(this, data);
		else if(Dlg->GetCheck(528)) p = new DensDisp(this, data);
		else if(Dlg->GetCheck(529)) p = new Function(this, data);
		else if(Dlg->GetCheck(530)) p = new FitFunc(this, data);
		else if(Dlg->GetCheck(540)) p = new StackBar(this, data);
		else if(Dlg->GetCheck(541)) p = new StackPG(this, data);
		else p = new PlotScatt(this, data, 0x01);
		if(p && p->PropertyDlg()) {
			if(!Command(CMD_DROP_PLOT, p, (anyOutput *)NULL)) delete p;
			else bRet = true;
			}
		else if(p) delete p;
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

bool
Graph::PropertyDlg()
{
	TabSHEET tab1 = {0, 22, 10, "Data"};
	TabSHEET tab2 = {22, 62, 10, "Placement"};
	TabSHEET tab3 = {62, 87, 10, "Axes"};
	TabSHEET tab_A = {0, 27, 10, "only Y"};
	TabSHEET tab_B = {27, 65, 10, "XY values"};
	TabSHEET tab_C = {65, 104, 10, "X, many Y"};
	TabSHEET tab_D = {104, 147, 10, "XYZ values"};
	DlgInfo GraphDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 170, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 170, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{4, 5, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 157, 122},
		{5, 6, 200, ISPARENT, SHEET, &tab2, 5, 10, 157, 122},
		{6, 7, 300, ISPARENT, SHEET, &tab3, 5, 10, 157, 122},
		{100, 101, 0, 0x0L, LTEXT, (void*)"arrangement of data: select plot", 10, 25, 60, 8},
		{101, 102, 500, TOUCHEXIT | ISPARENT, SHEET, &tab_A, 10, 37, 147, 88},
		{102, 103, 520, TOUCHEXIT | ISPARENT | CHECKED, SHEET, &tab_B, 10, 37, 147, 90},
		{103, 104, 540, TOUCHEXIT | ISPARENT, SHEET, &tab_C, 10, 37, 147, 88},
		{104, 0, 560, TOUCHEXIT | ISPARENT, SHEET, &tab_D, 10, 37, 147, 88},
		{200, 201, 0, 0x0L, LTEXT, (void*)"bounding rectangle (relative to page)", 10, 35, 60, 8},
		{201, 202, 0, 0x0L, RTEXT, (void*)"upper left corner x", 5, 47, 58, 8},
		{202, 203, 0, 0x0L, EDVAL1, &GRect.Xmin, 64, 47, 30, 10},
		{203, 204, 0, 0x0L, RTEXT, (void*)"y", 95, 47, 10, 8},
		{204, 205, 0, 0x0L, EDVAL1, &GRect.Ymin, 107, 47, 30, 10},
		{205, 206, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 140, 47, 20, 8},
		{206, 207, 0, 0x0L, RTEXT, (void*)"lower right x", 5, 59, 58, 8},
		{207, 208, 0, 0x0L, EDVAL1, &GRect.Xmax, 64, 59, 30, 10},
		{208, 209, 0, 0x0L, RTEXT, (void*)"y", 95, 59, 10, 8},
		{209, 210, 0, 0x0L, EDVAL1, &GRect.Ymax, 107, 59, 30, 10},
		{210, 211, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 140, 59, 20, 8},
		{211, 212, 0, 0x0L, LTEXT, (void*)"plotting rectangle (relative to bounding rectangle)", 10, 84, 60, 8},
		{212, 213, 0, 0x0L, RTEXT, (void*)"upper left corner x", 5, 96, 58, 8},
		{213, 214, 0, 0x0L, EDVAL1, &DRect.Xmin, 64, 96, 30, 10},
		{214, 215, 0, 0x0L, RTEXT, (void*)"y", 95, 96, 10, 8},
		{215, 216, 0, 0x0L, EDVAL1, &DRect.Ymin, 107, 96, 30, 10},
		{216, 217, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 140, 96, 20, 8},
		{217, 218, 0, 0x0L, RTEXT, (void*)"lower right x", 5, 108, 58, 8},
		{218, 219, 0, 0x0L, EDVAL1, &DRect.Xmax, 64, 108, 30, 10},
		{219, 220, 0, 0x0L, RTEXT, (void*)"y", 95, 108, 10, 8},
		{220, 221, 0, 0x0L, EDVAL1, &DRect.Ymax, 107, 108, 30, 10},
		{221, 0, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 140, 108, 20, 8},
		{300, 301, 0, 0x0L, LTEXT, (void*)"select template:", 20, 30, 60, 8},
		{301, 400, 310, CHECKED | ISPARENT, GROUP, 0L, 0, 0, 0, 0,},
		{310, 311, 0, TOUCHEXIT | CHECKED | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl), 20, 42, 25, 25},
		{311, 312, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl), 45, 42, 25, 25},
		{312, 313, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl), 70, 42, 25, 25},
		{313, 314, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl), 95, 42, 25, 25},
		{314, 315, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl), 120, 42, 25, 25},
		{315, 316, 0, CHECKED | TOUCHEXIT, RADIO1, (void*)"ticks outside", 12, 85, 40, 8},
		{316, 317, 0, TOUCHEXIT, RADIO1, (void*)"ticks inside", 12, 93, 40, 8},
		{317, 318, 0, TOUCHEXIT, RADIO1, (void*)"ticks symmetrical", 12, 101, 40, 8},
		{318, 319, 0, TOUCHEXIT, CHECKBOX, (void*)"horizontal grid lines", 80, 85, 40, 8},
		{319, 0, 0, TOUCHEXIT, CHECKBOX, (void*)"vertical grid lines", 80, 93, 40, 8},
		{400, 0, 410, HIDDEN | CHECKED | ISPARENT, GROUP, 0L, 0, 0, 0, 0,},
		{410, 411, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl3D), 20, 42, 25, 25},
		{411, 412, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl3D), 45, 42, 25, 25},
		{412, 0, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_AxisTempl3D), 70, 42, 25, 25},
		{500, 501, 0, TOUCHEXIT | CHECKED | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 25, 60, 25, 25},
		{501, 502, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 50, 60, 25, 25},
		{502, 503, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 75, 60, 25, 25},
		{503, 504, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 25, 85, 25, 25},
		{504, 0, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 50, 85, 25, 25},
		{520, 521, 0, TOUCHEXIT | CHECKED | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 20, 50, 25, 25},
		{521, 522, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 45, 50, 25, 25},
		{522, 523, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 70, 50, 25, 25},
		{523, 524, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 95, 50, 25, 25},
		{524, 525, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 120, 50, 25, 25},
		{525, 526, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 20, 75, 25, 25},
		{526, 527, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 45, 75, 25, 25},
		{527, 528, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 70, 75, 25, 25},
		{528, 529, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 95, 75, 25, 25},
		{529, 530, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 120, 75, 25, 25},
		{530, 0, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 20, 100, 25, 25},
		{540, 541, 0, TOUCHEXIT | CHECKED | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 20, 60, 25, 25},
		{541, 542, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 45, 60, 25, 25},
		{542, 543, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 70, 60, 25, 25},
		{543, 544, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 95, 60, 25, 25},
		{544, 0, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 120, 60, 25, 25},
		{560, 561, 0, TOUCHEXIT | CHECKED | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 25, 60, 25, 25},
		{561, 562, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 50, 60, 25, 25},
		{562, 563, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 75, 60, 25, 25},
		{563, 0, 0, LASTOBJ | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)OD_PlotTempl, 100, 60, 25, 25}};
	DlgRoot *Dlg;
	GraphObj *p;
	void *hDlg;
	int i, res, selPlt = 520, selAxis = 310;
	bool bRet, bContinue;
	fRECT rc1, rc2;

	ODtickstyle = tickstyle;
	AxisTempl = 0;
	if(!parent) return false;
	Dlg = new DlgRoot(GraphDlg);
	Dlg->SetCheck(410 + AxisTempl3D, 0L, true);
	if(parent->Id != GO_PAGE) {
		Dlg->Activate(202, false);	Dlg->Activate(204, false);
		}
	hDlg = CreateDlgWnd("Create graph", 50, 50, 450, 300, Dlg, 0x0L);
	bContinue = false;
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		bRet = false;
		switch(res) {
		case 0:
			if(bContinue) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 101:
			for(i = 500; i <= 504; i++) if(Dlg->GetCheck(i))selPlt = i;
			Dlg->ShowItem(301, true);	Dlg->ShowItem(400, false);
			res = -1;
			break;
		case 102:
			for(i = 520; i <= 530; i++) if(Dlg->GetCheck(i))selPlt = i;
			Dlg->ShowItem(301, true);	Dlg->ShowItem(400, false);
			res = -1;
			break;
		case 103:
			for(i = 540; i <= 544; i++) if(Dlg->GetCheck(i))selPlt = i;
			Dlg->ShowItem(301, true);	Dlg->ShowItem(400, false);
			res = -1;
			break;
		case 104:
			for(i = 560; i <= 563; i++) if(Dlg->GetCheck(i))selPlt = i;
			Dlg->ShowItem(301, false);	Dlg->ShowItem(400, true);
			res = -1;
			break;
		case 310:	case 311:	case 312:	case 313:	case 314:
			AxisTempl = res-310;
			if(res == selAxis) Dlg->SetCheck(4, 0L, true);
			selAxis = res;
			res = -1;
			break;
		case 315:	case 316:	case 317:	//tick style
			tickstyle = res -315;
		case 318:	case 319:				//horizontal or vertical grid
			tickstyle &= ~0x300;
			if(Dlg->GetCheck(318)) tickstyle |= 0x200;
			if(Dlg->GetCheck(319)) tickstyle |= 0x100;
			ODtickstyle = tickstyle;
			Dlg->DoPlot(0L);
			res = -1;
			break;
		case 410:	case 411:	case 412:	//axis templates
			AxisTempl3D = res-410;
			res = -1;
			break;
		case 500:	case 501:	case 502:	case 503:
		case 504:
		case 520:	case 521:	case 522:	case 523:
		case 524:	case 525:	case 526:	case 527:
		case 528:	case 529:	case 530:
		case 540:	case 541:	case 542:	case 543:
		case 544:
		case 560:	case 561:	case 562:	case 563:
			if(res != selPlt) {
				selPlt = res;
				res = -1;
				break;
				}
			//double click means select: continue as if OK
			res = 1;
		case 1:
			if(!Dlg->GetCheck(4)) {
				Dlg->SetCheck(4, 0L, true);
				res = -1;
				break;
				}
			memcpy(&rc1, &GRect, sizeof(fRECT));
			memcpy(&rc2, &DRect, sizeof(fRECT));
			Dlg->GetValue(202, &rc1.Xmin);			Dlg->GetValue(204, &rc1.Ymin);
			Dlg->GetValue(207, &rc1.Xmax);			Dlg->GetValue(209, &rc1.Ymax);
			Dlg->GetValue(213, &rc2.Xmin);			Dlg->GetValue(215, &rc2.Ymin);
			Dlg->GetValue(218, &rc2.Xmax);			Dlg->GetValue(220, &rc2.Ymax);
			if(rc1.Xmin < 0.0 || rc1.Xmax < 0.0 || rc1.Ymin < 0.0 || 
				rc1.Ymax < 0.0 || rc2.Xmin < 0.0 || rc2.Xmax < 0.0 || 
				rc2.Ymin < 0.0 || rc2.Ymax < 0.0) {
				ErrorBox("All values defining\nthe placement of the plot\n"
					"must be positive.");
				res = -1;
				bContinue = true;
				Dlg->SetCheck(5, 0L, true);
				break;
				}
			if(rc2.Xmin > (rc1.Xmax-rc1.Xmin) || rc2.Ymax > (rc1.Ymax-rc1.Ymin) 
				|| (rc2.Xmax-rc2.Xmin) > (rc1.Xmax-rc1.Xmin)
				|| (rc2.Ymax-rc2.Ymin) > (rc1.Ymax-rc1.Ymin)){
				ErrorBox("The plotting rectangle must\nfit inside the\n"
					"bounding rectangle.");
				res = -1;
				bContinue = true;
				Dlg->SetCheck(5, 0L, true);
				break;
				}
			memcpy(&GRect, &rc1, sizeof(fRECT));
			memcpy(&DRect, &rc2, sizeof(fRECT));
			p = 0L;
			if(Dlg->GetCheck(101)) {
				if(Dlg->GetCheck(500))p = new PieChart(this, data);
				else if(Dlg->GetCheck(501))p = new RingChart(this, data);
				else if(Dlg->GetCheck(502))p = new StarChart(this, data);
				else if(Dlg->GetCheck(503))p = new BarChart(this, data);
				else if(Dlg->GetCheck(504))p = new GroupBars(this, data);
				}
			else if(Dlg->GetCheck(102)){
				if(Dlg->GetCheck(524)) p = new BubblePlot(this, data);
				else if(Dlg->GetCheck(525)) p = new BoxPlot(this, data);
				else if(Dlg->GetCheck(521)) p = new PlotScatt(this, data, 0x03);
				else if(Dlg->GetCheck(522)) p = new PlotScatt(this, data, 0x08);
				else if(Dlg->GetCheck(523)) p = new PlotScatt(this, data, 0x04);
				else if(Dlg->GetCheck(526)) p = new Regression(this, data);
				else if(Dlg->GetCheck(527)) p = new PolarPlot(this, data);
				else if(Dlg->GetCheck(528)) p = new DensDisp(this, data);
				else if(Dlg->GetCheck(529)) p = new Function(this, data);
				else if(Dlg->GetCheck(530)) p = new FitFunc(this, data);
				else p = new PlotScatt(this, data, 0x01);
				}
			else if(Dlg->GetCheck(103)) {
				if(Dlg->GetCheck(540)) p = new StackBar(this, data);
				else if(Dlg->GetCheck(542)) p = new Waterfall(this, data);
				else if(Dlg->GetCheck(543)) p = new Chart25D(this, data, 0L);
				else if(Dlg->GetCheck(544)) p = new Ribbon25D(this, data, 0L);
				else p = new StackPG(this, data);
				}
			else if(Dlg->GetCheck(104)) {
				if(Dlg->GetCheck(560)) p = new Plot3D(this, data, 0x1001);
				else if(Dlg->GetCheck(561)) p = new Plot3D(this, data, 0x1002);
				else if(Dlg->GetCheck(562)) p = new Plot3D(this, data, 0x1004);
				else if(Dlg->GetCheck(563)) p = new BubblePlot3D(this, data);
				}
			if(p && p->PropertyDlg()) {
				if(!Command(CMD_DROP_PLOT, p, 0L)) DeleteGO(p);
				else bRet = true;
				}
			else if(p) {
				Dlg->SetCheck(410 + AxisTempl3D, 0L, true);
				DeleteGO(p);		Dlg->DoPlot(0L);			ShowDlgWnd(hDlg);
				}
			if(!bRet) {
				res = -1;
				//we might have lost the focus
				bContinue = true;
				}
			break;
			}
		}while(res <0);
	if(!bRet) parent->Command(CMD_DELOBJ, this, NULL);
	else Command(CMD_SET_DATAOBJ, (void*)data, 0L);
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

bool
Graph::Configure()
{
	TabSHEET tab1 = {0, 28, 10, "Colors"};
	TabSHEET tab2 = {28, 68, 10, "Placement"};
	DlgInfo GraphDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 170, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 170, 25, 45, 12},
		{3, 4, 0, 0x0L, PUSHBUTTON, (void*)"Add Plot", 170, 45, 45, 12},
		{4, 13, 0, 0x0L, PUSHBUTTON, (void*)"Add Axis", 170, 60, 45, 12},
		{13, 50, 14, ISPARENT | CHECKED, GROUP, 0L, 138, 40, 55, 12},
		{14, 15, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 155, 120},
		{15, 0, 200, ISPARENT, SHEET, &tab2, 5, 10, 155, 120},
		{50, 0, 600, ISPARENT | CHECKED | HIDDEN, GROUP, 0L, 0, 0, 0, 0},
		{100, 101, 0, 0x0L, LTEXT, (void*)"bounding rectangle", 20, 30, 60, 8},
		{101, 102, 0, 0x0L, RTEXT, (void*)"fill color", 15, 42, 58, 8},
		{102, 103, 0, TOUCHEXIT | OWNDIALOG, COLBUTTON, (void *)ColGR, 74, 42, 25, 10},
		{103, 104, 0, 0x0L, RTEXT, (void*)"outline color", 15, 54, 58, 8},
		{104, 105, 0, TOUCHEXIT | OWNDIALOG, COLBUTTON, (void *)ColGRL, 74, 54, 25, 10},
		{105, 106, 0, 0x0L, LTEXT, (void*)"plotting rectangle", 20, 68, 60, 8},
		{106, 107, 0, 0x0L, RTEXT, (void*)"fill color", 15, 80, 58, 8},
		{107, 108, 0, TOUCHEXIT | OWNDIALOG, COLBUTTON, (void *)ColDR, 74, 80, 25, 10},
		{108, 109, 0, 0x0L, LTEXT, (void*)"axes, ticks, and axis labels", 20, 94, 60, 8},
		{109, 110, 0, 0x0L, RTEXT, (void*)"axis color", 15, 106, 58, 8},
		{110, 0, 0, TOUCHEXIT | OWNDIALOG, COLBUTTON, (void *)ColAX, 74, 106, 25, 10},
		{200, 201, 0, 0x0L, LTEXT, (void*)"bounding rectangle (relative to page)", 10, 35, 60, 8},
		{201, 202, 0, 0x0L, RTEXT, (void*)"upper left corner x", 5, 47, 58, 8},
		{202, 203, 0, 0x0L, EDVAL1, &GRect.Xmin, 64, 47, 30, 10},
		{203, 204, 0, 0x0L, RTEXT, (void*)"y", 95, 47, 10, 8},
		{204, 205, 0, 0x0L, EDVAL1, &GRect.Ymin, 107, 47, 30, 10},
		{205, 206, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 140, 47, 20, 8},
		{206, 207, 0, 0x0L, RTEXT, (void*)"lower right x", 5, 59, 58, 8},
		{207, 208, 0, 0x0L, EDVAL1, &GRect.Xmax, 64, 59, 30, 10},
		{208, 209, 0, 0x0L, RTEXT, (void*)"y", 95, 59, 10, 8},
		{209, 210, 0, 0x0L, EDVAL1, &GRect.Ymax, 107, 59, 30, 10},
		{210, 211, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 140, 59, 20, 8},
		{211, 212, 0, 0x0L, LTEXT, (void*)"plotting rectangle (relative to bounding rectangle)", 10, 84, 60, 8},
		{212, 213, 0, 0x0L, RTEXT, (void*)"upper left corner x", 5, 96, 58, 8},
		{213, 214, 0, 0x0L, EDVAL1, &DRect.Xmin, 64, 96, 30, 10},
		{214, 215, 0, 0x0L, RTEXT, (void*)"y", 95, 96, 10, 8},
		{215, 216, 0, 0x0L, EDVAL1, &DRect.Ymin, 107, 96, 30, 10},
		{216, 217, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 140, 96, 20, 8},
		{217, 218, 0, 0x0L, RTEXT, (void*)"lower right x", 5, 108, 58, 8},
		{218, 219, 0, 0x0L, EDVAL1, &DRect.Xmax, 64, 108, 30, 10},
		{219, 220, 0, 0x0L, RTEXT, (void*)"y", 95, 108, 10, 8},
		{220, 221, 0, 0x0L, EDVAL1, &DRect.Ymax, 107, 108, 30, 10},
		{221, 0, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 140, 108, 20, 8},
		{600, 601, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 170, 85, 15, 15},
		{601, 602, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 190, 85, 15, 15},
		{602, 603, 0, TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 190, 100, 15, 15},
		{603, 0, 0, LASTOBJ | TOUCHEXIT, ODBUTTON, (void*)OD_DrawOrder, 170, 100, 15, 15}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, res, undo_level = *Undo.pcb;
	DWORD undo_flags = 0, tmpcol;
	bool bRet = false, bContinue = false;
	fRECT o_gr, n_gr, o_dr, n_dr;

	if(!(Dlg = new DlgRoot(GraphDlg)))return false;
	Dlg->GetValue(202, &o_gr.Xmin);			Dlg->GetValue(204, &o_gr.Ymin);
	Dlg->GetValue(207, &o_gr.Xmax);			Dlg->GetValue(209, &o_gr.Ymax);
	Dlg->GetValue(213, &o_dr.Xmin);			Dlg->GetValue(215, &o_dr.Ymin);
	Dlg->GetValue(218, &o_dr.Xmax);			Dlg->GetValue(220, &o_dr.Ymax);
	if(parent && parent->Id == GO_PAGE) Dlg->ShowItem(50, true);
	hDlg = CreateDlgWnd("Graph properties", 50, 50, 450, 300, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = ExecDrawOrderButt(parent, this, Dlg->GetResult());
		switch(res) {
		case 0:
			if(bContinue) res = -1;
			break;
		case -1:
			bContinue = false;
			break;
		case 102:	case 104:	case 107:	case 110:
			res = -1;
			break;
		case 1:
			Dlg->GetValue(202, &n_gr.Xmin);			Dlg->GetValue(204, &n_gr.Ymin);
			Dlg->GetValue(207, &n_gr.Xmax);			Dlg->GetValue(209, &n_gr.Ymax);
			Dlg->GetValue(213, &n_dr.Xmin);			Dlg->GetValue(215, &n_dr.Ymin);
			Dlg->GetValue(218, &n_dr.Xmax);			Dlg->GetValue(220, &n_dr.Ymax);
			if(n_gr.Xmin < 0.0 || n_gr.Xmax < 0.0 || n_gr.Ymin < 0.0 || 
				n_gr.Ymax < 0.0 || n_dr.Xmin < 0.0 || n_dr.Xmax < 0.0 || 
				n_dr.Ymin < 0.0 || n_dr.Ymax < 0.0) {
				ErrorBox("All values defining\nthe placement of the plot\n"
					"must be positive.");
				res = -1;
				bContinue = true;
				Dlg->SetCheck(5, 0L, true);
				break;
				}
			if(n_dr.Xmin > (n_gr.Xmax-n_gr.Xmin) || n_dr.Ymax > (n_gr.Ymax-n_gr.Ymin) 
				|| (n_dr.Xmax-n_dr.Xmin) > (n_gr.Xmax-n_gr.Xmin)
				|| (n_dr.Ymax-n_dr.Ymin) > (n_gr.Ymax-n_gr.Ymin)){
				ErrorBox("The plotting rectangle must\nfit inside the\n"
					"bounding rectangle.");
				res = -1;
				bContinue = true;
				Dlg->SetCheck(5, 0L, true);
				break;
				}
			bRet = true;
			break;
		case 3:
			if(bRet = Command(CMD_ADDPLOT, 0L, 0L)) break;
		case 4:
			if(res == 4 && (bRet = Command(CMD_ADDAXIS, 0L, 0L))) break;
			bContinue = true;
			res = -1;
			}
		}while(res <0);
	if(res == 1 && bRet) {
		if(n_gr.Xmin != o_gr.Xmin || n_gr.Xmax != o_gr.Xmax ||
			n_gr.Ymin != o_gr.Ymin || n_gr.Ymax != o_gr.Ymax ||
			n_dr.Xmin != o_dr.Xmin || n_dr.Xmax != o_dr.Xmax ||
			n_dr.Ymin != o_dr.Ymin || n_dr.Ymax != o_dr.Ymax){
			Command(CMD_SAVEPOS, 0L, 0L);
			memcpy(&GRect, &n_gr, sizeof(fRECT));
			memcpy(&DRect, &n_dr, sizeof(fRECT));
			undo_flags |= UNDO_CONTINUE;
			}
		if(Dlg->GetColor(102, &tmpcol))
			undo_flags = CheckNewDword(&ColGR, ColGR, tmpcol, this, undo_flags);
		if(Dlg->GetColor(104, &tmpcol))
			undo_flags = CheckNewDword(&ColGRL, ColGRL, tmpcol, this, undo_flags);
		if(Dlg->GetColor(107, &tmpcol))
			undo_flags = CheckNewDword(&ColDR, ColDR, tmpcol, this, undo_flags);
		if(Dlg->GetColor(110, &tmpcol) && tmpcol != ColAX) {
			undo_flags = CheckNewDword(&ColAX, ColAX, tmpcol, this, undo_flags);
			if(Axes) for(i = 0; i < NumAxes; i++)
				if(Axes[i]) Axes[i]->SetColor(COL_AXIS | UNDO_STORESET, ColAX);
			if(Plots && NumPlots && Plots[0] && Plots[0]->Id == GO_PLOT3D) 
				Plots[0]->SetColor(COL_AXIS | UNDO_STORESET, ColAX);
			}
		}
	else if(res == 2) {
		if(*Undo.pcb > undo_level) {	//restore plot order
			while(*Undo.pcb > undo_level)	Undo.Restore(false, 0L);
			bRet = true;
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

bool
Graph::AddAxis()
{
	TabSHEET tab1 = {0, 25, 10, "Axis"};
	TabSHEET tab2 = {25, 52, 10, "Style"};
	TabSHEET tab3 = {52, 78, 10, "Plots"};
	AxisDEF axis;
	double sizAxLine = defs.GetSize(SIZE_AXIS_LINE);
	DWORD colAxis = ColAX;
	DlgInfo NewAxisDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 148, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 148, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, NULL, 138, 40, 55, 12},
		{4, 5, 50, TOUCHEXIT | ISPARENT, SHEET, &tab1, 5, 10, 130, 130},
		{5, 6, 200, ISPARENT | CHECKED, SHEET, &tab2, 5, 10, 130, 130},
		{6, 0, 300, ISPARENT, SHEET, &tab3, 5, 10, 130, 130},
		{50, 51, 100, ISPARENT | CHECKED, GROUPBOX, (void*)" scaling ", 10, 30, 120, 36},
		{51, 120, 0, 0x0L, CHECKBOX, (void*)" automatic scaling", 17, 37, 80, 8},
		{100, 101, 0, 0x0L, RTEXT, (void*)"axis from", 10, 51, 35, 8},
		{101, 102, 0, 0x0L, EDVAL1, &y_axis.min, 48, 51, 32, 10},
		{102, 103, 0, 0x0L, CTEXT, (void*)"to", 81, 51, 11, 8},
		{103, 0, 0, 0x0L, EDVAL1, &y_axis.max, 93, 51, 32, 10},
		{120, 0, 121, ISPARENT | CHECKED, GROUPBOX, (void*)" line ", 10, 72, 120, 20},
		{121, 122, 0, 0x0L, RTEXT, (void*)"width", 10, 77, 25, 8},
		{122, 123, 0, 0x0L, EDVAL1, &sizAxLine, 37, 77, 25, 10},
		{123, 124, 0, 0x0L, LTEXT, (void *) Units[defs.cUnits].display, 63, 77, 10, 8},
		{124, 125, 0, 0x0L, RTEXT, (void*)"color", 73, 77, 25, 8},
		{125, 130, 0, OWNDIALOG, COLBUTTON, (void *)colAxis, 100, 77, 25, 10},
		{130, 131, 0, ISPARENT | CHECKED, GROUPBOX, (void*)" axis label ", 10, 98, 120, 20},
		{131, 0, 0, 0x0L, EDTEXT, (void*)0L, 15, 103, 110, 10},
		{200, 201, 0, 0x0L, LTEXT, (void*)"select a template:", 10, 30, 70, 9},
		{201, 202, 0, CHECKED | TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_NewAxisTempl), 20, 42, 25, 25},
		{202, 203, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_NewAxisTempl), 45, 42, 25, 25},
		{203, 204, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_NewAxisTempl), 70, 42, 25, 25},
		{204, 205, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_NewAxisTempl), 95, 42, 25, 25},
		{205, 206, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_NewAxisTempl), 20, 67, 25, 25},
		{206, 207, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_NewAxisTempl), 45, 67, 25, 25},
		{207, 208, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_NewAxisTempl), 70, 67, 25, 25},
		{208, 210, 0, TOUCHEXIT | ISRADIO, ODBUTTON, (void*)(OD_NewAxisTempl), 95, 67, 25, 25},
		{210, 0, 220, ISPARENT | CHECKED, GROUPBOX, (void*)" placement ", 10, 97, 120, 35},
		{220, 221, 0, 0x0L, RTEXT, (void*)"x", 10, 105, 15, 8},
		{221, 222, 0, 0x0L, EDVAL1, &axis.loc[0].fx, 27, 105, 35, 10},
		{222, 223, 0, 0x0L, LTEXT, (void*)"-", 65, 105, 5, 8},
		{223, 224, 0, 0x0L, EDVAL1, &axis.loc[1].fx, 71, 105, 35, 10},
		{224, 225, 0, 0x0L, LTEXT, (void*)Units[units].display, 109, 105, 15, 8},
		{225, 226, 0, 0x0L, RTEXT, (void*)"y", 10, 117, 15, 8},
		{226, 227, 0, 0x0L, EDVAL1, &axis.loc[0].fy, 27, 117, 35, 10},
		{227, 228, 0, 0x0L, LTEXT, (void*)"-", 65, 117, 5, 8},
		{228, 229, 0, 0x0L, EDVAL1, &axis.loc[1].fy, 71, 117, 35, 10},
		{229, 0, 0, 0x0L, LTEXT, (void*)Units[units].display, 109, 117, 15, 8},
		{300, 0, 0, NOSELECT, ODBUTTON, (void*)OD_axisplot, 15, 30, 110, 140},
		{400, 0, 0, LASTOBJ, NONE, 0L, 0, 0, 0, 0}};
	DlgRoot *Dlg;
	void *hDlg;
	int i, j, res, currTempl = 201;
	double vx1, vx2, vy1, vy2, hx1, hx2, hy1, hy2;
	double tlb_dist, tlb_dx, tlb_dy, lb_x, lb_y;
	TextDEF label_def, tlbdef;
	DWORD flags;
	Axis *the_new, **tmpAxes;
	bool bAxis = false, bRet = false;
	char **names;
	GraphObj **somePlots;
	Label *label;

	if(!(names = (char**)calloc(nscp+2, sizeof(char*))))return false;
	if(!(somePlots = (GraphObj**)calloc(nscp+2, sizeof(GraphObj*))))return false;
	if(!Axes) Axes = (Axis**)calloc(2, sizeof(Axis*));
	names[j=0] = strdup("[none]");
	for(i = 0, j = 1; i < nscp; i++) {
		if(Sc_Plots[i] && Sc_Plots[i]->name){
			names[j] = strdup(Sc_Plots[i]->name);
			somePlots[j++] = Sc_Plots[i];
			}
		}
	OD_axisplot(OD_ACCEPT, 0L, 0L, 0L, names, 0);
	axis.loc[0].fx = axis.loc[1].fx = vx1 = vx2 = (DRect.Xmin + DRect.Xmax)/2.0;
	axis.loc[0].fy = vy1 = DRect.Ymin;
	axis.loc[1].fy = vy2 = DRect.Ymax;
	axis.min = y_axis.min;		axis.max = y_axis.max;
	hy1 = hy2 = (DRect.Ymax + DRect.Ymin)/2.0;
	hx1 = DRect.Xmin;			hx2 = DRect.Xmax;
	if(!(Dlg = new DlgRoot(NewAxisDlg)))return false;
	if(type != 1 || !nscp){		//must be standard graph to link to plot
		Dlg->ShowItem(6, false);
		}
	hDlg = CreateDlgWnd("New axis properties", 50, 50, 400, 314, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch (res){
		case 4:											//the axis sheet
			res = -1;
			bAxis = true;
			break;
		case 201:	case 202:	case 203:	case 204:	//axis templates
		case 205:	case 206:	case 207:	case 208:
			if(currTempl > 204) {
				Dlg->GetValue(221, &hx1);			Dlg->GetValue(223, &hx2);
				Dlg->GetValue(226, &hy1);			Dlg->GetValue(228, &hy2);
				}
			else {
				Dlg->GetValue(221, &vx1);			Dlg->GetValue(223, &vx2);
				Dlg->GetValue(226, &vy1);			Dlg->GetValue(228, &vy2);
				}
			if(res > 204) {
				WriteFloatToBuff(TmpTxt, hx1);		Dlg->SetText(221, TmpTxt+1);
				WriteFloatToBuff(TmpTxt, hx2);		Dlg->SetText(223, TmpTxt+1);
				WriteFloatToBuff(TmpTxt, hy1);		Dlg->SetText(226, TmpTxt+1);
				WriteFloatToBuff(TmpTxt, hy2);		Dlg->SetText(228, TmpTxt+1);
				if(! bAxis) {
					WriteFloatToBuff(TmpTxt, x_axis.min);	Dlg->SetText(101, TmpTxt+1);
					WriteFloatToBuff(TmpTxt, x_axis.max);	Dlg->SetText(103, TmpTxt+1);
					}
				}
			else {
				WriteFloatToBuff(TmpTxt, vx1);		Dlg->SetText(221, TmpTxt+1);
				WriteFloatToBuff(TmpTxt, vx2);		Dlg->SetText(223, TmpTxt+1);
				WriteFloatToBuff(TmpTxt, vy1);		Dlg->SetText(226, TmpTxt+1);
				WriteFloatToBuff(TmpTxt, vy2);		Dlg->SetText(228, TmpTxt+1);
				if(! bAxis) {
					WriteFloatToBuff(TmpTxt, y_axis.min);	Dlg->SetText(101, TmpTxt+1);
					WriteFloatToBuff(TmpTxt, y_axis.max);	Dlg->SetText(103, TmpTxt+1);
					}
				}
			currTempl = res;
			Dlg->DoPlot(0L);
			res = -1;
			break;
			}
		}while (res < 0);
	if(res == 1) {
		Dlg->GetValue(122, &sizAxLine);				Dlg->GetColor(125, &colAxis);
		Dlg->GetValue(221, &axis.loc[0].fx);		Dlg->GetValue(223, &axis.loc[1].fx);
		Dlg->GetValue(226, &axis.loc[0].fy);		Dlg->GetValue(228, &axis.loc[1].fy);
		axis.loc[0].fz = axis.loc[1].fz = 0.0;		axis.owner = 0L;
		Dlg->GetValue(101, &axis.min);				Dlg->GetValue(103, &axis.max);
		axis.Start = axis.min;				axis.Center.fx = axis.Center.fy = 0.0;
		axis.nBreaks = 0;			axis.breaks = 0L;		axis.Radius = 0.0;	
		tlb_dist = NiceValue(defs.GetSize(SIZE_AXIS_TICKS));
		tlb_dx = tlb_dy = 0.0;
		tlbdef.ColTxt = colAxis;				tlbdef.ColBg = 0x00ffffffL;
		tlbdef.RotBL = tlbdef.RotCHAR = 0.0f;	tlbdef.fSize = defs.GetSize(SIZE_TICK_LABELS);
		tlbdef.Align = TXA_VCENTER | TXA_HCENTER;
		tlbdef.Style = TXS_NORMAL;				tlbdef.Mode = TXM_TRANSPARENT;
		tlbdef.Font = FONT_HELVETICA;			tlbdef.text = 0L;
		label_def.ColTxt = colAxis;				label_def.ColBg = 0x00ffffffL;
		label_def.fSize = defs.GetSize(SIZE_TICK_LABELS)*1.2f;	label_def.RotBL = 0.0f;
		label_def.RotCHAR = 0.0f;								label_def.iSize = 0;
		label_def.Align = TXA_VTOP | TXA_HCENTER;		label_def.Mode = TXM_TRANSPARENT;
		label_def.Style = TXS_NORMAL;	label_def.Font = FONT_HELVETICA;
		switch (currTempl) {
		default:	flags = AXIS_NEGTICKS;	axis.Step = y_axis.Step;
			tlb_dx = -tlb_dist * 2.0;	tlbdef.Align = TXA_VCENTER | TXA_HRIGHT;
			lb_x = -tlb_dist * 6.0;		lb_y = 0;	label_def.Align = TXA_VBOTTOM | TXA_HCENTER;
			label_def.RotBL = 90.0;
			break;
		case 202:	flags = AXIS_POSTICKS;	axis.Step = y_axis.Step;
			tlb_dx = -tlb_dist;			tlbdef.Align = TXA_VCENTER | TXA_HRIGHT;
			lb_x = -tlb_dist * 4.5;		lb_y = 0;	label_def.Align = TXA_VBOTTOM | TXA_HCENTER;
			label_def.RotBL = 90.0;
			break;
		case 203:	flags = AXIS_POSTICKS;	axis.Step = y_axis.Step;
			tlb_dx = tlb_dist * 2.0;	tlbdef.Align = TXA_VCENTER | TXA_HLEFT;
			lb_x = tlb_dist * 6;		lb_y = 0;	label_def.Align = TXA_VTOP | TXA_HCENTER;
			label_def.RotBL = 90.0;
			break;
		case 204:	flags = AXIS_NEGTICKS;	axis.Step = y_axis.Step;
			tlb_dx = tlb_dist;			tlbdef.Align = TXA_VCENTER | TXA_HLEFT;
			lb_x = tlb_dist * 4.5;		lb_y = 0;	label_def.Align = TXA_VTOP | TXA_HCENTER;
			label_def.RotBL = 90.0;
			break;
		case 205:	flags = AXIS_NEGTICKS;	axis.Step = x_axis.Step;
			tlb_dy = tlb_dist * 2.0;	tlbdef.Align = TXA_VTOP | TXA_HCENTER;
			lb_x = 0;					lb_y = tlb_dist * 4.0;
			break;
		case 206:	flags = AXIS_POSTICKS;	axis.Step = x_axis.Step;
			tlb_dy = tlb_dist;			tlbdef.Align = TXA_VTOP | TXA_HCENTER;
			lb_x = 0;					lb_y = tlb_dist * 3.0;
			break;
		case 207:	flags = AXIS_POSTICKS;	axis.Step = x_axis.Step;
			tlb_dy = -tlb_dist * 2.0;	tlbdef.Align = TXA_VBOTTOM | TXA_HCENTER;
			lb_x = 0;	lb_y = -tlb_dist * 4.0;	label_def.Align = TXA_VBOTTOM | TXA_HCENTER;
			break;
		case 208:	flags = AXIS_NEGTICKS;	axis.Step = x_axis.Step;
			tlb_dy = -tlb_dist;			tlbdef.Align = TXA_VBOTTOM | TXA_HCENTER;
			lb_x = 0;	lb_y = -tlb_dist * 3.0;	label_def.Align = TXA_VBOTTOM | TXA_HCENTER;
			break;
			}
		flags |= AXIS_AUTOTICK;			flags |= AXIS_DEFRECT;
		if(Dlg->GetCheck(51)) flags |= AXIS_AUTOSCALE;
		if(the_new = new Axis(this, data, &axis, flags)){
			the_new->SetSize(SIZE_TLB_YDIST, tlb_dy);	the_new->SetSize(SIZE_TLB_XDIST, tlb_dx); 
			the_new->SetSize(SIZE_AXIS_LINE, sizAxLine);
			the_new->SetColor(COL_AXIS, colAxis);
			the_new->Command(CMD_TLB_TXTDEF, (void*)&tlbdef, 0L);
			the_new->SetSize(SIZE_LB_XDIST, lb_x);		the_new->SetSize(SIZE_LB_YDIST, lb_y); 
			if(Dlg->GetText(131, TmpTxt)) label_def.text = TmpTxt;
			else label_def.text = 0L;
			if(label = new Label(Axes[0], data, (axis.loc[0].fx + axis.loc[1].fx)/2.0,
				(axis.loc[0].fy + axis.loc[1].fy)/2.0, &label_def, 
				label_def.RotBL < 45.0 ? LB_Y_PARENT : LB_X_PARENT)){
				label->SetSize(SIZE_LB_XDIST, lb_x);	label->SetSize(SIZE_LB_YDIST, lb_y); 
				if(the_new->Command(CMD_DROP_LABEL, (void*)label, 0L)) label = 0L;
				else DeleteGO(label);
				}
			for(i = 0; i < NumAxes && Axes[i]; i++);
			if(i < NumAxes) {
				Undo.SetGO(this, (GraphObj**)(&Axes[i]), the_new, 0L);
				bRet = true;
				}
			else {
				if(tmpAxes = (Axis**)calloc(NumAxes+1, sizeof(Axis*))){
					memcpy(tmpAxes, Axes, NumAxes * sizeof(Axis*));
					Undo.ListGOmoved((GraphObj**)Axes, (GraphObj**)tmpAxes, NumAxes);
					Undo.SetGO(this, (GraphObj**)(&tmpAxes[NumAxes]), the_new, 0L);
					free(Axes);			Axes = tmpAxes;
					i = NumAxes++;		bRet = true;
					}
				else delete (the_new);	//very unlikely memory allocation error
				}
			CurrAxes = Axes;
			if(bRet) {
				OD_axisplot(OD_ACCEPT, 0L, 0L, (anyOutput*) &res, 0L, 0);
				if(res && i) somePlots[res]->Command(CMD_USEAXIS, &i, 0L);
				}
			}
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	if(names) {
		for(j = 0; names[j]; j++) if(names[j]) free(names[j]);
		free(names);
		}
	if(somePlots) free(somePlots);
	return bRet;
}

bool
Page::Configure()
{
	TabSHEET tab1 = {0, 50, 10, "Paper Size"};
	DlgInfo PageDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 150, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{4, 0, 100, ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 120, 120},
		{100, 0, 0, LASTOBJ | NOSELECT, ODBUTTON, (void*)OD_paperdef, 15, 30, 110, 140}};
	DlgRoot *Dlg;
	void *hDlg;
	int res;
	bool bRet = false;

	FindPaper(GRect.Xmax - GRect.Xmin, GRect.Ymax -GRect.Ymin, .0001);
	if(!(Dlg = new DlgRoot(PageDlg)))return false;
	hDlg = CreateDlgWnd("Page properties", 50, 50, 450, 300, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		}while(res <0);
	if(res == 1) {
		OD_paperdef(OD_ACCEPT, 0L, 0L, 0L, 0L, 0);
		GRect.Xmin = GRect.Ymin = 0.0;
		GetPaper(&GRect.Xmax, &GRect.Ymax);
		DoPlot(CurrDisp);
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Edit global defaults
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool
Default::PropertyDlg()
{
	TabSHEET tab1 = {0, 25, 10, "Line"};
	TabSHEET tab2 = {25, 60, 10, "Shapes"};
	TabSHEET tab3 = {60, 93, 10, "Dialogs"};
	TabSHEET tab4 = {93, 128, 10, "Internat."};
	char text1[20];
	DlgInfo DefsDlg[] = {
		{1, 2, 0, DEFAULT, PUSHBUTTON, (void*)"OK", 150, 10, 45, 12},
		{2, 3, 0, 0x0L, PUSHBUTTON, (void*)"Cancel", 150, 25, 45, 12},
		{3, 0, 4, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{4, 5, 100, TOUCHEXIT | ISPARENT | CHECKED, SHEET, &tab1, 5, 10, 139, 120},
		{5, 6, 200, TOUCHEXIT | ISPARENT, SHEET, &tab2, 5, 10, 139, 120},
		{6, 7, 300, ISPARENT, SHEET, &tab3, 5, 10, 139, 120},
		{7, 0, 400, ISPARENT, SHEET, &tab4, 5, 10, 139, 120},
		{100, 0, 0, NOSELECT, ODBUTTON, (void*)OD_linedef, 10, 38, 130, 100},
		{200, 0, 0, NOSELECT, ODBUTTON, (void*)OD_filldef, 25, 40, 90, 50},
		{300, 301, 0, 0x0L, RTEXT, (void*)"text size", 20, 30, 38, 8},
		{301, 302, 0, 0x0L, EDTEXT, (void*)text1, 60, 30, 20, 10},
		{302, 0, 0, 0x0L, LTEXT, (void*)"pixel", 82, 30, 20, 8},
		{400, 401, 0, 0x0L, LTEXT, (void*)"edit country specific information", 20, 30, 100, 8},
		{401, 402, 0, 0x0L, RTEXT, (void*)"decimal point", 45, 45, 40, 8},
		{402, 403, 0, 0x0L, EDTEXT, (void*)DecPoint, 90, 45, 10, 10},
		{403, 404, 0, 0x0L, RTEXT, (void*)"column separator", 45, 57, 40, 8},
		{404, 405, 0, 0x0L, EDTEXT, (void*)ColSep, 90, 57, 10, 10},
		{405, 406, 0, 0x0L, RTEXT, (void*)"use units:", 25, 75, 47, 8},
		{406, 0, 420, ISPARENT | CHECKED, GROUP, 0L, 0, 0, 0, 0},
		{420, 421, 0, 0x0L, RADIO1, (void*)Units[0].display, 75, 75, 20, 8},
		{421, 422, 0, 0x0L, RADIO1, (void*)Units[1].display, 75, 83, 20, 8},
		{422, 0, 0, LASTOBJ, RADIO1, (void*)Units[2].display, 75, 91, 20, 8}};
	DlgRoot *Dlg;
	void *hDlg;
	int res, tmpUnits = cUnits;
	bool bRet = false;
	LineDEF LineDef;
	FillDEF FillDef;

	OD_linedef(OD_SETLINE, 0L, 0L, 0L, (void *)GetLine(), 0);
	OD_filldef(OD_SETLINE, 0L, 0L, 0L, (void *)GetOutLine(), 0);
	OD_filldef(OD_SETFILL, 0L, 0L, 0L, (void *)GetFill(), 0);
	sprintf(text1, "%d", dlgtxtheight);
	Dlg = new DlgRoot(DefsDlg);
	switch(dUnits) {
	case 1:		Dlg->SetCheck(421, 0L, true);	break;
	case 2:		Dlg->SetCheck(422, 0L, true);	break;
	default:	Dlg->SetCheck(420, 0L, true);	break;
		}
	hDlg = CreateDlgWnd("Edit Global Preferences", 50, 50, 410, 300, Dlg, 0x0L);
	do{
		LoopDlgWnd();
		res = Dlg->GetResult();
		switch(res) {
		case 4:	case 5:
			res = -1;
			break;
		case 1:
			if(Dlg->GetCheck(421)) dUnits = 1;
			else if(Dlg->GetCheck(422)) dUnits = 2;
			else dUnits = 0;
			}
		}while (res < 0);
	if(res == 1) {
		if(Dlg->GetText(402, TmpTxt))	DecPoint[0] = TmpTxt[0];
		if(Dlg->GetText(404, TmpTxt))	ColSep[0] = TmpTxt[0];
		bRet = true;
		OD_linedef(OD_GETLINE, 0L, 0L, 0L, (void *)&LineDef, 0);
		SetLine(tmpUnits, &LineDef, 0);
		OD_filldef(OD_GETLINE, 0L, 0L, 0L, (void *)&LineDef, 0);
		SetLine(tmpUnits, &LineDef, 2);
		OD_filldef(OD_GETFILL, 0L, 0L, 0L, (void *)&FillDef, 0);
		SetFill(tmpUnits, &FillDef);
		Dlg->GetInt(301, &dlgtxtheight);
		}
	CloseDlgWnd(hDlg);
	delete Dlg;
	return bRet;
}
